using System;
using System.Runtime.InteropServices;

namespace twain
{
	/// <summary>
	/// twait ̊Tv̐łB
	/// </summary>
	public class tw
	{
		
		//
		//ȉ twain.h vȂ̂𔲐
		//
	
		/* There are four containers used for capabilities negotiation:
		*    TWON_ONEVALUE, TWON_RANGE, TWON_ENUMERATION, TWON_ARRAY
		* In each container structure ItemType can be TWTY_INT8, TWTY_INT16, etc.
		* The kind of data stored in the container can be determined by doing
		* DCItemSize[ItemType] where the following is defined in TWAIN glue code:
		*          DCItemSize[]= { sizeof(TW_INT8),
		*                          sizeof(TW_INT16),
		*                          etc.
		*                          sizeof(TW_UINT32) };
		*
		*/
	
		public const ushort TWTY_INT8  = 0x0; /* Means Item is a TW_INT8   */
		public const ushort TWTY_INT16 = 0x1; /* Means Item is a TW_INT16  */
		public const ushort TWTY_INT32 = 0x2; /* Means Item is a TW_INT32  */
	
		public const ushort TWTY_UINT8 = 0x3;  /* Means Item is a TW_UINT8  */
		public const ushort TWTY_UINT16 = 0x4; /* Means Item is a TW_UINT16 */
		public const ushort TWTY_UINT32 = 0x5; /* Means Item is a TW_UINT32 */
	
		public const ushort TWTY_BOOL = 0x6;		/* Means Item is a TW_BOOL   */
	
		public const ushort TWTY_FIX32 = 0x7;	/* Means Item is a TW_FIX32  */
	
		public const ushort TWTY_FRAME = 0x8;	/* Means Item is a TW_FRAME  */
	
		public const ushort TWTY_STR32 = 0x9;	/* Means Item is a TW_STR32  */
		public const ushort TWTY_STR64 = 0xA;	/* Means Item is a TW_STR64  */
		public const ushort TWTY_STR128 = 0xB;	/* Means Item is a TW_STR128 */
		public const ushort TWTY_STR255 = 0xC;	/* Means Item is a TW_STR255 */
		public const ushort TWTY_STR1024 = 0xD;	/* Means Item is a TW_STR1024...added 1.9 */
		public const ushort TWTY_UNI512 = 0xE;	/* Means Item is a TW_UNI512...added 1.9 */
	
		/****************************************************************************
		* Capability Constants                                                     *
		****************************************************************************/
	
		/* ICAP_IMAGEFILEFORMAT values (FF_means File Format)   */
		public const short TWFF_TIFF = 0;		/* Tagged Image File Format     */
		public const short TWFF_PICT = 1;		/* Macintosh PICT               */
		public const short TWFF_BMP = 2;		/* Windows Bitmap               */
		public const short TWFF_XBM = 3;		/* X-Windows Bitmap             */
		public const short TWFF_JFIF = 4;		/* JPEG File Interchange Format */
		public const short TWFF_FPX = 5;		/* Flash Pix                    */
		public const short TWFF_TIFFMULTI = 6;	/* Multi-page tiff file         */
		public const short TWFF_PNG = 7;
		public const short TWFF_SPIFF = 8;
		public const short TWFF_EXIF = 9;
	
		/****************************************************************************
		* Language Constants                                                       *
		****************************************************************************/
		public const short TWLG_JAPANESE = 68;
		public const short TWCY_JAPAN = 81;
	
		/****************************************************************************
		* Messages                                                                 *
		****************************************************************************/
	
		/* All message constants are unique.
		* Messages are grouped according to which DATs they are used with.*/
	
		public const ushort MSG_NULL = 0x0;				/* Used in TW_EVENT structure               */
		public const ushort MSG_CUSTOMBASE = 0x8000;	/* Base of custom messages                  */
	
		/* Generic messages may be used with any of several DATs.                   */
		public const ushort MSG_GET = 0x1;			/* Get one or more values                   */
		public const ushort MSG_GETCURRENT = 0x2;	/* Get current value                        */
		public const ushort MSG_GETDEFAULT = 0x3;	/* Get default (e.g. power up) value        */
		public const ushort MSG_GETFIRST = 0x4;		/* Get first of a series of items, e.g. DSs */
		public const ushort MSG_GETNEXT = 0x5;		/* Iterate through a series of items.       */
		public const ushort MSG_SET = 0x6;			/* Set one or more values                   */
		public const ushort MSG_RESET = 0x7;		/* Set current value to default value       */
		public const ushort MSG_QUERYSUPPORT = 0x8;	/* Get supported operations on the cap.     */
	
		/****************************************************************************
		* TWAIN Version                                                            *
		****************************************************************************/
		public const short TWON_PROTOCOLMINOR = 9;  /* Changed for Version 1.9   */
		public const short TWON_PROTOCOLMAJOR = 1;
		/****************************************************************************
		* Data Groups                                                              *
		****************************************************************************/
	
		/* More Data Groups may be added in the future.
		* Possible candidates include text, vector graphics, sound, etc.
		* NOTE: Data Group constants must be powers of 2 as they are used
		*       as bitflags when Application asks DSM to present a list of DSs.
		*/
	
		public const ushort DG_CONTROL = 0x1;	/* data pertaining to control       */
		public const ushort DG_IMAGE = 0x2;		/* data pertaining to raster images */
		/* Added 1.8 */
		public const ushort DG_AUDIO = 0x4;		/* data pertaining to audio */
	
		/* Return Codes: DSM_Entry and DS_Entry may return any one of these values. */
		public const ushort TWRC_CUSTOMBASE = 0x8000;
	
		public const short TWRC_SUCCESS = 0;
		public const short TWRC_FAILURE = 1;		/* Application may get TW_STATUS for info on failure */
		public const short TWRC_CHECKSTATUS = 2;	/* "tried hard"; get status                  */
		public const short TWRC_CANCEL = 3;
		public const short TWRC_DSEVENT = 4;
		public const short TWRC_NOTDSEVENT = 5;
		public const short TWRC_XFERDONE = 6;
		public const short TWRC_ENDOFLIST = 7;		/* After MSG_GETNEXT if nothing left         */
		public const short TWRC_INFONOTSUPPORTED = 8;
		public const short TWRC_DATANOTAVAILABLE = 9;
	
	
		/****************************************************************************
		* Generic Constants                                                        *
		****************************************************************************/
	
		public const ushort TWON_ARRAY = 3;			/* indicates TW_ARRAY container       */
		public const ushort TWON_ENUMERATION = 4;	/* indicates TW_ENUMERATION container */
		public const ushort TWON_ONEVALUE = 5;		/* indicates TW_ONEVALUE container    */
		public const ushort TWON_RANGE = 6;			/* indicates TW_RANGE container       */
	
		public const ushort TWON_ICONID = 962;		/* res Id of icon used in USERSELECT lbox */
		public const ushort TWON_DSMID = 461;		/* res Id of the DSM version num resource */
		public const ushort TWON_DSMCODEID = 63;		/* res Id of the Mac SM Code resource     */
	
		public const ushort TWON_DONTCARE8 = 0xFF;
		public const ushort TWON_DONTCARE16 = 0xFFFF;
		public const uint TWON_DONTCARE32 = 0xFFFFFFFF;
	
	
		/****************************************************************************
		* Capabilities                                                             *
		****************************************************************************/
	
		public const ushort CAP_CUSTOMBASE = 0x8000; /*Base of custom capabilities */
	
		/*all data sources are REQUIRED to support these caps */
		public const ushort CAP_XFERCOUNT = 0x1;
	
		/*image data sources are REQUIRED to support these caps */
		public const ushort ICAP_COMPRESSION = 0x100;
		public const ushort ICAP_PIXELTYPE = 0x101;
		public const ushort ICAP_UNITS = 0x102; /*default is TWUN_INCHES */
		public const ushort ICAP_XFERMECH = 0x103;
	
		/*all data sources MAY support these caps */
		public const ushort CAP_AUTHOR = 0x1000;
		public const ushort CAP_CAPTION = 0x1001;
		public const ushort CAP_FEEDERENABLED = 0x1002;
		public const ushort CAP_FEEDERLOADED = 0x1003;
		public const ushort CAP_TIMEDATE = 0x1004;
		public const ushort CAP_SUPPORTEDCAPS = 0x1005;
		public const ushort CAP_EXTENDEDCAPS = 0x1006;
		public const ushort CAP_AUTOFEED = 0x1007;
		public const ushort CAP_CLEARPAGE = 0x1008;
		public const ushort CAP_FEEDPAGE = 0x1009;
		public const ushort CAP_REWINDPAGE = 0x100A;
		public const ushort CAP_INDICATORS = 0x100B; /*Added 1.1 */
		public const ushort CAP_SUPPORTEDCAPSEXT = 0x100C; /*Added 1.6 */
		public const ushort CAP_PAPERDETECTABLE = 0x100D; /*Added 1.6 */
		public const ushort CAP_UICONTROLLABLE = 0x100E; /*Added 1.6 */
		public const ushort CAP_DEVICEONLINE = 0x100F; /*Added 1.6 */
		public const ushort CAP_AUTOSCAN = 0x1010; /*Added 1.6 */
		public const ushort CAP_THUMBNAILSENABLED = 0x1011; /*Added 1.7 */
		public const ushort CAP_DUPLEX = 0x1012; /*Added 1.7 */
		public const ushort CAP_DUPLEXENABLED = 0x1013; /*Added 1.7 */
		public const ushort CAP_ENABLEDSUIONLY = 0x1014; /*Added 1.7 */
		public const ushort CAP_CUSTOMDSDATA = 0x1015; /*Added 1.7 */
		public const ushort CAP_ENDORSER = 0x1016; /*Added 1.7 */
		public const ushort CAP_JOBCONTROL = 0x1017; /*Added 1.7 */
		public const ushort CAP_ALARMS = 0x1018; /*Added 1.8 */
		public const ushort CAP_ALARMVOLUME = 0x1019; /*Added 1.8 */
		public const ushort CAP_AUTOMATICCAPTURE = 0x101A; /*Added 1.8 */
		public const ushort CAP_TIMEBEFOREFIRSTCAPTURE = 0x101B; /*Added 1.8 */
		public const ushort CAP_TIMEBETWEENCAPTURES = 0x101C; /*Added 1.8 */
		public const ushort CAP_CLEARBUFFERS = 0x101D; /*Added 1.8 */
		public const ushort CAP_MAXBATCHBUFFERS = 0x101E; /*Added 1.8 */
		public const ushort CAP_DEVICETIMEDATE = 0x101F; /*Added 1.8 */
		public const ushort CAP_POWERSUPPLY = 0x1020; /*Added 1.8 */
		public const ushort CAP_CAMERAPREVIEWUI = 0x1021; /*Added 1.8 */
		public const ushort CAP_DEVICEEVENT = 0x1022; /*Added 1.8 */
		public const ushort CAP_SERIALNUMBER = 0x1024; /*Added 1.8 */
		public const ushort CAP_PRINTER = 0x1026; /*Added 1.8 */
		public const ushort CAP_PRINTERENABLED = 0x1027; /*Added 1.8 */
		public const ushort CAP_PRINTERINDEX = 0x1028; /*Added 1.8 */
		public const ushort CAP_PRINTERMODE = 0x1029; /*Added 1.8 */
		public const ushort CAP_PRINTERSTRING = 0x102A; /*Added 1.8 */
		public const ushort CAP_PRINTERSUFFIX = 0x102B; /*Added 1.8 */
		public const ushort CAP_LANGUAGE = 0x102C; /*Added 1.8 */
		public const ushort CAP_FEEDERALIGNMENT = 0x102D; /*Added 1.8 */
		public const ushort CAP_FEEDERORDER = 0x102E; /*Added 1.8 */
		public const ushort CAP_REACQUIREALLOWED = 0x1030; /*Added 1.8 */
		public const ushort CAP_BATTERYMINUTES = 0x1032; /*Added 1.8 */
		public const ushort CAP_BATTERYPERCENTAGE = 0x1033; /*Added 1.8 */
	
		/*image data sources MAY support these caps */
		public const ushort ICAP_AUTOBRIGHT = 0x1100;
		public const ushort ICAP_BRIGHTNESS = 0x1101;
		public const ushort ICAP_CONTRAST = 0x1103;
		public const ushort ICAP_CUSTHALFTONE = 0x1104;
		public const ushort ICAP_EXPOSURETIME = 0x1105;
		public const ushort ICAP_FILTER = 0x1106;
		public const ushort ICAP_FLASHUSED = 0x1107;
		public const ushort ICAP_GAMMA = 0x1108;
		public const ushort ICAP_HALFTONES = 0x1109;
		public const ushort ICAP_HIGHLIGHT = 0x110A;
		public const ushort ICAP_IMAGEFILEFORMAT = 0x110C;
		public const ushort ICAP_LAMPSTATE = 0x110D;
		public const ushort ICAP_LIGHTSOURCE = 0x110E;
		public const ushort ICAP_ORIENTATION = 0x1110;
		public const ushort ICAP_PHYSICALWIDTH = 0x1111;
		public const ushort ICAP_PHYSICALHEIGHT = 0x1112;
		public const ushort ICAP_SHADOW = 0x1113;
		public const ushort ICAP_FRAMES = 0x1114;
		public const ushort ICAP_XNATIVERESOLUTION = 0x1116;
		public const ushort ICAP_YNATIVERESOLUTION = 0x1117;
		public const ushort ICAP_XRESOLUTION = 0x1118;
		public const ushort ICAP_YRESOLUTION = 0x1119;
		public const ushort ICAP_MAXFRAMES = 0x111A;
		public const ushort ICAP_TILES = 0x111B;
		public const ushort ICAP_BITORDER = 0x111C;
		public const ushort ICAP_CCITTKFACTOR = 0x111D;
		public const ushort ICAP_LIGHTPATH = 0x111E;
		public const ushort ICAP_PIXELFLAVOR = 0x111F;
		public const ushort ICAP_PLANARCHUNKY = 0x1120;
		public const ushort ICAP_ROTATION = 0x1121;
		public const ushort ICAP_SUPPORTEDSIZES = 0x1122;
		public const ushort ICAP_THRESHOLD = 0x1123;
		public const ushort ICAP_XSCALING = 0x1124;
		public const ushort ICAP_YSCALING = 0x1125;
		public const ushort ICAP_BITORDERCODES = 0x1126;
		public const ushort ICAP_PIXELFLAVORCODES = 0x1127;
		public const ushort ICAP_JPEGPIXELTYPE = 0x1128;
		public const ushort ICAP_TIMEFILL = 0x112A;
		public const ushort ICAP_BITDEPTH = 0x112B;
		public const ushort ICAP_BITDEPTHREDUCTION = 0x112C; /*Added 1.5 */
		public const ushort ICAP_UNDEFINEDIMAGESIZE = 0x112D; /*Added 1.6 */
		public const ushort ICAP_IMAGEDATASET = 0x112E; /*Added 1.7 */
		public const ushort ICAP_EXTIMAGEINFO = 0x112F; /*Added 1.7 */
		public const ushort ICAP_MINIMUMHEIGHT = 0x1130; /*Added 1.7 */
		public const ushort ICAP_MINIMUMWIDTH = 0x1131; /*Added 1.7 */
		public const ushort ICAP_FLIPROTATION = 0x1136; /*Added 1.8 */
		public const ushort ICAP_BARCODEDETECTIONENABLED = 0x1137; /*Added 1.8 */
		public const ushort ICAP_SUPPORTEDBARCODETYPES = 0x1138; /*Added 1.8 */
		public const ushort ICAP_BARCODEMAXSEARCHPRIORITIES = 0x1139; /*Added 1.8 */
		public const ushort ICAP_BARCODESEARCHPRIORITIES = 0x113A; /*Added 1.8 */
		public const ushort ICAP_BARCODESEARCHMODE = 0x113B; /* Added 1.8 */
		public const ushort ICAP_BARCODEMAXRETRIES = 0x113C; /* Added 1.8 */
		public const ushort ICAP_BARCODETIMEOUT = 0x113D; /*Added 1.8 */
		public const ushort ICAP_ZOOMFACTOR = 0x113E; /*Added 1.8 */
		public const ushort ICAP_PATCHCODEDETECTIONENABLED = 0x113F; /*Added 1.8 */
		public const ushort ICAP_SUPPORTEDPATCHCODETYPES = 0x1140; /*Added 1.8 */
		public const ushort ICAP_PATCHCODEMAXSEARCHPRIORITIES = 0x1141; /*Added 1.8 */
		public const ushort ICAP_PATCHCODESEARCHPRIORITIES = 0x1142; /*Added 1.8 */
		public const ushort ICAP_PATCHCODESEARCHMODE = 0x1143; /*Added 1.8 */
		public const ushort ICAP_PATCHCODEMAXRETRIES = 0x1144; /*Added 1.8 */
		public const ushort ICAP_PATCHCODETIMEOUT = 0x1145; /*Added 1.8 */
		public const ushort ICAP_FLASHUSED2 = 0x1146; /*Added 1.8 */
		public const ushort ICAP_IMAGEFILTER = 0x1147; /*Added 1.8 */
		public const ushort ICAP_NOISEFILTER = 0x1148; /*Added 1.8 */
		public const ushort ICAP_OVERSCAN = 0x1149; /*Added 1.8 */
		public const ushort ICAP_AUTOMATICBORDERDETECTION = 0x1150; /*Added 1.8 */
		public const ushort ICAP_AUTOMATICDESKEW = 0x1151; /*Added 1.8 */
		public const ushort ICAP_AUTOMATICROTATE = 0x1152; /*Added 1.8 */
		public const ushort ICAP_JPEGQUALITY = 0x1153; /*Added 1.9 */
	
	
		/* ICAP_UNITS values (UN_ means UNits) */
		public const short TWUN_INCHES = 0;
		public const short TWUN_CENTIMETERS = 1;
		public const short TWUN_PICAS = 2;
		public const short TWUN_POINTS = 3;
		public const short TWUN_TWIPS = 4;
		public const short TWUN_PIXELS = 5;
	
	
		public struct TW_STR1024
		{
			[MarshalAs(UnmanagedType.ByValTStr, SizeConst=1026)]
			public string str_Renamed;
		}

		public struct TW_UINT32
		{
			public short l;
			public short u;
		}

		public struct TW_FIX32
		{
			public short Whole; /* maintains the sign */
			public short Frac;
		}

		/* No DAT needed.  Describes version of software currently running. */
		public struct TW_VERSION
		{
			public short MajorNum;  /* Major revision number of the software. */
			public short MinorNum;  /* Incremental revision number of the software. */
			public short Language;  /* e.g. TWLG_SWISSFRENCH */
			public short Country;   /* e.g. TWCY_SWITZERLAND */
			[MarshalAs(UnmanagedType.ByValTStr, SizeConst=34)]
			public string Info;		/* e.g. "1.0b3 Beta release" */
		}

		/* DAT_IDENTITY. Identifies the program/library/code resource. */
		public struct TW_IDENTITY
		{
			public TW_UINT32 Id;				/* Unique number.  In Windows, application pWnd */
			public TW_VERSION Version;			/* Identifies the piece of code              */
			public short ProtocolMajor;			/* Application and DS must set to TWON_PROTOCOLMAJOR */
			public short ProtocolMinor;			/* Application and DS must set to TWON_PROTOCOLMINOR */
			public TW_UINT32 SupportedGroups;	/* Bit field OR combination of DG_ constants */
			[MarshalAs(UnmanagedType.ByValTStr, SizeConst=34)]
			public string Manufacturer;			/* Manufacturer name, e.g. "Hewlett-Packard" */
			[MarshalAs(UnmanagedType.ByValTStr, SizeConst=34)]
			public string ProductFamily;		/* Product family name, e.g. "ScanJet"       */
			[MarshalAs(UnmanagedType.ByValTStr, SizeConst=34)]
			public string ProductName;			/* Product name, e.g. "ScanJet Plus"         */
		}


		/* DAT_IMAGEINFO. Application gets detailed image info from DS with this. */
		public struct TW_IMAGEINFO
		{
			public TW_FIX32 XResolution;	/* Resolution in the horizontal             */
			public TW_FIX32 YResolution;	/* Resolution in the vertical               */
			public int ImageWidth;			/* Columns in the image, -1 if unknown by DS*/
			public int ImageLength;			/* Rows in the image, -1 if unknown by DS   */
			public short SamplesPerPixel;	/* Number of samples per pixel, 3 for RGB   */
			[MarshalAs(UnmanagedType.ByValArray, SizeConst=8)]
			public short[] BitsPerSample;	/* Number of bits for each sample           */
			public short BitsPerPixel;		/* Number of bits for each padded pixel     */
			public short Planar;			/* True if Planar, False if chunky          */
			public short PixelType;			/* How to interp data; photo interp (TWPT_) */
			public short Compression;		/* How the data is compressed (TWCP_xxxx)   */

			public void initialize()
			{
				BitsPerSample = new short [8];
			}
		}

		/* No DAT.  Defines a frame rectangle in ICAP_UNITS coordinates. */
		public struct TW_FRAME
		{
			public TW_FIX32 Left; 
			public TW_FIX32 Top;
			public TW_FIX32 Right;
			public TW_FIX32 Bottom;
		}

		/* DAT_IMAGELAYOUT. Provides image layout information in current units. */
		public struct TW_IMAGELAYOUT
		{
			public TW_FRAME Frame;				/* Frame coords within larger document */
			public TW_UINT32 DocumentNumber; 
			public TW_UINT32 PageNumber;		/* Reset when you go to next document  */
			public TW_UINT32 FrameNumber;       /* Reset when you go to next page      */
		}
		
	}
}
