// ChildView.cpp : CChildView NX̎
//
#include "stdafx.h"
#include "TestEx.h"
#include "MainFrm.h"
#include "ChildView.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CChildView

CChildView::CChildView()
{
	m_lpE = (CEsergeant*)&theApp.m_E;
	m_lpBSE = (CBEsergeant*)&theApp.m_BSE;
	m_lpAZ = (CM3az*)&theApp.m_AZ;
	m_lpIZ = (CM4iz*)&theApp.m_IZ;
	m_lpLZ = (CM4lz*)&theApp.m_LZ;
	SecureZeroMemory(&m_ClippingZone, sizeof(CLIPPING_ZONE));
	SecureZeroMemory(&m_Vo, sizeof(POINT));	// \_
	m_nHs = 0;	// XN[
	m_nVs = 0;	// XN[
	SecureZeroMemory(&m_info, sizeof(IMAGE_INFO));
	m_info.nMagnifications = CTestExApp::MAG_FULL;
	SecureZeroMemory(&m_szMsgUndo, sizeof(m_szMsgUndo));

	// F
	m_crBlack = RGB(0,0,0);
	m_crRed	  = RGB(255,0,0);
	m_crWhite = RGB(255,255,255);
	m_crGray  = RGB(128,128,128);

	// uV
	m_brushRed.CreateSolidBrush(m_crRed);
	m_hatchGray.CreateHatchBrush(HS_DIAGCROSS, m_crGray);

	// y
	m_redPen.CreatePen(PS_SOLID, 1, m_crRed);
	
	// rbg}bv
	m_bmpMessage.LoadBitmap(IDB_MESSAGE);

	CBitmap	bmp;
	bmp.LoadBitmap(IDB_ICON);
	m_imgIcon.Create(24, 24,  ILC_COLOR8, 0, 4);
	m_imgIcon.Add(&bmp, RGB(0, 0, 0));

	m_szMsgUndo[0] = 0;
	m_nSampling = FALSE;
}

CChildView::~CChildView()
{
	if(m_lpBSE->AreYouReady() == CMBSE5E::yes)
	{
		m_lpBSE->beDestroyImage(m_info.lpImageBag);
	}
	else 
	{
		m_lpE->eSetImage(m_info.lpImageBag);
		m_lpE->eDestroyImage();
	}

	if(m_info.nExifCount != 0) 
	{
		INT nI;
		for(nI = 0; nI < m_info.nExifCount; nI++) 
		{
			delete m_info.lpField[nI].lpszName;
			delete m_info.lpField[nI].lpszValues;
		}
	}

	delete m_info.lpHistData;
	delete m_info.lpField;

	// uV
	m_brushRed.DeleteObject();
	m_hatchGray.DeleteObject();

	// y
	m_redPen.DeleteObject();
		
	// rbg}bv
	m_bmpMessage.DeleteObject();
}


BEGIN_MESSAGE_MAP(CChildView, CWnd)
	ON_WM_DESTROY()
	ON_WM_ERASEBKGND()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_PAINT()
	ON_WM_RBUTTONDOWN()
	ON_WM_SIZE()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONUP()
END_MESSAGE_MAP()



// CChildView bZ[W nh

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(	CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS, 
										::LoadCursor(NULL, IDC_ARROW), 
										reinterpret_cast<HBRUSH>(COLOR_WINDOW + 1), 
										NULL	);
	return TRUE;
}

BOOL CChildView::Create(	LPCTSTR lpszClassName, 
							LPCTSTR lpszWindowName,
							DWORD   dwStyle, 
					const	RECT&	rect, 
							CWnd*	pParentWnd, 
							UINT	nID, 
							CCreateContext* pContext	)
{
	// TODO : ɓȃR[hǉ邩A͊{NXĂяoĂB
	return CWnd::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this); // `̃foCX ReLXg

	CFont	font;
	CFont*	lpdef_font;
	LOGFONT lf;
	
	//
	//// 摜\
	//
	if(m_nSampling < 2)
	{
		// tHgύX
		SecureZeroMemory(&lf, sizeof(LOGFONT));       
		lf.lfHeight = 12;   
		lf.lfCharSet = SHIFTJIS_CHARSET;
		lstrcpy(lf.lfFaceName, _T("MS UI Gothic"));
		VERIFY(font.CreateFontIndirect(&lf)); 
		lpdef_font = dc.SelectObject(&font);
		
		if(m_lpBSE->AreYouReady() == CMBSE5E::yes)	// Booster E p
			DrawImageAtBSE(dc.m_hDC);
		else
			DrawImageAtE(dc.m_hDC);	

		
		// ̈\
		DrawClippingZone(&dc);
		// bZ[W
		DrawMessage(&dc);
		// ACR
		DrawIcon(&dc);
		// hy[h\
		if(theApp.m_bIZMode)
			DrawIZMode(&dc);
			
		dc.SelectObject(lpdef_font);
	}

	if(m_nSampling > 0)
	{
		//
		//// ky
		//
		if(m_lpLZ->AreYouReady() == CMGC4LZ::yes)
		{
			DrawLine(&dc);
		}
	}

	// bZ[W̕`̂߂ CWnd::OnPaint() ĂяoȂłB
}

BOOL CChildView::OnEraseBkgnd(CDC* pDC)
{
	// TODO : ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	RECT rc;
	GetClientRect(&rc);
	FillRect(pDC->m_hDC, &rc, (HBRUSH)GetStockObject(BLACK_BRUSH)); 

	return TRUE;//CWnd::OnEraseBkgnd(pDC);
}

void CChildView::OnLButtonDown(UINT nFlags, CPoint point)
{
	if(m_ClippingZone.nStatus != CPZ_REMOVED)
	{
		RECT  rcView;

		GetViewArea(FALSE, &rcView);
		
		if(m_ClippingZone.nStatus == CPZ_START)
		{
			// IJn
			m_ClippingZone.rcArea.left = point.x - m_Vo.x + rcView.left;
			m_ClippingZone.rcArea.top  = point.y - m_Vo.y + rcView.top;

			if(		m_ClippingZone.rcArea.left	< 0 
				||	m_ClippingZone.rcArea.top	< 0
				||	m_ClippingZone.rcArea.left >= m_info.nMagWidth
				||	m_ClippingZone.rcArea.top	>= m_info.nMagHeight	)
			{
				m_ClippingZone.nStatus = CPZ_REMOVED;
			}
			else 
			{
				m_ClippingZone.nStatus = CPZ_CLIPPING;
			}
		}
		else if(m_ClippingZone.nStatus == CPZ_CLIPPED)
		{
			// ̃T[NȂړ
			if(InspectPoint(&point, rcView.left, rcView.top))
			{
				ClipArea();
				m_ClippingZone.nStatus = CPZ_MOVING;
				MoveZone(TRUE, &point);
				// ĕ`
				InvalidateRect(NULL, FALSE);
			}
			else if(InspectPoint(&point, rcView.left, rcView.top, NULL))
			{
				// p̕`ȂTCYύX
				ClipArea();
				m_ClippingZone.nStatus = CPZ_CLIPPING;
			}
		}
	}
	else
	{
		if(m_lpLZ->AreYouReady())
		{
			m_nSampling = 0;
			 
			InvalidateRect(NULL, FALSE); 
			UpdateWindow();
			
			// J[\̈ړ
			RECT rect;

			GetWindowRect(&rect);
			ClipCursor(&rect);

			//
			//// ̃vOł́A}EX̍{^܂܃hbO邱ƂŃJ[\̍WTvOB
			//	 J[\WTvOn߂܂ 
		
			// IZ DLL 
			CMGC4LZ::INI_PARAMETERS params;

			params.nTimerElapse = CMGC4LZ::iniTimerElapseDefault;	// TvOg
			params.nFunction = CMGC4LZ::iniFncCommands;
			m_lpLZ->mlzInitialize(&params);					// ܂

			// TvOJn
			CMGC4LZ::STR_PARAMETERS	start;

			GetClientRect(&rect);

			start.nErase	= FALSE;
			start.nLeft		= rect.left;
			start.nTop		= rect.top;
			start.nRight	= rect.right;
			start.nBottom	= rect.bottom;

			UINT nR = m_lpLZ->mlzStart(this->m_hWnd, &start);	

			m_nSampling = 2;
		}
	}

	CWnd::OnLButtonDown(nFlags, point);
}

void CChildView::OnMouseMove(UINT nFlags, CPoint point)
{
	if(nFlags == MK_LBUTTON && m_ClippingZone.nStatus != CPZ_REMOVED)
	{
		if(m_ClippingZone.nStatus == CPZ_CLIPPING)
			ClipZone(&point);
		else if(m_ClippingZone.nStatus == CPZ_MOVING)
			MoveZone(FALSE, &point);
		
		// ĕ`
		InvalidateRect(NULL, FALSE); 
	}

	CWnd::OnMouseMove(nFlags, point);
}

void CChildView::OnLButtonUp(UINT nFlags, CPoint point)
{
	ClipCursor(NULL);

	if(m_ClippingZone.nStatus != CPZ_REMOVED)
	{
		if(m_ClippingZone.nStatus == CPZ_CLIPPING)
		{
			// Ï悪OH
			if( !(		m_ClippingZone.rcArea.top == m_ClippingZone.rcArea.bottom 
					||	m_ClippingZone.rcArea.left == m_ClippingZone.rcArea.right	)	)
			{
				m_ClippingZone.nStatus = CPZ_CLIPPED;
				m_ClippingZone.nCenterX = (m_ClippingZone.rcArea.right - m_ClippingZone.rcArea.left) / 2; 
                m_ClippingZone.nCenterY = (m_ClippingZone.rcArea.bottom - m_ClippingZone.rcArea.top) / 2; 
        	}
		}
		else if(m_ClippingZone.nStatus == CPZ_MOVING) 
		{
			m_ClippingZone.nStatus = CPZ_CLIPPED;
		}

		InvalidateRect(NULL, TRUE); // \XV
	}
	else
	{
		if(m_lpLZ->AreYouReady() == CMGC4LZ::yes && m_nSampling == 2)
		{
			int nR = m_lpLZ->mlzStop(this->m_hWnd);	// TvOI

			m_nSampling = 1;
				
			CString			strFormat, strMessage;
			CMGC4LZ::GRT_RESULT	grtResult;

			SecureZeroMemory(&grtResult, sizeof(CMGC4LZ::GRT_RESULT));


			m_lpLZ->mlzGetResult(&grtResult);	// ͌

			if(grtResult.nReturn == CMGC4LZ::success) 
			{
				// R}hs
				switch (grtResult.nType) 
				{
				case  CMGC4LZ::grtType1A :
					break;	
				case CMGC4LZ::grtType1B :
					break;
				case CMGC4LZ::grtType1C :
					break;
				case CMGC4LZ::grtType1D :
					break;
				case CMGC4LZ::grtType2A :
					break;
				case CMGC4LZ::grtType2B :
					break;
				case CMGC4LZ::grtType2C :
					break;
				case CMGC4LZ::grtType2D :
					break;
				case CMGC4LZ::grtType2E :
					theApp.Rotate(-90);
					break;
				case CMGC4LZ::grtType2F :
					break;
				case CMGC4LZ::grtType2G :
					theApp.Rotate(90);
					break;
				case CMGC4LZ::grtType2H :
					break;
				case CMGC4LZ::grtType3A :
					break;
				case CMGC4LZ::grtType3B :
					break;
				case CMGC4LZ::grtType3C :
					break;
				case CMGC4LZ::grtType3D :
					break;
				case CMGC4LZ::grtType3E :
					break;
				case CMGC4LZ::grtType3F :
					break;
				case CMGC4LZ::grtType3G :
					break;
				case CMGC4LZ::grtType3H :
					break;
				case CMGC4LZ::grtTypeOther :
					break;
				default:	//CMGC4LZ::grtTypeERROR
					break;
				}

			}

			InvalidateRect(NULL);
		}

	}

	CWnd::OnLButtonUp(nFlags, point);
}

void CChildView::OnRButtonUp(UINT nFlags, CPoint point)
{
	// TODO: ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	if(m_ClippingZone.nStatus != CPZ_REMOVED)
	{
		SecureZeroMemory(&m_ClippingZone, sizeof(CLIPPING_ZONE));
		ClipCursor(NULL);
	}
	else
	{
		ClipCursor(NULL);
		m_nSampling = 0;
	}

	InvalidateRect(NULL, TRUE);

	CWnd::OnRButtonUp(nFlags, point);
}

void CChildView::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);
	GetClientRect(&m_rcClient);
}

void CChildView::OnDestroy()
{
	CWnd::OnDestroy();
	// TODO : ɃbZ[W nh R[hǉ܂B
	//if(m_info.bEdited)
		//theApp.Save((CChildFrame*)GetParentFrame());
}

void CChildView::ClipZone(INT nType)
{
	SecureZeroMemory(&m_ClippingZone, sizeof(CLIPPING_ZONE));
	m_ClippingZone.nStatus = CPZ_START;
	m_ClippingZone.nType = nType;
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
///////
///////	vCx[g֐
///////
/////////////////////////////////////////////////////////////////////////////////////////////////////
void CChildView::DrawImageAtE(HDC hDC)
{
	//
	//// 摜\
	//
	INT	 nHeight;
	INT  nWidth;
	RECT rcDIB;
	RECT rcDest;
		

	theApp.m_E.eSetImage(m_info.lpImageBag);
	theApp.m_E.eGetDIBSize(&nHeight, &nWidth);

	if(nWidth > m_rcClient.right)	// \摜ʂ傫
	{
		// XN[ł
		GetScrollPoint(FALSE, (INT*)&rcDIB.left, (INT*)&rcDIB.right);
		rcDest.left = 0;	

		rcDest.right = ((rcDIB.right - rcDIB.left) < m_rcClient.right)?
							(rcDIB.right - rcDIB.left) : (m_rcClient.right);
	}
	else
	{
		rcDIB.left	 = 0;
		rcDIB.right = nWidth;
		rcDest.left = (m_rcClient.right - nWidth) / 2;
		rcDest.right = rcDest.left + nWidth;
	}

	if(nHeight > m_rcClient.bottom)
	{	
		GetScrollPoint(TRUE, (INT*)&rcDIB.top, (INT*)&rcDIB.bottom);
		rcDest.top = 0;

		rcDest.bottom = ((rcDIB.bottom - rcDIB.top) < m_rcClient.bottom)?
							(rcDIB.bottom - rcDIB.top) : (m_rcClient.bottom);		
	}
	else 
	{
		rcDIB.top		= 0;
		rcDIB.bottom	= nHeight;
		rcDest.top		= (m_rcClient.bottom - nHeight) / 2;
		rcDest.bottom	= rcDest.top + nHeight;
	}

	theApp.m_E.ePaintImage(hDC, &rcDIB, &rcDest);
}

void CChildView::DrawImageAtBSE(HDC hDC)
{
	//
	//// 摜gk
	//
	RECT	rcFrame;
	CMBSE5E::CPY_PARAMS params;

	
	SecureZeroMemory(&rcFrame, sizeof(RECT));
	SecureZeroMemory(&params, sizeof(params));

	params.nMagX = params.nMagY = (FLOAT)m_info.nRealMagnifications;
	params.nSrcRight	= m_info.nWidth;
	params.nSrcBottom	= m_info.nHeight;
	params.nBitPerPixel = m_info.nBPP;


	//// `vZ (Kvȗ̈Rs[ĕ\)
	//
	INT	nR0 = m_lpBSE->beGetSizeForCopy(&params, m_info.lpImageBag);
	
	// \摜ʂ傫
	if(params.nDestWidth > m_rcClient.right) 
	{
		// XN[ł
		GetScrollPoint(FALSE, &params.nSrcLeft, &params.nSrcRight);
        params.nDestX = 0;
		params.nDestWidth = m_rcClient.right;
	}
	else
	{
		m_Vo.x = (m_rcClient.right - params.nDestWidth) / 2;
		rcFrame.left  = m_Vo.x - 1;  
		rcFrame.right = m_Vo.x + params.nDestWidth + 5;
	}

	if(params.nDestHeight > m_rcClient.bottom)
	{	
		// XN[ł
		GetScrollPoint(TRUE, &params.nSrcTop, &params.nSrcBottom);
        params.nDestY = 0;
		params.nDestHeight = m_rcClient.bottom;		
	}
	else 
	{
		m_Vo.y = (m_rcClient.bottom - params.nDestHeight) / 2;
		rcFrame.top    = m_Vo.y - 1;  
		rcFrame.bottom = m_Vo.y + params.nDestHeight + 5;
	}

	//// K}␳
	//// Booster 𑕔Kv
	//
	//		 Function
	//				CMBSE5E::doNotPushInReverseBuffer(UNDOs)
	//           Adjustment.nBaseColor
	//				MBE_COLOR_RGB/MBE_COLOR_R/MBE_COLOR_G/MBE_COLOR_B(x[XJ[)
	//			 Adjustment.nGamma
	//				l 0.01  5.00 / 1.00 ͒Ȃ

	CMBSE5E::LPIMAGEBAG	lpDrawImage = NULL;

	if(nR0 == CMBSE5E::success)
	{
		lpDrawImage = m_lpBSE->beCreateImage(	CMBSE5E::noReverseBuffer,
												params.nDestWidth + 4, 
												params.nDestHeight + 4, 
												params.nBitPerPixel	);
		if(lpDrawImage != NULL)
		{
			params.nDestX = 2;
			params.nDestY = 2;
			params.nDestWidth  += 2;
			params.nDestHeight += 2;

			m_lpBSE->beCopy(	GetSafeHwnd(), 
								CMBSE5E::doNotPushInReverseBuffer | CMBSE5E::cpyMLQ,
								&params, 
								m_info.lpImageBag, 
								lpDrawImage	);

			CMBSE5E::ADG_ADJUSTMENT adj;

			adj.nBottom = params.nDestHeight;
			adj.nTop    = 0;
			adj.nRight  = params.nDestWidth;
			adj.nLeft   = 0;
			adj.nGamma  = theApp.m_setup.nGamma;
			adj.nBaseColor = CMBSE5E::adgRGB;

			m_lpBSE->beAdjustGamma(	GetSafeHwnd(), 
									CMBSE5E::doNotPushInReverseBuffer, 
									&adj, 
									lpDrawImage, 
									NULL	);

			m_lpBSE->beDrawImage(	hDC, 
									m_Vo.x, 
									m_Vo.y,
									params.nDestWidth,
									params.nDestHeight,
									0, 0, SRCCOPY, lpDrawImage	);

			m_lpBSE->beDestroyImage(lpDrawImage);

			::FrameRect(hDC, &rcFrame, (HBRUSH)GetStockObject(WHITE_BRUSH));
		}
	}

}

void CChildView::DrawLine(CPaintDC* lpDC)
{
	//
	//// LZ [h\
	//
	CMGC4LZ::GRT_RESULT		grtResult;
	CMGC4LZ::GSP_PARAMETERS	gspParams[2];

	m_lpLZ->mlzGetSamplingPosition(0, &gspParams[0]);

	if(gspParams[0].nCount != 0) 
	{
		// TvO_`
		lpDC->SelectObject(GetStockObject(BLACK_PEN));
		lpDC->SelectObject(GetStockObject(WHITE_BRUSH));

		lpDC->Ellipse(	gspParams[0].ptSamplingPosition.x, 
						gspParams[0].ptSamplingPosition.y,
						gspParams[0].ptSamplingPosition.x + 10, 
						gspParams[0].ptSamplingPosition.y + 10	);
				
		for(INT nI = 1; nI < gspParams[0].nCount; nI++) 
		{
			m_lpLZ->mlzGetSamplingPosition(nI, &gspParams[1]);

			lpDC->Ellipse(	gspParams[1].ptSamplingPosition.x,
							gspParams[1].ptSamplingPosition.y,
							gspParams[1].ptSamplingPosition.x + 6,
							gspParams[1].ptSamplingPosition.y + 6	);
		}
	}

	m_lpLZ->mlzGetResult(&grtResult);	// ͌

	if(grtResult.nReturn == CMGC4LZ::success) 
	{
		// TvO_萶`
		LONG nStart, nEnd, nStep;
		LONG nXx, nYy, nX, nY;
		CPen pen;
		CPen* lppenOld;
							
		
		pen.CreatePen(PS_SOLID, 2, RGB(235, 155, 10));
		lppenOld = lpDC->SelectObject(&pen);

		// ]n͂wAxւKv
		if(grtResult.nRotated == CMGC4LZ::yes)
		{
			LONG nTmp;
			for(LONG nI = 0; nI < 2; nI++)
			{
				nTmp = gspParams[nI].ptSamplingPosition.x;
				gspParams[nI].ptSamplingPosition.x = gspParams[nI].ptSamplingPosition.y;
				gspParams[nI].ptSamplingPosition.y = nTmp;
			}
		}

		GetStep(	gspParams[0].ptSamplingPosition.x, 
					gspParams[1].ptSamplingPosition.x, 
					&nStart, 
					&nEnd, 
					&nStep	);

		for(nXx = nStart; nXx < nEnd + nStep; nXx += nStep) 
		{
			nYy = (INT)(	grtResult.nCoefficient[3] * nXx * nXx * nXx + 
							grtResult.nCoefficient[2] * nXx * nXx +
							grtResult.nCoefficient[1] * nXx +
							grtResult.nCoefficient[0] );

			nX = (grtResult.nRotated == CMGC4LZ::yes)?  nYy : nXx;
			nY = (grtResult.nRotated == CMGC4LZ::yes)?  nXx : nYy;
	
			if(nXx == nStart)
				lpDC->MoveTo(nX, nY);
			else 
				lpDC->LineTo(nX, nY);
		}

		lpDC->SelectObject(lppenOld);
	}
}

void CChildView::GetStep(LONG nX1, LONG nX2, LONG* lpStart, LONG* lpEnd, LONG* lpStep)
{
	INT nStart  = min(nX1, nX2);
	INT nEnd	= max(nX1, nX2);
	INT nStep	= (nEnd - nStart) / 10;

	*lpStart = nStart;
	*lpEnd = nEnd;
	*lpStep = nStep;
}

void CChildView::DrawIZMode(CPaintDC* lpDC)
{
	//
	//// IZ [h\
	//
	if(theApp.m_bIZMode) 
	{
		TCHAR szT[CMGC4IZ::lengthName + CMGC4IZ::lengthValue];

		lpDC->SetBkMode(TRANSPARENT);
		lpDC->SetTextColor(m_crWhite);
		wsprintf(szT, _T("t@C <%s>"), m_info.szFileName);
		lpDC->TextOut(3, 0, szT, lstrlen(szT));
		wsprintf(szT, _T("t@C쐬 <%s>"), m_info.szCreateTime);
		lpDC->TextOut(3, 12, szT, lstrlen(szT));
		wsprintf(szT, _T("t@CXV <%s>"), m_info.szWriteTime);
		lpDC->TextOut(3, 24, szT, lstrlen(szT));
		wsprintf(szT, _T("t@C <%s>"), m_info.szFileAttributes);
		lpDC->TextOut(3, 36, szT, lstrlen(szT));


		INT nI = 0;


		if(m_info.nExifCount == 0)
		{
			wsprintf(szT, _T(" <%d>"), m_info.nWidth);
			lpDC->TextOut(3, 48, szT,lstrlen(szT));
			wsprintf(szT, _T(" <%d>"), m_info.nHeight);
			lpDC->TextOut(3, 60, szT, lstrlen(szT));
			wsprintf(szT, _T("rbg[ <%d>"), m_info.nBPP);
			lpDC->TextOut(3, 72, szT, lstrlen(szT));
		}
		else
		{
			// Exif
			
			for(nI = 0; nI < m_info.nExifCount; nI++)
			{
				wsprintf(	szT, 
							_T("%s <%s>"),
							m_info.lpField[nI].lpszName,
							m_info.lpField[nI].lpszValues	);
				lpDC->TextOut(3, (nI + 4) * 12, szT, lstrlen(szT));
			}
		}

		// Ot`
		if(m_info.lpHistData != NULL) 
		{
			INT	nOx, nOy, nX;

			if(m_rcClient.right > 600 && m_rcClient.bottom > 200)
			{
				nOx = m_rcClient.right - 270;
				nOy = 76;
				lpDC->SelectObject(GetStockObject(WHITE_PEN));

				for(INT nI = 0; nI < 256; nI++)
				{
					nX = nOx + nI;
					lpDC->MoveTo(nX, nOy);
					lpDC->LineTo(nX, nOy - m_info.lpHistData->nData[CMBSE5E::hstI][nI] / 4);
				}

				lpDC->MoveTo(nOx - 2  , nOy + 2);
				lpDC->LineTo(nOx + 260, nOy + 2);
				lpDC->MoveTo(nOx - 2  , nOy + 2);
				lpDC->LineTo(nOx - 2  , nOy - 68);
			}
		}
	}
}

void CChildView::DrawIcon(CPaintDC* lpDC)
{
	static LPCTSTR lpszMagnifications[] = {	_T("3:1\0"), _T("2:1\0"), _T("1:1\0"), _T("1:2\0"), _T("1:3\0"),
											_T("1:4\0"), _T("1:5\0"), _T("1:6\0"), _T("1:7\0"), _T("1:8\0"), 
											_T("1:9\0"), _T("1:10\0"), _T("?:?\0")	};
	INT	nN;
	INT	nI;
	INT	nX;
	INT	nY;
	BOOL bReady[7];
	

	nX = m_rcClient.right - 30;
	nY = m_rcClient.bottom - 30;

	// DLL
	bReady[0] = m_lpAZ->AreYouReady() == MAZ_YES;
	bReady[1] = m_lpBSE->AreYouReady() == CMBSE5E::yes;
	bReady[2] = m_lpE->AreYouReady() == CMGC4E::yes;
	bReady[3] = m_lpIZ->AreYouReady() == CMGC4IZ::yes;
	bReady[4] = m_lpLZ->AreYouReady() == CMGC4LZ::yes;
	// reverse buffer
	bReady[5] = theApp.m_nReverseBuffer == CMBSE5E::reverseBuffer;
	// Edited
	bReady[6] = m_info.bEdited;

	for(nI = 0; nI < 7; nI++)
	{
		if(bReady[nI])
		{
			m_imgIcon.Draw(lpDC, nI, CPoint(nX, nY), ILD_NORMAL);
		}
		nY-=26;
	}
	
	// {
	m_imgIcon.Draw(lpDC, nI, CPoint(nX, nY), ILD_NORMAL);

	nN = (m_info.nMagnifications < CTestExApp::MAG_COUNT)? 
			m_info.nMagnifications : CTestExApp::MAG_COUNT;
	
	lpDC->TextOut(nX + 2, nY + 2, lpszMagnifications[nN], lstrlen(lpszMagnifications[nN]));	
}

void CChildView::DrawMessage(CPaintDC* lpDC)
{
	//
	///// bZ[Wʂɕ\
	//
	// AhD
	CDC	 dcT;
	RECT rect; 

	if(m_szMsgUndo[0] != 0)
	{
		rect.left = m_rcClient.right - UNDO_MSG_X;
		rect.top = m_rcClient.bottom - UNDO_MSG_Y;

		lpDC->SetBkMode(TRANSPARENT);
		lpDC->SelectObject(GetStockObject(WHITE_BRUSH));
		lpDC->SelectObject(GetStockObject(WHITE_PEN));
		lpDC->SetTextColor(m_crBlack);

		dcT.CreateCompatibleDC(lpDC);
		dcT.SetBkMode(TRANSPARENT);
		dcT.SetTextColor(m_crBlack);
		dcT.SelectObject(&m_bmpMessage);
	
		lpDC->BitBlt(rect.left, rect.top, 300, 24, &dcT, 0, 0, SRCCOPY);
		lpDC->TextOut(rect.left + 40, rect.top + 6, m_szMsgUndo, lstrlen(m_szMsgUndo));
	}	
}

void CChildView::DrawClippingZone(CPaintDC* lpDC)
{
	//
	//// ̈\
	//
	if(m_ClippingZone.nStatus != CPZ_REMOVED) 
	{
		RECT  rcArea = {	m_ClippingZone.rcArea.left, 
							m_ClippingZone.rcArea.top, 
							m_ClippingZone.rcArea.right, 
							m_ClippingZone.rcArea.bottom	  };
	
		// \ʒu␳l
		RECT rcView;

		GetViewArea(FALSE, &rcView);
		rcArea.left   -= rcView.left;
		rcArea.right  -= rcView.left;
		rcArea.top    -= rcView.top;
		rcArea.bottom -= rcView.top;
		rcArea.left   += m_Vo.x;
		rcArea.right  += m_Vo.x;
		rcArea.top    += m_Vo.y;
		rcArea.bottom += m_Vo.y;

		//@\
		TCHAR	szTa[128], szTb[128];

		wsprintf( szTa, 
				  _T("x1=%d y1=%d, x2=%d y2=%d\0"), 
				  GetRealSize(m_ClippingZone.rcArea.left), 
				  GetRealSize(m_ClippingZone.rcArea.top),
				  GetRealSize(m_ClippingZone.rcArea.right),
				  GetRealSize(m_ClippingZone.rcArea.bottom)	);
		wsprintf( szTb, 
				  _T("%d x %d"),
				  abs(GetRealSize(m_ClippingZone.rcArea.right) - GetRealSize(m_ClippingZone.rcArea.left)), 
				  abs(GetRealSize(m_ClippingZone.rcArea.bottom) - GetRealSize(m_ClippingZone.rcArea.top))		);

		// ̈ړ̘g
		if(m_ClippingZone.nStatus == CPZ_MOVING) 
		{
			CRgn   rgnMove;
			rgnMove.CreateRectRgn(	rcArea.left   - 10, 
									rcArea.top    - 10, 
									rcArea.right  + 10,
									rcArea.bottom + 10		);
			lpDC->FrameRgn(&rgnMove, &m_hatchGray, 8, 8);
		}
		// Ig
		lpDC->FrameRect(&rcArea, &m_brushRed);
		// W
		lpDC->SetBkMode(TRANSPARENT);
		lpDC->SetTextColor(m_crRed);
		lpDC->TextOut(rcArea.left + 8, rcArea.top + 2, szTa, lstrlen(szTa));
		lpDC->TextOut(rcArea.left + 8, rcArea.bottom - 12, szTb, lstrlen(szTb));
		lpDC->SetTextColor(m_crBlack);
		// ړNbv̈
		RECT rcCircle;
		rcCircle.left   =  rcCircle.right = rcArea.left + (rcArea.right - rcArea.left) / 2;
		rcCircle.left   -= CPZ_GRIP_RADIUS;
		rcCircle.right  += CPZ_GRIP_RADIUS;
		rcCircle.top    =  rcCircle.bottom = rcArea.top + (rcArea.bottom - rcArea.top) / 2;
		rcCircle.top    -= CPZ_GRIP_RADIUS;
		rcCircle.bottom += CPZ_GRIP_RADIUS;
		lpDC->Ellipse(&rcCircle);
		// TCYNbv̈
		rcArea.left = rcArea.right - CPZ_GRIP_SIDE;
		rcArea.top = rcArea.bottom - CPZ_GRIP_SIDE;
		lpDC->Rectangle(&rcArea);
	}
}

void CChildView::GetScrollPoint(BOOL bVertical, INT *lpStart, INT *lpEnd)
{
	//
	//// XN[W̌vZ
	//
	INT		nStep;	// XN[
	INT		nLi;	// 摜ӂ̒
	DOUBLE  nLc;	// NCAg̒
	
	if(bVertical) 
	{
		nStep = m_nVs;
		nLi = m_info.nHeight;
		nLc = (DOUBLE)m_rcClient.bottom;
	}
	else
	{
  		 nStep = m_nHs;
		 nLi = m_info.nWidth;
		 nLc = (DOUBLE)m_rcClient.right;
	}

	if(nStep > 90)
		nStep = 90;

	*lpStart = nLi * nStep / 100;	// ړ

	if(lpEnd != NULL) 
	{
		*lpEnd = *lpStart + (INT)(nLc / m_info.nRealMagnifications);
		
		if(*lpEnd > nLi)
			*lpEnd = nLi;
	}
}

void CChildView::ClipZone(CPoint* lpPoint)
{
	//
	//// IGA擾
	//
	RECT rcView;

	GetViewArea(FALSE, &rcView);
	
	// Eւ̂ݓ
	if(		m_ClippingZone.rcArea.left > (lpPoint->x - m_Vo.x + rcView.left)
		||	m_ClippingZone.rcArea.top > (lpPoint->y - m_Vo.y + rcView.bottom)	)
	{
		return;
	}

	// Ï
	m_ClippingZone.rcArea.right = lpPoint->x - m_Vo.x + rcView.left;

	if(m_ClippingZone.nType == CPZ_TYPE_23)
	{
			m_ClippingZone.rcArea.bottom
		=	(m_ClippingZone.rcArea.right - m_ClippingZone.rcArea.left) * 3 / 2
		+	m_ClippingZone.rcArea.top;
	}
	else if(m_ClippingZone.nType == CPZ_TYPE_32)
	{
			m_ClippingZone.rcArea.bottom
		=	(m_ClippingZone.rcArea.right - m_ClippingZone.rcArea.left) * 2 / 3
		+	m_ClippingZone.rcArea.top;
	}
	else 
	{
		m_ClippingZone.rcArea.bottom = lpPoint->y - m_Vo.y + rcView.top;
	}


	// ̈搧
	if(m_ClippingZone.rcArea.right >= (rcView.right + rcView.left))
	{
		m_ClippingZone.rcArea.right = m_info.nMagWidth;
		if(m_ClippingZone.nType == CPZ_TYPE_23) 
		{
				m_ClippingZone.rcArea.bottom
			=	(m_ClippingZone.rcArea.right - m_ClippingZone.rcArea.left) * 3 / 2 
			+	m_ClippingZone.rcArea.top;
		}
		else if(m_ClippingZone.nType == CPZ_TYPE_32)
		{
				m_ClippingZone.rcArea.bottom
			=	(m_ClippingZone.rcArea.right - m_ClippingZone.rcArea.left) * 2 / 3 
			+	m_ClippingZone.rcArea.top;
		}
	}

	if(m_ClippingZone.rcArea.bottom > (rcView.bottom + rcView.top))
	{
		m_ClippingZone.rcArea.bottom = rcView.bottom;
		if(m_ClippingZone.nType == CPZ_TYPE_23)
		{
				m_ClippingZone.rcArea.right
			=	(m_ClippingZone.rcArea.bottom - m_ClippingZone.rcArea.top) * 2 / 3 
			+	m_ClippingZone.rcArea.left;
		}
		else if(m_ClippingZone.nType == CPZ_TYPE_32) 
		{
				m_ClippingZone.rcArea.right
			=	(m_ClippingZone.rcArea.bottom - m_ClippingZone.rcArea.top) * 3 / 2
			+	m_ClippingZone.rcArea.left;
		}
	}
}

void CChildView::MoveZone(BOOL bStart, CPoint* lpPoint)
{
	//
	//// IGAړ
	//
	static POINT ptOld = { 0, 0 };
	
	if(bStart)
	{
		ptOld.x = lpPoint->x;
		ptOld.y = lpPoint->y;
	}
	else 
	{
		// \̈
		RECT rcView;
		GetViewArea(FALSE, &rcView);

		INT nWidth  = rcView.right + rcView.left;
		INT nHeight = rcView.bottom + rcView.top;
	
		// ̈搧
		RECT rcTmp = {		m_ClippingZone.rcArea.left, 
							m_ClippingZone.rcArea.top, 
							m_ClippingZone.rcArea.right,
							m_ClippingZone.rcArea.bottom	};
		
		rcTmp.left   += (lpPoint->x - ptOld.x);
		rcTmp.right  += (lpPoint->x - ptOld.x);			
		rcTmp.top    += (lpPoint->y - ptOld.y);
		rcTmp.bottom += (lpPoint->y - ptOld.y);

		if(rcTmp.left < rcView.left) 
		{
			rcTmp.right = rcView.left + (rcTmp.right - rcTmp.left);
			rcTmp.left  = rcView.left;		
		}
		if(rcTmp.right > nWidth) 
		{
			rcTmp.left  = nWidth - (rcTmp.right - rcTmp.left);
			rcTmp.right = nWidth;
		}
		if(rcTmp.top < rcView.top)
		{
			rcTmp.bottom = rcView.top + (rcTmp.bottom - rcTmp.top);
			rcTmp.top    = rcView.top;
		}
		if(rcTmp.bottom > nHeight)
		{
			rcTmp.top    = nHeight - (rcTmp.bottom - rcTmp.top);
			rcTmp.bottom = nHeight;
		}

		CopyMemory(&m_ClippingZone.rcArea, &rcTmp, sizeof(RECT));
		ptOld.x = lpPoint->x;
		ptOld.y = lpPoint->y;
	}
}

BOOL CChildView::InspectPoint(POINT *lpPoint, LONG nOffsetX, LONG nOffsetY)
{
	//
	//// ~GÃ|CgH
	//
	RECT rcArea = {  m_ClippingZone.rcArea.left   - nOffsetX, 
					 m_ClippingZone.rcArea.top    - nOffsetY, 
					 m_ClippingZone.rcArea.right  - nOffsetX,
					 m_ClippingZone.rcArea.bottom - nOffsetY };

	POINT pntO = {	(rcArea.right - rcArea.left) / 2 + rcArea.left + m_Vo.x, 
					(rcArea.bottom - rcArea.top) / 2 + rcArea.top + m_Vo.y  };

	INT nRadius2 =		(lpPoint->y - pntO.y) * (lpPoint->y - pntO.y)
					+	(lpPoint->x - pntO.x) * (lpPoint->x - pntO.x);

	return nRadius2 < (CPZ_GRIP_RADIUS * CPZ_GRIP_RADIUS);
}

BOOL CChildView::InspectPoint(POINT *lpPoint, LONG nOffsetX, LONG nOffsetY, LPVOID lpReserved)
{
	//
	//// `GÃ|CgH
	//
	RECT rcArea = { m_ClippingZone.rcArea.right  - CPZ_GRIP_SIDE	- nOffsetX + m_Vo.x, 
					 m_ClippingZone.rcArea.bottom - CPZ_GRIP_SIDE	- nOffsetY + m_Vo.y, 
					 m_ClippingZone.rcArea.right					- nOffsetX + m_Vo.x,
					 m_ClippingZone.rcArea.bottom					- nOffsetY + m_Vo.y  };

	return	lpPoint->x > rcArea.left 
		&&	lpPoint->x < rcArea.right
		&&	lpPoint->y > rcArea.top
		&&	lpPoint->y < rcArea.bottom;
}

void CChildView::GetViewArea(BOOL bClient, RECT* lprcView)
{
	//
	//// ʂɕ\ĂGA
	//

	//// XN[W̌vZ
	INT	nSx = m_nHs;		// XN[
	INT	nSy = m_nVs;		// XN[
	
	
	if(nSx == 100)
		nSx = 98;
	if(nSy == 100)
		nSy = 98;

	INT nX = m_info.nMagWidth * nSx / 100;	// ړ
	INT nY = m_info.nMagHeight* nSy / 100;	// ړ

	// _
	if(bClient == TRUE) 
	{
		// _NCAg̍
		lprcView->left   = m_Vo.x;
		lprcView->top    = m_Vo.y;
		lprcView->right  = m_info.nMagWidth  + m_Vo.x;
		lprcView->bottom = m_info.nMagHeight + m_Vo.y;
	}
	else 
	{
		// _摜̍
		lprcView->left   = nX;
		lprcView->top    = nY;
		lprcView->right  = m_info.nMagWidth;
		lprcView->bottom = m_info.nMagHeight;
	}

    // \摜ʂ傫+XN[łƂ
	if(m_info.nMagWidth > m_rcClient.right) 
	{
		if((m_info.nMagWidth - nX) < m_rcClient.right)
			lprcView->right = m_info.nMagWidth - nX;
		else
			lprcView->right = m_rcClient.right;
	}
	if(m_info.nMagHeight > m_rcClient.bottom) 
	{
		if((m_info.nMagHeight - nY) < m_rcClient.bottom)
			lprcView->bottom = m_info.nMagHeight - nY;
		else
			lprcView->bottom = m_rcClient.bottom;
	}
}

void CChildView::ClipArea()
{
	//
	//// I搧
	//
	RECT rcLimit;
	GetViewArea(TRUE, &rcLimit);
	rcLimit.right++;
	rcLimit.bottom++;
    ClientToScreen(&rcLimit);
	ClipCursor(&rcLimit);
}
/////////////////////////////////////////////////////////////////////////////////////////////////////
///////
///////	pubN֐
///////
/////////////////////////////////////////////////////////////////////////////////////////////////////
INT CChildView::GetMagSize(INT nValue)
{
	return (INT) ((DOUBLE)nValue * m_info.nRealMagnifications);
}

void CChildView::GetMagSize(RECT *lprcValue)
{
	lprcValue->bottom = GetMagSize(lprcValue->bottom);
	lprcValue->left   = GetMagSize(lprcValue->left);
	lprcValue->right  = GetMagSize(lprcValue->right);
	lprcValue->top    = GetMagSize(lprcValue->top);
}

INT CChildView::GetRealSize(INT nValue)
{
	return (INT) ((DOUBLE)nValue / m_info.nRealMagnifications);
}

void CChildView::GetRealSize(RECT* lprcValue)
{
	lprcValue->bottom = GetRealSize(lprcValue->bottom);
	lprcValue->left   = GetRealSize(lprcValue->left);
	lprcValue->right  = GetRealSize(lprcValue->right);
	lprcValue->top    = GetRealSize(lprcValue->top);
}

void CChildView::SetMagnification(DOUBLE nRealMagnifications, INT nMagnifications)
{
	if(m_ClippingZone.nStatus == CPZ_CLIPPED) 
	{
		// ̈IĂƂ̍ČvZ
		RECT rcCopy;
		CopyMemory(&rcCopy, &m_ClippingZone.rcArea, sizeof(RECT));
		GetRealSize(&rcCopy);
		GetMagSize(&rcCopy);
		CopyMemory(&m_ClippingZone.rcArea, &rcCopy, sizeof(RECT));
	}
	else
	{
		m_info.nMagnifications = nMagnifications;
		m_info.nRealMagnifications = nRealMagnifications;
	}

	m_info.nMagnifications = nMagnifications;
	m_info.nRealMagnifications = nRealMagnifications;
	m_info.nMagHeight = GetMagSize(m_info.nHeight);
	m_info.nMagWidth = GetMagSize(m_info.nWidth);
}

void CChildView::SetMessageUndo(LPCTSTR lpszMsg)
{
	lstrcpy(m_szMsgUndo, lpszMsg);
}

void CChildView::GetAreaToErase(LPRECT lpArea)
{
	lpArea->left	= m_rcClient.right - UNDO_MSG_X;
	lpArea->top		= m_rcClient.bottom - UNDO_MSG_Y;
	lpArea->bottom	= lpArea->top + 30;
	lpArea->right	= lpArea->left + 304;
}
