// DlgCopy.cpp : t@C
//

#include "stdafx.h"
#include "TestEx.h"
#include "DlgCopy.h"


// CDlgCopy _CAO

IMPLEMENT_DYNAMIC(CDlgCopy, CDialog)
CDlgCopy::CDlgCopy(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgCopy::IDD, pParent)
{
	m_CopyValue.nAdjust = NO_ADJUST;
	m_CopyValue.nFunctions = 0;
	m_CopyValue.nDegrees = 0;
	m_CopyValue.nMagnifications = 1.0f;
	// {^
	m_bmpEnd.LoadBitmap(IDB_END);
}

CDlgCopy::~CDlgCopy()
{
	m_bmpEnd.DeleteObject();
}

void CDlgCopy::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COPY_BUTTON_END, m_btnEnd);
	DDX_Control(pDX, IDC_COPY_SLIDER_ROTATE, m_sldRotete);
	DDX_Control(pDX, IDC_COPY_SLIDER_MAG , m_sldMag);
	DDX_Control(pDX, IDC_COPY_CHECK_MIRROR, m_btnMirror);
	DDX_Control(pDX, IDC_COPY_CHECK_REVERSE, m_btnReverse);
	DDX_Control(pDX, IDC_COPY_CHECK_SEPIA, m_btnSepia);
	DDX_Control(pDX, IDC_COPY_CHECK_QUALITY, m_btnQuality);
	DDX_Control(pDX, IDC_COPY_STATIC_MAG_NO, m_labMagNo);
	DDX_Control(pDX, IDC_COPY_STATIC_ROTATE_NO, m_labRotateNo);
	DDX_Control(pDX, IDC_COPY_STATIC_TITLE, m_labTitle);
}

BEGIN_MESSAGE_MAP(CDlgCopy, CDialog)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_COPY_BUTTON_END, OnBnClickedButtonEnd)
	ON_BN_CLICKED(IDC_COPY_BUTTON_RESET, OnBnClickedButtonReset)
	ON_WM_HSCROLL()
END_MESSAGE_MAP()


// CDlgCopy bZ[W nh

BOOL CDlgCopy::OnInitDialog()
{
	CDialog::OnInitDialog();

	// {^
	m_btnEnd.SetBitmap(m_bmpEnd);

	// ^Cg
	TCHAR szT[64];
	LoadString(theApp.m_hInstance, IDS_DLG_COPY_TITLE, szT, 64);
	m_labTitle.SetWindowText(szT);

	// XC_[
	m_sldRotete.SetRange(-180, 180, TRUE);
	m_sldRotete.SetPageSize(90);
	m_sldRotete.SetPos(0);
	m_sldRotete.SetWindowText(_T("0"));

	m_sldMag.SetRange(2, 30, TRUE);
	m_sldMag.SetPageSize(1);
	m_sldMag.SetPos(10);
	m_sldMag.SetWindowText(_T("1"));

	// 
	CTestExApp::REAL real;
	
	theApp.FloatToReal((DOUBLE)m_sldMag.GetPos() / 10.0, &real);
	wsprintf(szT, _T("%d.%d"), real);
	m_labMagNo.SetWindowText(szT);
	wsprintf(szT, _T("%d"), m_sldRotete.GetPos());
	m_labRotateNo.SetWindowText(szT);
	
	// `FbN{bNX
	m_btnQuality.SetCheck(TRUE);


	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

void CDlgCopy::OnBnClickedCancel()
{
	m_CopyValue.nAdjust		= NO_ADJUST;
 	m_CopyValue.nDegrees	= 0;
	m_CopyValue.nFunctions	= 0;
	m_CopyValue.nMagnifications	= 1.0;
	OnCancel();
}

void CDlgCopy::OnBnClickedOk()
{
	INT nDegrees		= m_sldRotete.GetPos();
	INT nMagnifications	= m_sldMag.GetPos();
	INT nMirror			= m_btnMirror.GetCheck();
	INT nReverse		= m_btnReverse.GetCheck();
	INT nSepia			= m_btnSepia.GetCheck();
    INT nQuality		= m_btnQuality.GetCheck();
    
	
	m_CopyValue.nMagnifications = (DOUBLE)nMagnifications / 10.0;
	m_CopyValue.nDegrees	= nDegrees;
	m_CopyValue.nFunctions	= 0;

	if(m_btnMirror.GetCheck())
		m_CopyValue.nFunctions |= CMBSE5E::cpyMirror;
	if(m_btnReverse.GetCheck())
		m_CopyValue.nFunctions |= CMBSE5E::cpyReverseColor;
	if(m_btnSepia.GetCheck())
		m_CopyValue.nFunctions |= CMBSE5E::cpySepia;
	if(!m_btnQuality.GetCheck())
		m_CopyValue.nFunctions |= CMBSE5E::cpyMLQ;

	m_CopyValue.nAdjust = ADJUST;
	OnOK();
}

void CDlgCopy::OnBnClickedButtonEnd()
{
	m_CopyValue.nAdjust = NO_ADJUST;
	OnCancel();
}

void CDlgCopy::GetValue(LPCOPY_VALUE lpCopyValue)
{
	CopyMemory(lpCopyValue, &m_CopyValue, sizeof(COPY_VALUE));
}

void CDlgCopy::OnBnClickedButtonReset()
{
	// XC_[
	TCHAR			 szT[32];
	CTestExApp::REAL real;


	m_sldRotete.SetPos(0);
	m_sldMag.SetPos(10);

	theApp.FloatToReal((DOUBLE)m_sldMag.GetPos() / 10.0, &real);
	wsprintf(szT, _T("%d.%d"), real);
	m_labMagNo.SetWindowText(szT);	
	wsprintf(szT, _T("%d"), m_sldMag.GetPos());
	m_labRotateNo.SetWindowText(szT);
	
	// `FbN{bNX
	m_btnMirror.SetCheck(FALSE);
	m_btnReverse.SetCheck(FALSE);
	m_btnSepia.SetCheck(FALSE);
	m_btnQuality.SetCheck(TRUE);

	m_CopyValue.nAdjust		= NO_ADJUST;
	m_CopyValue.nDegrees	= 0;
	m_CopyValue.nFunctions	= 0;
	m_CopyValue.nMagnifications	= 1.0;
}

void CDlgCopy::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	if(nSBCode == TB_ENDTRACK)
	{
		EnableWindow(FALSE);
     
		CSliderCtrl *lpSlider = (CSliderCtrl*)pScrollBar;
		TCHAR szNo[32];
		CTestExApp::REAL real;

		
		switch(lpSlider->GetDlgCtrlID())
		{
		case IDC_COPY_SLIDER_MAG:
			m_CopyValue.nMagnifications	= (DOUBLE)lpSlider->GetPos() / 10.0;
			theApp.FloatToReal(m_CopyValue.nMagnifications, &real);
			wsprintf(szNo, _T("%d.%d"), real);
			m_labMagNo.SetWindowText(szNo);	
			break;
		case IDC_COPY_SLIDER_ROTATE:
			m_CopyValue.nDegrees = lpSlider->GetPos();
			wsprintf(szNo, _T("%d"), m_CopyValue.nDegrees);
			m_labRotateNo.SetWindowText(szNo);
			break;
		}
		
		EnableWindow(TRUE);
	}

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
