// DlgFile.cpp : t@C
//
#include "stdafx.h"
#include "TestEx.h"
#include "DlgFile.h"


// CDlgFile _CAO

IMPLEMENT_DYNAMIC(CDlgFile, CDialog)
CDlgFile::CDlgFile(CWnd* pParent /*=NULL*/, LPCTSTR lpszDirectory)
	: CDialog(CDlgFile::IDD, pParent)
{
	m_szDirectory[0] = 0;

	if(lpszDirectory == NULL || lstrlen(lpszDirectory) == 0)
	{
		// WfBNg
		GetCurrentDirectory(MAX_PATH, m_szDirectory);
		if(lstrlen(m_szDirectory) < 240)
			lstrcat(m_szDirectory, _T("\\images"));	
	}
	else 
	{
		lstrcpy(m_szDirectory, lpszDirectory);
	}

	// {^
	m_bmpEnd.LoadBitmap(IDB_END);
}

CDlgFile::~CDlgFile()
{
	m_bmpEnd.DeleteObject();
}

void CDlgFile::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_FILE_BUTTON_END, m_btnEnd);
	DDX_Control(pDX, IDC_FILE_EDIT_DIRECTORY, m_edtDirectory);
	DDX_Control(pDX, IDC_FILE_EDIT_FILENAME, m_edtFileName);
	DDX_Control(pDX, IDC_FILE_STATIC_OUTPUT, m_labOutput);
	DDX_Control(pDX, IDC_FILE_STATIC_TITLE, m_labTitle);
}

BEGIN_MESSAGE_MAP(CDlgFile, CDialog)
	ON_BN_CLICKED(IDC_FILE_BUTTON_END, OnBnClickedButtonEnd)
	ON_BN_CLICKED(IDC_FILE_BUTTON_REFER, OnBnClickedButtonRefer)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_EN_CHANGE(IDC_FILE_EDIT_FILENAME, OnEnChangeEditFileName)
	ON_WM_PAINT()
END_MESSAGE_MAP()


// CDlgFile bZ[W nh
BOOL CDlgFile::OnInitDialog()
{
	CDialog::OnInitDialog();


	TCHAR szOutput[MAX_PATH];

	// {^
	m_btnEnd.SetBitmap(m_bmpEnd);	
	m_edtDirectory.SetWindowText(m_szDirectory);
	m_edtFileName.SetWindowText(_T("image"));
	wsprintf(szOutput, _T("%s\\image_***.bmp"), m_szDirectory);
	m_labOutput.SetWindowText(szOutput);
	m_edtFileName.SetLimitText(16);

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

void CDlgFile::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO : ɃbZ[W nh R[hǉ܂B
	// `惁bZ[W CDialog::OnPaint() ĂяoȂłB
}

void CDlgFile::OnBnClickedButtonRefer()
{
	MAZ_SDB_INFORMATION info;

	if(theApp.m_AZ.AreYouReady() == CMBSE5E::yes) 
	{
		info.hWnd = GetSafeHwnd();
		info.lpszCurrentDirectory = NULL;
		info.nX		 = -1;
		info.nY		 = -1;
		info.nHeight = -1;
		info.nWidth	 = -1;	
		info.nStyle	 = MAZ_SDB_TYPE_A;
		info.lpszMessage = "C[Wt@Co͐";

		if(theApp.m_AZ.ShowDirListBox(&info, CT2A(m_szDirectory)) == MAZ_OK) 
		{
			m_edtDirectory.SetWindowText(m_szDirectory);
			OnEnChangeEditFileName();
		}
	}
}

void CDlgFile::OnEnChangeEditFileName()
{
	// TODO :  ꂪ RICHEDIT Rg[̏ꍇA܂ACDialog::OnInitDialog() ֐I[o[ChāA
	// OR Ԃ ENM_CORRECTTEXT tO}XNɓāA
	// CRichEditCtrl().SetEventMask() ĂяoȂA
	// Rg[́A̒ʒm𑗐M܂B
	TCHAR szDirectory[MAX_PATH];
	TCHAR szFileName[MAX_PATH];
	TCHAR szOutput[MAX_PATH];

	
	m_edtDirectory.GetWindowText(szDirectory, MAX_PATH);
	m_edtFileName.GetWindowText(szFileName, MAX_PATH);

	wsprintf(szOutput, _T("%s\\%s***_.bmp"), szDirectory, szFileName);
	lstrcpy(m_szFileName, szFileName);

	m_labOutput.SetWindowText(szOutput);	
}

void CDlgFile::OnBnClickedOk()
{
	WIN32_FIND_DATA FindFileData;

	if(FindFirstFile(m_szDirectory, &FindFileData) == INVALID_HANDLE_VALUE)
	{
		// o͐悪Ȃ̂ō쐬
		if(CreateDirectory(m_szDirectory, NULL) == 0) 
		{
			// 쐬łȂ
			theApp.ShowErrorMessage(CTestExApp::ERR_TEX_DIRECTORY, _T("TEX"));
			return;
		}
	}
    
	OnOK();
}

void CDlgFile::GetFileName(LPTSTR lpszFileName)
{
	wsprintf(lpszFileName, _T("%s\\%s"), m_szDirectory, m_szFileName);
}

void CDlgFile::GetDirectory(LPTSTR lpszDirectory)
{
	lstrcpy(lpszDirectory, m_szDirectory);
}

void CDlgFile::OnBnClickedButtonEnd()
{
	OnCancel();
}
