// DlgHistogram.cpp : t@C
//

#include "stdafx.h"
#include "TestEx.h"
#include "DlgHistogram.h"



// CDlgHistogram _CAO

IMPLEMENT_DYNAMIC(CDlgHistogram, CDialog)
CDlgHistogram::CDlgHistogram(INT nHist[6][256], INT nBitPixel, CWnd* pParent)
	: CDialog(CDlgHistogram::IDD, pParent)
{
	m_nColor = COLOR_I;

	// qXgf[^Rs[
	CopyMemory(m_nHist, nHist, sizeof(m_nHist));
	m_nBitPixel = nBitPixel;

	// {^
	m_bmpEnd.LoadBitmap(IDB_END);
}

CDlgHistogram::~CDlgHistogram()
{
}

void CDlgHistogram::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_HISTOGRAM_BUTTON_END, m_btnEnd);
	DDX_Control(pDX, IDC_HISTOGRAM_RADIO_B, m_btnB);
	DDX_Control(pDX, IDC_HISTOGRAM_RADIO_G, m_btnG);
	DDX_Control(pDX, IDC_HISTOGRAM_RADIO_I, m_btnI);
	DDX_Control(pDX, IDC_HISTOGRAM_RADIO_R, m_btnR);
	DDX_Control(pDX, IDC_HISTOGRAM_STATIC_BIT, m_labBit);
	DDX_Control(pDX, IDC_HISTOGRAM_STATIC_MAX, m_labMax);
	DDX_Control(pDX, IDC_HISTOGRAM_STATIC_MIN, m_labMin);
	DDX_Control(pDX, IDC_HISTOGRAM_STATIC_TITLE, m_labTitle);
}

BEGIN_MESSAGE_MAP(CDlgHistogram, CDialog)
	ON_BN_CLICKED(IDC_HISTOGRAM_BUTTON_END, OnBnClickedButtonEnd)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_CONTROL_RANGE(BN_CLICKED, IDC_HISTOGRAM_RADIO_B, IDC_HISTOGRAM_RADIO_R, OnBnClickedRadio)
	ON_WM_PAINT()
END_MESSAGE_MAP()


// CDlgHistogram bZ[W nh

BOOL CDlgHistogram::OnInitDialog()
{
	CDialog::OnInitDialog();

	TCHAR szT[64];

	// {^
	m_btnEnd.SetBitmap(m_bmpEnd);

	// ^Cg
	LoadString(theApp.m_hInstance, IDS_DLG_HISTOGRAM_TITLE, szT, 64);
	m_labTitle.SetWindowText(szT);

	// WI{^
	LoadString(theApp.m_hInstance, IDS_DLG_HISTOGRAM_R, szT, 64);
	m_btnR.SetWindowText(szT);
	LoadString(theApp.m_hInstance, IDS_DLG_HISTOGRAM_G, szT, 64);
	m_btnG.SetWindowText(szT);
	LoadString(theApp.m_hInstance, IDS_DLG_HISTOGRAM_B, szT, 64);
	m_btnB.SetWindowText(szT);
	LoadString(theApp.m_hInstance, IDS_DLG_HISTOGRAM_I, szT, 64);
	m_btnI.SetWindowText(szT);
	m_btnI.SetCheck(TRUE);

	// rbgeLXg
	wsprintf(szT, _T("%d BPP"), m_nBitPixel);
	m_labBit.SetWindowText(szT);
	
	//@
	CenterWindow();

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

void CDlgHistogram::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO : ɃbZ[W nh R[hǉ܂B
	// `惁bZ[W CDialog::OnPaint() ĂяoȂłB

	//
	//// Ot`
	//   
	INT		nX, nY;
	POINT	pntOrigin = { 10, 42 };	// `挴_

	
	CBrush brushWhite(RGB(255, 255, 255));
	CBrush* pOldBrush = dc.SelectObject(&brushWhite);
	CPen penSolidBlack;
	penSolidBlack.CreatePen(PS_SOLID, 0, RGB(0, 0, 0));
	CPen penSolidRed;
	CPen penSolidGreen;
	CPen penSolidBlue;
	CPen penSolidGold;
	CPen penSolidSilver;
	CPen penSolid;
	
	// Otwi
	CPen* pOldPen = dc.SelectObject(&penSolidBlack);

	RECT rect;
	rect.left	= pntOrigin.x;
	rect.right	= pntOrigin.x + 260;
	rect.top	= pntOrigin.y;
	rect.bottom = pntOrigin.y + 132;

	dc.MoveTo(rect.left, rect.top); 
	dc.LineTo(rect.right, rect.top); 
	dc.LineTo(rect.right, rect.bottom);
	dc.LineTo(rect.left, rect.bottom); 
	dc.LineTo(rect.left, rect.top);
	dc.Rectangle(&rect);
	
		
	// CWP[^
	INT		nI;
	POINT	point;
	
	for(nI = 0; nI < 256; nI++)
	{
		switch(m_nColor)
		{
		case COLOR_R:   // 
			penSolid.CreatePen(PS_SOLID, 0, RGB(nI, 0, 0));
			break;
		case COLOR_G:   // 
			penSolid.CreatePen(PS_SOLID, 0, RGB(0, nI, 0));
			break;
		case COLOR_B:   // 
			penSolid.CreatePen(PS_SOLID, 0, RGB(0, 0, nI));
			break;
		default: // Px// F// ʓx
			penSolid.CreatePen(PS_SOLID, 0, RGB(nI, nI, nI));
		}

		dc.SelectObject(&penSolid);

		point.x = nI + pntOrigin.x + 2;
		point.y = pntOrigin.y + 144;
		dc.MoveTo(point);
		point.y -= 10;
		dc.LineTo(point);

		dc.SelectObject(pOldPen);
		penSolid.DeleteObject(); 
	}


	// FI
	switch(m_nColor)
	{
	case COLOR_R:   // 
		penSolidRed.CreatePen(PS_SOLID, 0, RGB(255, 0, 0));
		pOldPen = dc.SelectObject(&penSolidRed);
		break;
	case COLOR_G:   // 
		penSolidGreen.CreatePen(PS_SOLID, 0, RGB(0, 255, 0));
		pOldPen = dc.SelectObject(&penSolidGreen);
		break;
	case COLOR_B:   // 
		penSolidBlue.CreatePen(PS_SOLID, 0, RGB(0, 0, 255));
		pOldPen = dc.SelectObject(&penSolidBlue);
		break;
	case COLOR_I:	// Px
		dc.SelectObject(&penSolidBlack);
	}

	for(nI = 0; nI < 256; nI++)
	{
		nX = nI + pntOrigin.x + 2;
		nY = pntOrigin.y + 129;
		dc.MoveTo(nX, nY);
		nY -= m_nHist[m_nColor][nI];
		dc.LineTo(nX, nY);
	}

	// put back the old objects
	dc.SelectObject(pOldPen);

	switch(m_nColor)
	{
	case COLOR_R:   // 
		penSolidRed.DeleteObject();
		break;
	case COLOR_G:   // 
		penSolidGreen.DeleteObject();
		break;
	case COLOR_B:   // 
		penSolidBlue.DeleteObject();
	}
	penSolidBlack.DeleteObject();

	dc.SelectObject(pOldBrush);
}

void CDlgHistogram::OnBnClickedOk()
{
	OnOK();
}

void CDlgHistogram::OnBnClickedButtonEnd()
{
	OnCancel();
}

void CDlgHistogram::OnBnClickedRadio(UINT nID)
{
	switch(nID)
	{
	case IDC_HISTOGRAM_RADIO_R:
		m_nColor = COLOR_R;
		break;
	case IDC_HISTOGRAM_RADIO_I:
		m_nColor = COLOR_I;
		break;
	case IDC_HISTOGRAM_RADIO_G: 
		m_nColor = COLOR_G;
		break;
	case IDC_HISTOGRAM_RADIO_B:
		m_nColor = COLOR_B;
		break;
	}

	InvalidateRect(NULL, FALSE);
}