// DlgImage.cpp : t@C
//
#include "stdafx.h"
#include "TestEx.h"
#include "DlgImage.h"


// CDlgImage _CAO

IMPLEMENT_DYNAMIC(CDlgImage, CDialog)
CDlgImage::CDlgImage(CWnd* pParent /*=NULL*/, 
					 INT nType, 
					 CMBSE5E::LPIMAGEBAG lpImage,
					 INT nWidth, 
					 INT nHeight, 
					 INT nBitPerPixel) : CDialog(CDlgImage::IDD, pParent)
{
	m_bAdjust = (nType == BINALIZE)? TRUE : FALSE;
	m_lpBSE	= &theApp.m_BSE;
	m_lpImageBag = lpImage;
	m_lpImageBagForPaint = NULL;
	m_nHeight	= nHeight;
	m_nType		= nType;
	m_nWidth	= nWidth;


	// l
	m_binalize.nBaseColor = CMBSE5E::decBaseI;
	m_binalize.nNoise = CMBSE5E::decOpMakeNoise;
	m_binalize.nThreshold = 0;

	// RgXg
	m_contrast.nBaseColor = CMBSE5E::colorRGB;
	m_contrast.nLevel = 0;
	SecureZeroMemory(&m_adjContrast, sizeof(CMBSE5E::ADC_ADJUSTMENT));
	m_adjContrast.nBottom = m_nHeight;
	m_adjContrast.nRight  = m_nWidth;

	// 掿
	SecureZeroMemory(&m_quality, sizeof(QUALITY_VALUE));
	SecureZeroMemory(&m_adjQuality, sizeof(CMBSE5E::ADQ_ADJUSTMENT));
	m_adjQuality.nBottom = m_nHeight;
	m_adjQuality.nRight = m_nWidth;
			
	// tB^[
	m_function.nFunctions = CDlgImage::NO_ADJUST;
	SecureZeroMemory(&m_adjFilter, sizeof(CMBSE5E::FLT_ADJUSTMENT));
	m_adjFilter.nBottom = m_nHeight;
	m_adjFilter.nRight  = m_nWidth;
	
	// Rs[p
	SecureZeroMemory(&m_CopyParams, sizeof(CMBSE5E::CPY_PARAMS));
	m_CopyParams.nBitPerPixel = nBitPerPixel;
	m_CopyParams.nDestHeight  = m_nHeight;
	m_CopyParams.nDestWidth   = m_nWidth;
	m_CopyParams.nSrcRight    = m_nWidth;
	m_CopyParams.nSrcBottom   = m_nHeight;
	m_CopyParams.nMagX        = m_CopyParams.nMagY = 1.0;

	// {^
	m_bmpEnd.LoadBitmap(IDB_END);

	// Slider p
	LoadString(	theApp.m_hInstance,
				(m_nType == CDlgImage::BINALIZE)? IDS_DLG_IMAGE_TEXT05 : IDS_DLG_IMAGE_TEXT06,
				m_szSlider,
				SLIDER_TEXT_SIZE	);
}

CDlgImage::~CDlgImage()
{
	m_bmpEnd.DeleteObject();
	m_lpBSE->beDestroyImage(m_lpImageBagForPaint);
}

void CDlgImage::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_IMAGE_BUTTON_END, m_btnEnd);
	DDX_Control(pDX, IDC_IMAGE_CHECK1, m_check1);
	DDX_Control(pDX, IDC_IMAGE_COMBO_CHANNEL, m_cmbChannel);
	DDX_Control(pDX, IDC_IMAGE_EDIT_COLOR, m_edtColor);
	DDX_Control(pDX, IDC_IMAGE_EDIT_COLOR_DISTANCE, m_edtColorDistance);
	DDX_Control(pDX, IDC_IMAGE_SLIDER0, m_slider0);
	DDX_Control(pDX, IDC_IMAGE_SLIDER1, m_slider1);
	DDX_Control(pDX, IDC_IMAGE_SLIDER2, m_slider2);
	DDX_Control(pDX, IDC_IMAGE_STATIC_CAHNNEL, m_labChannel);
	DDX_Control(pDX, IDC_IMAGE_STATIC_COLOR, m_labColor);
	DDX_Control(pDX, IDC_IMAGE_STATIC_COLOR_DISTANCE, m_labDistance);
	DDX_Control(pDX, IDC_IMAGE_STATIC_SLIDER0, m_labSlider0);
	DDX_Control(pDX, IDC_IMAGE_STATIC_SLIDER0N, m_labSlider0n);
	DDX_Control(pDX, IDC_IMAGE_STATIC_SLIDER1, m_labSlider1);
	DDX_Control(pDX, IDC_IMAGE_STATIC_SLIDER1N, m_labSlider1n);
	DDX_Control(pDX, IDC_IMAGE_STATIC_SLIDER2, m_labSlider2);
	DDX_Control(pDX, IDC_IMAGE_STATIC_SLIDER2N, m_labSlider2n);
	DDX_Control(pDX, IDC_IMAGE_STATIC_TITLE, m_labTitle);
}

BEGIN_MESSAGE_MAP(CDlgImage, CDialog)
	ON_BN_CLICKED(IDC_IMAGE_BUTTON_END, OnBnClickedButtonEnd)
	ON_BN_CLICKED(IDC_IMAGE_BUTTON_RESET, OnBnClickedButtonReset)
	ON_BN_CLICKED(IDC_IMAGE_CHECK1, &CDlgImage::OnBnClickedImageCheck1)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_CBN_SELENDOK(IDC_IMAGE_COMBO_CHANNEL, OnCbnSelendokComboChannel)
	ON_WM_HSCROLL()
	ON_WM_PAINT()
	ON_WM_RBUTTONUP()
END_MESSAGE_MAP()


// CDlgImage bZ[W nh

BOOL CDlgImage::OnInitDialog()
{
	CDialog::OnInitDialog();

	TCHAR szT[64];
	INT	  nResourse;

	// \ʒu
	m_nOx = (INT)((DOUBLE)(CDlgImage::SIZE_X - m_nWidth) / 2.0) + 8;
	m_nOy = (INT)((DOUBLE)(CDlgImage::SIZE_Y - m_nHeight) / 2.0) + 44;

	// {^
	m_btnEnd.SetBitmap(m_bmpEnd);
	m_cmbChannel.SetCurSel(3);

	if(m_nType == CDlgImage::BINALIZE)
	{
		// ^Cg
		LoadString(theApp.m_hInstance, IDS_DLG_IMAGE_TITLE_BINALIZE, szT, 64);
		m_labTitle.SetWindowText(szT);

		// `l
		m_cmbChannel.SetCurSel(0);

		// XC_[
		m_slider0.ShowWindow(SW_HIDE);

		m_slider1.SetRangeMax(255, FALSE);
		m_slider1.SetRangeMin(0, TRUE);
		m_slider1.SetPageSize(1);
		m_slider1.SetPos(0);
		m_slider1.SetWindowText(_T("0"));

		m_slider2.ShowWindow(SW_HIDE);

		// 
		m_labSlider0n.ShowWindow(SW_HIDE);
		m_labSlider0.ShowWindow(SW_HIDE);

		m_labSlider1n.SetWindowText(m_szSlider);
		LoadString(theApp.m_hInstance, IDS_DLG_IMAGE_TEXT01, szT, 64);
		m_labSlider1.SetWindowText(szT);

		m_labSlider2n.ShowWindow(SW_HIDE);
		m_labSlider2.ShowWindow(SW_HIDE);
		m_labColor.ShowWindow(SW_HIDE);
		m_labDistance.ShowWindow(SW_HIDE);

		// eLXg{bNX
		m_edtColor.ShowWindow(SW_HIDE);
		m_edtColorDistance.ShowWindow(SW_HIDE);		

		// `FbNX
		LoadString(theApp.m_hInstance, IDS_DLG_IMAGE_TEXT12, szT, 64);
		m_check1.SetWindowText(szT);
		m_check1.SetCheck(BST_CHECKED);
		m_check1.ShowWindow(SW_SHOW);
	}
	else if(m_nType == CDlgImage::CONTRAST)
	{
		// ^Cg
		LoadString(theApp.m_hInstance, IDS_DLG_IMAGE_TITLE_CONTRAST, szT, 64);
		m_labTitle.SetWindowText(szT);

		// `l
		m_cmbChannel.SetCurSel(0);

		// XC_[
		m_slider0.ShowWindow(SW_HIDE);

		m_slider1.SetRangeMax(100, FALSE);
		m_slider1.SetRangeMin(-100, TRUE);
		m_slider1.SetPageSize(1);
		m_slider1.SetPos(0);
		m_slider1.SetWindowText(_T("1"));

		m_slider2.ShowWindow(SW_HIDE);

		// 
		m_labSlider0n.ShowWindow(SW_HIDE);
		m_labSlider0.ShowWindow(SW_HIDE);

		m_labSlider1n.SetWindowText(m_szSlider);
		LoadString(theApp.m_hInstance, IDS_DLG_IMAGE_TEXT04, szT, 64);
		m_labSlider1.SetWindowText(szT);

		m_labSlider2n.ShowWindow(SW_HIDE);
		m_labSlider2.ShowWindow(SW_HIDE);
		m_labColor.ShowWindow(SW_HIDE);
		m_labDistance.ShowWindow(SW_HIDE);

		// eLXg{bNX
		m_edtColor.ShowWindow(SW_HIDE);
		m_edtColorDistance.ShowWindow(SW_HIDE);
	}
	else if(m_nType == CDlgImage::QUALITY) 
	{
		// ^Cg
		LoadString(theApp.m_hInstance, IDS_DLG_IMAGE_TITLE_QUALITY, szT, 64);
		m_labTitle.SetWindowText(szT);

		// `l
		m_labChannel.ShowWindow(SW_HIDE);
		m_cmbChannel.ShowWindow(SW_HIDE);

		// XC_[
		m_slider0.SetRangeMax(100, FALSE);
		m_slider0.SetRangeMin(-100, TRUE);
		m_slider0.SetPageSize(1);
		m_slider0.SetPos(0);
		m_slider0.SetWindowText(_T("0"));

		m_slider1.SetRangeMax(180, FALSE);
		m_slider1.SetRangeMin(-180, TRUE);
		m_slider1.SetPageSize(1);
		m_slider1.SetPos(0);
		m_slider1.SetWindowText(_T("1"));

		m_slider2.SetRangeMax(100, FALSE);
		m_slider2.SetRangeMin(-100, TRUE);
		m_slider2.SetPageSize(1);
		m_slider2.SetPos(0);
		m_slider2.SetWindowText(_T("2"));

		// 
		m_edtColor.SetWindowText(_T("0"));
		wsprintf(szT, _T("%d"), DEFAULT_DISTANCE);
		m_edtColorDistance.SetWindowText(szT);

		// 
		nResourse = IDS_DLG_IMAGE_TEXT07;

		m_labSlider0n.SetWindowText(m_szSlider);
		LoadString(theApp.m_hInstance, nResourse, szT, 64);
		m_labSlider0.SetWindowText(szT);

		m_labSlider1n.SetWindowText(m_szSlider);
		LoadString(theApp.m_hInstance, ++nResourse, szT, 64);
		m_labSlider1.SetWindowText(szT);

		m_labSlider2n.SetWindowText(m_szSlider);
		LoadString(theApp.m_hInstance, ++nResourse, szT, 64);
		m_labSlider2.SetWindowText(szT);

		m_labColor.SetWindowText(m_szSlider);
		LoadString(theApp.m_hInstance, ++nResourse, szT, 64);
		m_labColor.SetWindowText(szT);

		m_labDistance.SetWindowText(m_szSlider);
		LoadString(theApp.m_hInstance, ++nResourse, szT, 64);
		m_labDistance.SetWindowText(szT);
	}
	else if(m_nType == CDlgImage::SHADE) 
	{
		// ^Cg
		LoadString(theApp.m_hInstance, IDS_DLG_IMAGE_TITLE_SHADE, szT, 64);
		m_labTitle.SetWindowText(szT);

		// `l
		m_labChannel.ShowWindow(SW_HIDE);
		m_cmbChannel.ShowWindow(SW_HIDE);

		// XC_[
		m_slider0.ShowWindow(SW_HIDE);

		m_slider1.SetRangeMax(4, FALSE);
		m_slider1.SetRangeMin(0, TRUE);
		m_slider1.SetPageSize(1);
		m_slider1.SetPos(0);
		m_slider1.SetWindowText(_T("1"));

		m_slider2.ShowWindow(SW_HIDE);

		// 
		m_labSlider0n.ShowWindow(SW_HIDE);
		m_labSlider0.ShowWindow(SW_HIDE);

		m_labSlider1n.SetWindowText(m_szSlider);
		LoadString(theApp.m_hInstance, IDS_DLG_IMAGE_TEXT03, szT, 64);
		m_labSlider1.SetWindowText(szT);

		m_labSlider2n.ShowWindow(SW_HIDE);
		m_labSlider2.ShowWindow(SW_HIDE);
		m_labColor.ShowWindow(SW_HIDE);
		m_labDistance.ShowWindow(SW_HIDE);

		// eLXg{bNX
		m_edtColor.ShowWindow(SW_HIDE);
		m_edtColorDistance.ShowWindow(SW_HIDE);
	}
	else 
	{
		// ^Cg
		LoadString(theApp.m_hInstance, IDS_DLG_IMAGE_TITLE_SHARP, szT, 64);
		m_labTitle.SetWindowText(szT);

		// `l
		//LoadString(theApp.m_hInstance, IDS_DLG_IMAGE_TEXT0, szT, 64);
		//GetDlgItem(IDC_STATIC_CAHNNEL)->SetWindowText(szT);
		m_labChannel.ShowWindow(SW_HIDE);
		m_cmbChannel.ShowWindow(SW_HIDE);

		// XC_[
		m_slider0.ShowWindow(SW_HIDE);

		m_slider1.SetRangeMax(8, FALSE);
		m_slider1.SetRangeMin(0, TRUE);
		m_slider1.SetPageSize(1);
		m_slider1.SetPos(0);
		m_slider1.SetWindowText(_T("1"));

		m_slider2.ShowWindow(SW_HIDE);

		// 
		m_labSlider0n.ShowWindow(SW_HIDE);
		m_labSlider0.ShowWindow(SW_HIDE);

		m_labSlider1n.SetWindowText(m_szSlider);
		LoadString(theApp.m_hInstance, IDS_DLG_IMAGE_TEXT02, szT, 64);
		m_labSlider1.SetWindowText(szT);

		m_labSlider2n.ShowWindow(SW_HIDE);
		m_labSlider2.ShowWindow(SW_HIDE);
		m_labColor.ShowWindow(SW_HIDE);
		m_labDistance.ShowWindow(SW_HIDE);

		// eLXg{bNX
		m_edtColor.ShowWindow(SW_HIDE);
		m_edtColorDistance.ShowWindow(SW_HIDE);
	}

	CopyImageBag();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

void CDlgImage::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO : ɃbZ[W nh R[hǉ܂B
	// `惁bZ[W CDialog::OnPaint() ĂяoȂłB

	CMBSE5E::LPIMAGEBAG lpImage = m_lpImageBagForPaint;

	if(m_lpImageBagForPaint == NULL)
		return;


	if(m_bAdjust) 
	{
		if(m_nType == CDlgImage::BINALIZE) 
		{
			lpImage = m_lpBSE->beDecolor(	GetSafeHwnd(), 
											CMBSE5E::decModeBinary 
											| m_binalize.nBaseColor
											| m_binalize.nNoise
											| m_binalize.nThreshold
											| CMBSE5E::doNotPushInReverseBuffer,
											1, 
											CMBSE5E::noReverseBuffer,
											m_lpImageBagForPaint,
											NULL,
											NULL	);
		}
		else if(m_nType == CDlgImage::CONTRAST) 
		{
			m_lpBSE->beAdjustContrast(	GetSafeHwnd(), 
										CMBSE5E::adcAdjustManual  | CMBSE5E::doNotPushInReverseBuffer,
										&m_adjContrast,
										m_lpImageBagForPaint, 
										NULL );
		}
		else if(m_nType == CDlgImage::QUALITY)
		{
			m_lpBSE->beAdjustQuality(	GetSafeHwnd(),
										m_nFunctions | CMBSE5E::doNotPushInReverseBuffer,
										&m_adjQuality, 
										m_lpImageBagForPaint, 
										NULL	);
		}
		else 
		{
			m_lpBSE->beFilter(	GetSafeHwnd(), 
								m_function.nFunctions,
								&m_adjFilter, 
								m_lpImageBagForPaint, 
								NULL );
		}
	}

	m_lpBSE->beDrawImage(dc, m_nOx, m_nOy, m_nWidth, m_nHeight, 0, 0, SRCCOPY, lpImage);

	if(m_nType == CDlgImage::BINALIZE) 
	{
		m_lpBSE->beDestroyImage(lpImage);
	}

	// lp
	RECT rect;

	rect.left   = m_nOx - 2;
	rect.top	= m_nOy - 2;
	rect.right  = m_nOx + m_nWidth + 1;
	rect.bottom = m_nOy + m_nHeight + 1;

	dc.SelectObject(GetStockObject(BLACK_PEN));
	dc.MoveTo(rect.left,  rect.top);
	dc.LineTo(rect.right, rect.top);
	dc.LineTo(rect.right, rect.bottom);
	dc.LineTo(rect.left,  rect.bottom);
	dc.LineTo(rect.left,  rect.top);
}

void CDlgImage::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	if(nSBCode == TB_ENDTRACK)
	{
		TCHAR	szT[32];
		INT		nP;

		EnableWindow(FALSE);


		CSliderCtrl *lpSlider = (CSliderCtrl*)pScrollBar;
		nP = lpSlider->GetPos();
		

		switch(m_nType)
		{
		case CDlgImage::BINALIZE: 

			if(nP == 0)
				wsprintf(szT, _T("%s"), m_szSlider);
			else 
				wsprintf(szT, _T("%d"), nP);
		
			m_labSlider1n.SetWindowText(szT);
			
			m_binalize.nThreshold = nP;

			break;

		case CDlgImage::CONTRAST: 
		
			if(nP == 0)
			{
				wsprintf(szT, _T("%s"), m_szSlider);
				m_bAdjust = FALSE;
			}
			else
			{
				wsprintf(szT, _T("%d"), nP);
				m_bAdjust = TRUE;
			}

			m_labSlider1n.SetWindowText(szT);
			
			m_contrast.nLevel = nP;
			m_adjContrast.nLevel = nP;

			break;

		case CDlgImage::QUALITY:
		
			TCHAR szN[4];
			TCHAR szColorDistance[16];
			

			if(nP == 0)
				wsprintf(szT, _T("%s"), m_szSlider);
			else 
				wsprintf(szT, _T("%d"), nP);

			lpSlider->GetWindowText(szN, 32);
		
			if(lstrcmpi(szN, _T("0")) == 0) 
			{
				m_labSlider0n.SetWindowText(szT);
				m_adjQuality.nIntensity = m_quality.nIntensity = nP;
			}
			else if(lstrcmpi(szN, _T("1")) == 0) 
			{
				m_labSlider1n.SetWindowText(szT);
				m_adjQuality.nHeu = m_quality.nHue = nP;
			}
			else if(lstrcmpi(szN, _T("2")) == 0)
			{
				m_labSlider2n.SetWindowText(szT);
				m_adjQuality.nSaturation = m_quality.nSaturation = nP;
			}

			m_edtColorDistance.GetWindowText(szColorDistance, 16);
			m_adjQuality.nColorDistance = _ttoi(szColorDistance);

			m_nFunctions = (m_adjQuality.dwColor == 0)? CMBSE5E::adqOptAll : CMBSE5E ::adqOptFarDistance;
			
			if(m_quality.nIntensity == 0 && m_quality.nHue == 0 && m_quality.nSaturation == 0)
				m_bAdjust = FALSE;
			else
				m_bAdjust = TRUE;

			break;

		case CDlgImage::SHADE:
		
			if(nP == 0)
				wsprintf(szT, _T("%s"), m_szSlider);
			else 
				wsprintf(szT, _T("%d"), nP);

			m_labSlider1n.SetWindowText(szT);

			m_bAdjust = TRUE;

			if(nP == 4)	
				m_function.nFunctions = CMBSE5E::fltMoovingAverage4;
			else if(nP == 3)	
				m_function.nFunctions = CMBSE5E::fltMoovingAverage3;
			else if(nP == 2)	
				m_function.nFunctions = CMBSE5E::fltMoovingAverage2;
			else if(nP == 1)	
				m_function.nFunctions = CMBSE5E::fltMoovingAverage1;
			else 
			{		
				m_function.nFunctions = CDlgImage::NO_ADJUST;
				m_bAdjust = FALSE;
			}

			break;

		case SHARP:
			
			if(nP == 0)
				wsprintf(szT, _T("%s"), m_szSlider);
			else 
				wsprintf(szT, _T("%d"), nP);

			m_labSlider1n.SetWindowText(szT);

			m_bAdjust = TRUE;

			if(nP == 8)	
				m_function.nFunctions = CMBSE5E::fltSharpening1;
			else if(nP == 7)	
				m_function.nFunctions = CMBSE5E::fltSharpening2;
			else if(nP == 6)	
				m_function.nFunctions = CMBSE5E::fltSharpening3;
			else if(nP == 5)	
				m_function.nFunctions = CMBSE5E::fltSharpening4;
			else if(nP == 4)	
				m_function.nFunctions = CMBSE5E::fltSharpening5;
			else if(nP == 3)	
				m_function.nFunctions = CMBSE5E::fltSharpening6;
			else if(nP == 2)	
				m_function.nFunctions = CMBSE5E::fltSharpening7;
			else if(nP == 1)	
				m_function.nFunctions = CMBSE5E::fltSharpening8;
			else 
			{			
				m_function.nFunctions = CDlgImage::NO_ADJUST;
				m_bAdjust = FALSE;
			}

			break;
		}

		// C[WRs[
		CopyImageBag();

		EnableWindow(TRUE);
	}

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CDlgImage::OnRButtonUp(UINT nFlags, CPoint point)
{
	// TODO : ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	TCHAR szColor[16];


	if(m_nType == CDlgImage::QUALITY)
	{
		//INT nOx = (INT)((DIM_SIZE_X - (DOUBLE)m_nWidth) / (DOUBLE)2.0) + 8;
		//INT nOy = (INT)((DIM_SIZE_Y - (DOUBLE)m_nHeight) / (DOUBLE)2.0) + 44;
		INT nX  = point.x - m_nOx;
		INT nY  = point.y - m_nOy;

		if(nX > 0 && nX < m_nWidth && nY > 0 && nY < m_nHeight) 
		{
			m_adjQuality.dwColor = m_lpBSE->beGetColor(m_lpImageBag, nX, nY);		
			wsprintf(szColor, _T("%x"), m_adjQuality.dwColor);
			m_edtColor.SetWindowText(szColor);
		}
	}

	CDialog::OnRButtonUp(nFlags, point);
}

void CDlgImage::OnBnClickedButtonReset()
{
	// XC_[
	m_slider0.SetPos(0);
	m_slider1.SetPos(0);
	m_slider2.SetPos(0);
	
	// 
	m_labSlider0n.SetWindowText(m_szSlider);
	m_labSlider1n.SetWindowText(m_szSlider);
	m_labSlider2n.SetWindowText(m_szSlider);

	// `l
	m_cmbChannel.SetCurSel(0);

	// 
	TCHAR szTmp[16];

	switch(m_nType)
	{
	case CDlgImage::BINALIZE: 

		m_binalize.nBaseColor = CMBSE5E::decBaseI;
		m_binalize.nNoise = CMBSE5E::decOpMakeNoise;
		m_binalize.nThreshold = 0;
		m_slider1.SetPos(m_binalize.nThreshold);
		m_check1.SetCheck(BST_CHECKED);

		m_bAdjust = TRUE;

		break;
	
	case CDlgImage::CONTRAST:
		
		// RgXg
		m_contrast.nBaseColor = CMBSE5E::colorRGB;
		m_contrast.nLevel = 0;
		SecureZeroMemory(&m_adjContrast, sizeof(CMBSE5E::ADC_ADJUSTMENT));
		m_adjContrast.nBottom = m_nHeight;
		m_adjContrast.nRight  = m_nWidth;

		m_bAdjust = FALSE;

		break;

	case CDlgImage::QUALITY:
		
		// 掿
		SecureZeroMemory(&m_quality, sizeof(QUALITY_VALUE));
		SecureZeroMemory(&m_adjQuality, sizeof(CMBSE5E::ADQ_ADJUSTMENT));
		m_adjQuality.nBottom = m_nHeight;
		m_adjQuality.nRight = m_nWidth;
		m_edtColor.SetWindowText(_T("0"));
		wsprintf(szTmp, _T("%d"), DEFAULT_DISTANCE);
		m_edtColorDistance.SetWindowText(szTmp);

		m_bAdjust = FALSE;

		break;

	default:
	
		// tB^[
		m_function.nFunctions = CDlgImage::NO_ADJUST;
		SecureZeroMemory(&m_adjFilter, sizeof(CMBSE5E::FLT_ADJUSTMENT));
		m_adjFilter.nBottom = m_nHeight;
		m_adjFilter.nRight  = m_nWidth;

		m_bAdjust = FALSE;
	}

	CopyImageBag();
}

void CDlgImage::OnCbnSelendokComboChannel()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B

	switch(m_nType)
	{
	case CDlgImage::BINALIZE: 
		switch(m_cmbChannel.GetCurSel())
		{
		case 1:
			m_binalize.nBaseColor = CMBSE5E::decBaseR;
			break;
		case 2:
			m_binalize.nBaseColor = CMBSE5E::decBaseG;
			break;
		case 3:
			m_binalize.nBaseColor = CMBSE5E::decBaseB;
			break;
		default:
			m_binalize.nBaseColor = CMBSE5E::decBaseI;
		}
		break;
	case CDlgImage::CONTRAST:
		m_contrast.nBaseColor = m_cmbChannel.GetCurSel();
		m_adjContrast.nBaseColor = m_contrast.nBaseColor;
		break;
	}
	
	m_bAdjust = TRUE;
	CopyImageBag();
}

void CDlgImage::OnBnClickedImageCheck1()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	m_binalize.nNoise = (m_check1.GetCheck() == BST_CHECKED)? CMBSE5E::decOpMakeNoise : CMBSE5E::decOpNoneNoise;
	InvalidateRect(NULL, TRUE); // \XV
}

void CDlgImage::OnBnClickedOk()
{
	OnOK();
}

void CDlgImage::OnBnClickedCancel()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	m_function.nFunctions = m_binalize.nThreshold = CDlgImage::NO_ADJUST;
	OnCancel();
}

void CDlgImage::OnBnClickedButtonEnd()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	m_function.nFunctions = m_binalize.nThreshold = CDlgImage::NO_ADJUST;
	OnCancel();
}

int CDlgImage::GetBaseColor()
{
	if(m_nType == BINALIZE)
		return m_binalize.nBaseColor;
	else
		return m_contrast.nBaseColor;
}

void CDlgImage::CopyImageBag()
{
	// C[WRs[
	m_lpBSE->beDestroyImage(m_lpImageBagForPaint);
	m_lpImageBagForPaint = m_lpBSE->beCreateImage(	CMBSE5E::noReverseBuffer,
													m_nWidth,
													m_nHeight,
													m_CopyParams.nBitPerPixel	);

	if(m_lpImageBagForPaint != NULL) 
	{
		m_lpBSE->beCopy(	GetSafeHwnd(), 
							CMBSE5E::cpyCopy | CMBSE5E::doNotPushInReverseBuffer,
							&m_CopyParams, 
							m_lpImageBag,
							m_lpImageBagForPaint	);
	}

	InvalidateRect(NULL, TRUE); // \XV
}
