#pragma once

#include "mb5e.h"
#include "afxwin.h"
#include "afxcmn.h"


// CDlgImage _CAO
class CDlgImage : public CDialog
{
	DECLARE_DYNAMIC(CDlgImage)

public:
	// WRXgN^
	CDlgImage(	CWnd* pParent = NULL, 
				INT nType = 0, 
				CMBSE5E::LPIMAGEBAG lpImage = NULL,
				INT nWidth = 0, 
				INT nHeight = 0,
				INT nBitPerPixel = 0	);   
	virtual ~CDlgImage();

// _CAO f[^
	enum { IDD = IDD_IMAGE };

protected:
	afx_msg void OnBnClickedButtonEnd();
	afx_msg void OnBnClickedButtonReset();
	afx_msg void OnBnClickedCancel();
	afx_msg void OnBnClickedImageCheck1();
	afx_msg void OnBnClickedOk();
	afx_msg void OnCbnSelendokComboChannel();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnPaint();
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	virtual BOOL OnInitDialog();
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	DECLARE_MESSAGE_MAP()

public:
	static const int NO_ADJUST	= -1;
	static const int BINALIZE	= 0;
	static const int CONTRAST	= 1;
	static const int QUALITY	= 2;
	static const int SHADE		= 3;
	static const int SHARP		= 4;

	static const int SIZE_X		= 440;
	static const int SIZE_Y		= 260;

	
	typedef struct
	{
		INT	nBaseColor;
		INT nNoise;
		INT nThreshold;
	} BINALIZE_VALUE, *LPBINALIZE_VALUE;

	typedef struct
	{
		INT nLevel;
		INT	nBaseColor;
	} CONTRAST_VALUE, *LPCONTRAST_VALUE;

	typedef struct
	{
		INT nFunctions;
	} FUNCTION, *LPFUNCTION;

	typedef struct
	{
		INT		nIntensity;
		INT		nHue;
		INT		nSaturation;
		DWORD	dwColor;
		INT		nColorDistance;
	} QUALITY_VALUE, *LPQUALITY_VALUE;


	int GetBaseColor();

	int GetColorDistance() { return m_adjQuality.nColorDistance; };
	int GetFunctions() { return m_function.nFunctions; };
	int GetHue() { return m_quality.nHue; };
	int GetIntensity() { return m_quality.nIntensity; };
	int GetLevel() { return m_contrast.nLevel; };
	int GetNoise() { return m_binalize.nNoise; };
	int GetSaturation() { return m_quality.nSaturation; };
	int GetThrethold() { return m_binalize.nThreshold; };
	unsigned long GetColor() { return m_adjQuality.dwColor; };

private:
	static const int DEFAULT_DISTANCE = 8192;
	static const int SLIDER_TEXT_SIZE = 16;

	CBEsergeant* m_lpBSE;
	CBitmap		m_bmpEnd;
	CButton		m_check1;
	CButton		m_btnEnd;
	CComboBox	m_cmbChannel;
	CEdit		m_edtColor;
	CEdit		m_edtColorDistance;
	CSliderCtrl m_slider0;
	CSliderCtrl m_slider1;
	CSliderCtrl m_slider2;
	CStatic m_labChannel;
	CStatic m_labColor;
	CStatic m_labDistance;
	CStatic m_labSlider0;
	CStatic m_labSlider0n;
	CStatic m_labSlider1;
	CStatic m_labSlider1n;
	CStatic m_labSlider2;
	CStatic m_labSlider2n;
	CStatic m_labTitle;

	BOOL	m_bAdjust;
	INT		m_nFunctions;
	INT		m_nOx;
	INT		m_nOy;
	INT		m_nHeight;
	INT		m_nType;
	INT		m_nWidth;
	CMBSE5E::LPIMAGEBAG	m_lpImageBagForPaint;
	CMBSE5E::LPIMAGEBAG	m_lpImageBag;
	TCHAR m_szSlider[SLIDER_TEXT_SIZE];

	BINALIZE_VALUE		m_binalize;
	CONTRAST_VALUE		m_contrast;
	FUNCTION			m_function;
	CMBSE5E::ADC_ADJUSTMENT	m_adjContrast;
	CMBSE5E::ADQ_ADJUSTMENT	m_adjQuality;
	CMBSE5E::CPY_PARAMS		m_CopyParams;
	CMBSE5E::FLT_ADJUSTMENT	m_adjFilter;
	QUALITY_VALUE		m_quality;

	void CopyImageBag();		
};
