// Dialog2.cpp : t@C
//
#include "stdafx.h"
#include "TestEx.h"
#include "DlgSlider.h"


// CDlgSlider _CAO

IMPLEMENT_DYNAMIC(CDlgSlider, CDialog)
CDlgSlider::CDlgSlider(	CWnd*	 pParent /*=NULL*/, 
						int		 nMode, 
						int		 nMin, 
						int		 nMax, 
						int		 nStep,
						int		 nPos,
						int		 nOffset, 
						int		 nFloat, 
						int		 nMag,
						LPCTSTR lpLetter ) : CDialog(CDlgSlider::IDD, pParent)
{
	m_nMode  = nMode;
	m_nMax	 = nMax;
	m_nMin	 = nMin;
	m_nPos	 = nPos;
	m_nStep	 = nStep;
	m_nMag	 = nMag;
	m_nValue = 0;
	m_nOffset= nOffset;
	m_nFloat = nFloat;
	lstrcpy(m_szLetter, lpLetter);

	// {^
	m_bmpEnd.LoadBitmap(IDB_END);
}

CDlgSlider::~CDlgSlider()
{
}

void CDlgSlider::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SLIDER_SLIDER1, m_Slider1);
	DDX_Control(pDX, IDC_SLIDER_STATIC_VALUE, m_labValue);
	DDX_Control(pDX, IDC_SLIDER_BUTTON_END, m_btnEnd);
	DDX_Control(pDX, IDC_SLIDER_STATIC_TITLE, m_labTitle);
	DDX_Control(pDX, IDOK, m_btnOk);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
}

BEGIN_MESSAGE_MAP(CDlgSlider, CDialog)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_SLIDER_BUTTON_END, OnBnClickedButtonEnd)
END_MESSAGE_MAP()


// CDlgSlider bZ[W nh

BOOL CDlgSlider::OnInitDialog()
{
	CDialog::OnInitDialog();

	ShowWindow(SW_HIDE);

	if(m_nMode == OK) 
	{
		m_btnCancel.SetWindowPos(NULL, 0, 0, 0, 0, SWP_HIDEWINDOW);
		m_btnOk.SetWindowPos(	&CWnd::wndTop, 
								361, 95, 0, 0, 
								SWP_SHOWWINDOW | SWP_NOSIZE	);
	}

	// {^
	m_btnEnd.SetBitmap(m_bmpEnd);

	// slider
	m_Slider1.SetRangeMax(m_nMax, TRUE);
	m_Slider1.SetRangeMin(m_nMin, TRUE);
	m_Slider1.SetPageSize(m_nStep);
	m_Slider1.SetPos(m_nPos);
	m_nValue=m_Slider1.GetPos();
	//SetWindowText(m_szLetter);
	m_labTitle.SetWindowText(m_szLetter);

	SetLavelValue();

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

int CDlgSlider::GetValue()
{
	return m_nValue;
}

void CDlgSlider::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	if(nSBCode == TB_ENDTRACK)
	{
		m_nValue = m_Slider1.GetPos();
		SetLavelValue();
	}

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CDlgSlider::OnBnClickedButtonEnd()
{
	OnCancel();
}

void CDlgSlider::SetLavelValue()
{
	TCHAR szValue[32];
	CTestExApp::REAL real;

	if(m_nFloat != 0)
	{
		theApp.FloatToReal((DOUBLE)(m_nValue - m_nOffset) / (DOUBLE)m_nFloat * m_nMag, &real);
		wsprintf(szValue, _T("%d.%d"), real.nWhole, real.nFraction);
	}
	else 
	{
		wsprintf(szValue, _T("%d"), (m_nValue - m_nOffset) * m_nMag);
	}

	m_labValue.SetWindowText(szValue);
}
