// DlgTone.cpp : t@C
//
#include "stdafx.h"
#include <math.h>
#include "TestEx.h"
#include "DlgTone.h"


// CDlgTone _CAO

IMPLEMENT_DYNAMIC(CDlgTone, CDialog)
CDlgTone::CDlgTone(BYTE *lpMappingData, INT *lpBase, INT nHist[6][256], CWnd* pParent /*=NULL*/)
	: CDialog(CDlgTone::IDD, pParent)
{
	// qXgf[^Rs[
	CopyMemory(m_nHist, nHist, sizeof(m_nHist));
	m_nColor	= CMBSE5E::hstI;
	m_nMap		= 0;
	m_lpszM		= lpMappingData;
	m_lpBase	= lpBase;

	//
	//// }bsOf[^쐬
	//
	INT nI;

	for(nI = 0; nI < 256; nI++) 
	{
		m_szMappingData[MAP_BRIGHT0][nI] = (BYTE)(255.0 * pow(nI / 255.0, 0.8));
	}
	for(nI = 0; nI < 256; nI++)
	{
		m_szMappingData[MAP_BRIGHT1][nI] = (BYTE)(255.0 * pow(nI / 255.0, 0.6));
	}
	for(nI = 0; nI < 256; nI++)
	{
		m_szMappingData[MAP_BRIGHT2][nI] = (BYTE)(255.0 * pow(nI / 255.0, 0.4));
	}
	//
	for(nI = 0; nI < 256; nI++) 
	{
		m_szMappingData[MAP_DARK0][nI] = (BYTE)(255.0 * pow(nI / 255.0, 1.2));
	}
	for(nI = 0; nI < 256; nI++)
	{
		m_szMappingData[MAP_DARK1][nI] = (BYTE)(255.0 * pow(nI / 255.0, 1.6));
	}
	for(nI = 0; nI < 256; nI++)
	{
		m_szMappingData[MAP_DARK2][nI] = (BYTE)(255.0 * pow(nI / 255.0, 2.0));
	}
	// 
	for(nI = 0; nI < 128; nI++) 
	{
		m_szMappingData[MAP_MIDDLE][nI] = (BYTE)(2.0 * 255.0 * pow(nI / 255.0, 2.0));
	}
	for(nI = 128; nI < 256; nI++) 
	{
		m_szMappingData[MAP_MIDDLE][nI] = (BYTE)(255 / 2 * (1 + sqrt((2.0 * nI - 255.0) / 255.0)));
	}
	// 
	for(nI = 0; nI < 256; nI++)
	{
		m_szMappingData[MAP_REVERSE][nI] = (BYTE)(-nI + 255);
	}

	//
	nI = 0;
	for(int nID = IDS_DLG_TONE_BRIGHT0; nID <= IDS_DLG_TONE_REVERSE; nID++)
	{
		LoadString(theApp.m_hInstance, nID, m_szMappingText[nI], 64);
		nI++;
	}

	// {^
	m_bmpEnd.LoadBitmap(IDB_END);
}

CDlgTone::~CDlgTone()
{
	m_bmpEnd.DeleteObject();
}

void CDlgTone::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TONE_BUTTON_END, m_btnEnd);
	DDX_Control(pDX, IDC_TONE_BUTTON_CHANNEL, m_btnChannel);
	DDX_Control(pDX, IDC_TONE_BUTTON_TONE, m_btnTone);
	DDX_Control(pDX, IDC_TONE_CHECK_CONSTANT_I, m_chkConstantI);
	DDX_Control(pDX, IDC_TONE_STATIC_TITLE, m_labTitle);
}


BEGIN_MESSAGE_MAP(CDlgTone, CDialog)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_TONE_BUTTON_CHANNEL, OnBnClickedButtonChannel)
	ON_BN_CLICKED(IDC_TONE_BUTTON_TONE, OnBnClickedButtonTone)
	ON_BN_CLICKED(IDC_TONE_BUTTON_END, OnBnClickedButtonEnd)
	ON_WM_PAINT()
END_MESSAGE_MAP()


// CDlgTone bZ[W nh

BOOL CDlgTone::OnInitDialog()
{
	CDialog::OnInitDialog();

	// _CAO^Cg
	TCHAR szTitle[64];
	LoadString(theApp.m_hInstance, IDS_DLG_TONE_TITLE, szTitle, 64);
	m_labTitle.SetWindowText(szTitle);

	// {^
	m_btnEnd.SetBitmap(m_bmpEnd);
	m_btnTone.SetWindowText(m_szMappingText[m_nMap]);

	//@
	CenterWindow();

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

void CDlgTone::OnPaint()
{
	CPaintDC dc(this); // device context for painting


	static const RECT	rcDraw		= { 10, 45, 258, 258 };	// `ʒuTCY
	static const RECT	rcBitmap	= { 0, 0, 258, 258 };	// `̈


	// ꎞIcb쐬
	CDC		dcTmp;
	CBitmap bmp;

	dcTmp.CreateCompatibleDC(&dc);
	bmp.CreateCompatibleBitmap(&dc, rcBitmap.right, rcBitmap.bottom);
	dcTmp.SelectObject(&bmp);

	// y
	CPen penSolidGray;
	CPen penSolidBlack;

	penSolidGray.CreatePen(PS_SOLID, 0, RGB(210, 210, 210));
	penSolidBlack.CreatePen(PS_SOLID, 0, RGB(0, 0, 0));

	// `̈
	dcTmp.SelectObject(GetStockObject(WHITE_PEN));
	dcTmp.Rectangle(&rcBitmap);

	// g
	dcTmp.SelectObject(&penSolidBlack);
	dcTmp.MoveTo(0, rcBitmap.bottom - 1);
	dcTmp.LineTo(rcBitmap.right - 1, rcBitmap.bottom - 1);
	dcTmp.LineTo(rcBitmap.right - 1, 0);
	dcTmp.LineTo(0, 0);
	dcTmp.LineTo(0, rcBitmap.bottom - 1);

	// qXgO
	INT	nX;
	INT	nXx, nYy;

	dcTmp.SelectObject(&penSolidGray);
	nYy = rcBitmap.bottom - 2;
	for(nX = 0; nX < 256; nX++)
	{
		nXx = nX + 1;
		dcTmp.MoveTo(nXx, nYy);
		dcTmp.LineTo(nXx, nYy - m_nHist[m_nColor][nX]);
	}
	penSolidGray.DeleteObject();

	// }bsOf[^
	dcTmp.SelectObject(&penSolidBlack);
	dcTmp.MoveTo(rcBitmap.left + 1, nYy - m_szMappingData[m_nMap][0]);
	for(nX = 1; nX < 255; nX++)
	{
		dcTmp.LineTo(nX + 1, nYy - m_szMappingData[m_nMap][nX]);
	}

	
	// `
	dc.StretchBlt(	rcDraw.left, rcDraw.top, rcDraw.right, rcDraw.bottom, 
					&dcTmp, 
					rcBitmap.left, rcBitmap.top, rcBitmap.right,rcBitmap.bottom, 
					SRCCOPY	);

	// `惁bZ[W CDialog::OnPaint() ĂяoȂłB
}

void CDlgTone::OnBnClickedOk()
{
	CopyMemory(m_lpszM, &m_szMappingData[m_nMap][0], 256);
	if (m_nColor == CMBSE5E::hstR)		// 
		*m_lpBase = CMBSE5E::adgR;
	else if (m_nColor == CMBSE5E::hstG)	// 
		*m_lpBase = CMBSE5E::adgG;
	else if(m_nColor == CMBSE5E::hstB) 	// 
		*m_lpBase = CMBSE5E::adgB;
	else
		*m_lpBase = CMBSE5E::adgRGB;

	if(m_chkConstantI.GetCheck() == TRUE) 
	{
		*m_lpBase = *m_lpBase | CMBSE5E::adgConstantI;
	}
	
	OnOK();
}

void CDlgTone::OnBnClickedCancel()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	OnCancel();
}

void CDlgTone::OnBnClickedButtonEnd()
{
	OnCancel();
}

void CDlgTone::OnBnClickedButtonChannel()
{
	m_nColor ++;
	m_nColor &= CMBSE5E::hstI;

  	if (m_nColor == CMBSE5E::hstR)		// 
		m_btnChannel.SetWindowText(_T("R"));
	else if (m_nColor == CMBSE5E::hstG)	// 
		m_btnChannel.SetWindowText(_T("G"));
	else if(m_nColor == CMBSE5E::hstB) 	// 
		m_btnChannel.SetWindowText(_T("B"));
	else
		m_btnChannel.SetWindowText(_T("I"));

	InvalidateRect(NULL, NULL);
}

void CDlgTone::OnBnClickedButtonTone()
{
	m_nMap++;

	if(m_nMap >= MAP_COUNT)
		m_nMap = 0;
	
	m_btnTone.SetWindowText(m_szMappingText[m_nMap]);
	
	InvalidateRect(NULL, NULL);
}