// ESergeant.cpp : t@C
//

#include "stdafx.h"
#include "ESergeant.h"


// CEsergeant

CEsergeant::CEsergeant()
{
}

CEsergeant::~CEsergeant()
{
}


// CEsergeant o֐
INT CEsergeant::eInitialize(	TW_UINT16 twMajorNum, 
								TW_UINT16 twMinorNum,
								LPCTSTR lpszManufacturer, 
								LPCTSTR lpszProductFamily, 
								LPCTSTR lpszProductName		)
{
	//
	//// Twain source manager
	//
	INT nR = failure;

	if(AreYouReady() == CMGC4E::yes) 
	{
		// TWAIN dll informations
		m_twAppID.Id = 0; // Initialize to 0 (Source Manager will assign real value)
		m_twAppID.Version.Language	= TWLG_JAPANESE;
		m_twAppID.Version.Country	= TWCY_JAPAN;
		m_twAppID.ProtocolMajor		= TWON_PROTOCOLMAJOR;
		m_twAppID.ProtocolMinor		= TWON_PROTOCOLMINOR;
		m_twAppID.SupportedGroups	= DG_IMAGE | DG_CONTROL;

		// Your app's inforamtions 
		m_twAppID.Version.MajorNum = twMajorNum;
		m_twAppID.Version.MinorNum = twMinorNum;
		wsprintfA(m_twAppID.Version.Info, "Version %d.%d", twMajorNum, twMinorNum);
		lstrcpyA (m_twAppID.Manufacturer, CT2A(lpszManufacturer));
		lstrcpyA (m_twAppID.ProductFamily, CT2A(lpszProductFamily));
		lstrcpyA (m_twAppID.ProductName, CT2A(lpszProductName));

		
		// meConnectTwainSession  fBNgw肷邩NULL no\
		nR =  ConnectTwainSession(&m_twAppID, NULL);

		if(nR != TWRC_SUCCESS)	
			nR = failure;
	}

	return nR;
}

INT CEsergeant::eDestroy(HWND hWnd)
{
	INT nR = failure;

	if(AreYouReady() == CMGC4E::yes) 
	{
		nR =  CloseSource(CMGC4E::csoAuto, hWnd);
		nR =  DisconnectTwainSession();

		if(nR != TWRC_SUCCESS)	
			nR = failure;
	}

	return nR; 
}

INT CEsergeant::eScan(HWND hWnd, BOOL bADF)
{
	//
	//// Native Mode Transfer
	//
	if(OpenSourceAndManager(hWnd, bADF) == failure) 
		return failure;


	// ǎҋ@
	UINT nR =  RequestAcquisition(	CMGC4E::rqaTmNative | CMGC4E::rqaUiShow | CMGC4E::rqaTimeOut7,
									hWnd,
									NULL	);
	
	if(nR == TWRC_SUCCESS) 
		return success;
	else
		return failure;
}

INT CEsergeant::eScan(HWND hWnd, BOOL bADF, CMGC4E::LPRQA_DLG_PARAMS lpDlgProcParams)
{
	//
	//// Memory Mode Transfer
	//
	if(OpenSourceAndManager(hWnd, bADF) == failure) 
		return failure;


	// CWP[^
	// Ǝ̂̂܂BmeRequestAcquisition  ME_RQA_UI_HIDE ɂ邱Ƃ
	TW_UINT16 twConType, twItemType, twItem; 
	TW_UINT32 twMaxSize;

	twConType	= TWON_ONEVALUE;
	twItemType	= TWTY_BOOL;
	twItem		= FALSE;
	twMaxSize	= 1;
	
	 SetCapability(MSG_SET, CAP_INDICATORS, twConType, twItemType, &twItem, twMaxSize, FALSE);

#if _DEBUG
	twConType = TWON_ONEVALUE;
	twItemType	= TWTY_UINT16;
	twItem = TWPT_RGB; //TWPT_GRAY;
	twMaxSize = 1;
	SetCapability(MSG_SET, ICAP_PIXELTYPE, twConType, twItemType, &twItem, twMaxSize, FALSE);
#endif


	/// ǎҋ@
	UINT nR = RequestAcquisition(	CMGC4E::rqaTmMemory | CMGC4E::rqaUiHide | CMGC4E::rqaTimeOut7 ,
									hWnd, 
									lpDlgProcParams	);

	return (nR == TWRC_SUCCESS)? success : failure;
}

INT CEsergeant::eScan(HWND hWnd, BOOL bADF, LPTSTR lpFileName)
{
	//
	//// Disk File Mode Transfer
	//
	if(OpenSourceAndManager(hWnd, bADF) == failure) 
		return failure;

	/// ǎҋ@
	INT nR =  RequestAcquisition(	CMGC4E::rqaTmDisk | CMGC4E::rqaUiShow | CMGC4E::rqaTimeOut7,
									hWnd, 
									lpFileName	);

	return (nR == TWRC_SUCCESS)? success : failure;
}


#if _DEBUG
INT CEsergeant::eScanForTest(HWND hWnd, BOOL bADF)
{
	//
	//// Native Mode Transfer(eXgړIƂĂ)
	//
	const INT nDoNotSetup	= 0x00000000;
	const INT nBitdepth		= 0x00000001;
	const INT nBrighetness	= 0x00000002;
	const INT nContrast		= 0x00000004;
	const INT nFilter		= 0x00000008;
	const INT nFrames		= 0x00000010;
	const INT nGamma		= 0x00000020;
	const INT nHalfTones	= 0x00000040;
	const INT nIndicators	= 0x00000080;
	const INT nLightPath	= 0x00000100;
	const INT nLightSource	= 0x00000200;
	const INT nOrientation  = 0x00000400;
	const INT nPixelType	= 0x00000800;
	
	
#if _DEBUG
	const INT nCapabilities = nDoNotSetup;
#else
	const INT nCapabilities = nDoNotSetup;
#endif


	if(OpenSourceAndManager(hWnd, bADF) == failure) 
		return failure;

			TW_UINT16	twConType;
			TW_UINT16	twItemType;
			TW_UINT32	twMaxSize = 0;
	static	TW_UINT8	twItem[1026 * CMGC4E::capMaxArray];	// sizeof(TW_STR1024) = 1026

			pTW_UINT16	ptwUint16	= (pTW_UINT16)twItem;
			pTW_UINT32	ptwUint32	= (pTW_UINT32)twItem;
			FLOAT*		lpFloat		= (FLOAT*)twItem;		// TW_FIX32floatŎg
			pTW_STR32	ptwString32	= (pTW_STR32)twItem;
	

	SecureZeroMemory(twItem, sizeof(TW_STR1024) * CMGC4E::capMaxArray);
	

	// * meGetCapability
	// bZ[W : MSG_GET/MSG_GETCURRENT/MSG_GETDEFAULT/MSG_GETFIRST/MSG_GETNEXT
	// @\ : twain.h  CAP_*/ICAP_*(CAP_AUTOFEED, ICAP_UNITS etc.)
	//
	// * meGetCapability
	// bZ[W : MSG_SET/MSG_RESET
	// @\ : twain.h  CAP_*/ICAP_*(CAP_AUTOFEED, ICAP_UNITS etc.)
	//
	//  : sv`hm@ɂgȂꍇX
	
	INT nR = TWRC_FAILURE;

	if((nCapabilities & nPixelType) == nPixelType)
	{
		twConType = TWON_DONTCARE16;	
		nR =  GetCapability(	MSG_GET, 
								ICAP_PIXELTYPE, 
								&twConType, 
								&twItemType,
								twItem, 
								&twMaxSize, 
								TRUE	);

		if(nR == TWRC_SUCCESS)
		{
			twConType = TWON_ONEVALUE;
			ptwUint16[0] = TWPT_GRAY;
			twMaxSize = 1;
			SetCapability(	MSG_SET, 
							ICAP_PIXELTYPE, 
							twConType, 
							twItemType, 
							twItem, 
							twMaxSize, 
							TRUE	);

			ptwUint16[0] = 0;

			nR =  GetCapability(	MSG_GETCURRENT, 
									ICAP_PIXELTYPE, 
									&twConType, 
									&twItemType,
									twItem, 
									&twMaxSize, 
									TRUE	);
		}
	}

	if((nCapabilities & nOrientation) == nOrientation)
	{
		twConType = TWON_DONTCARE16;	
		nR =  GetCapability(	MSG_GET, 
								ICAP_ORIENTATION, 
								&twConType, 
								&twItemType,
								twItem, 
								&twMaxSize, 
								TRUE	);
	}

	if((nCapabilities & nLightSource) == nLightSource)
	{
		twConType = TWON_DONTCARE16;	
		nR =  GetCapability(	MSG_GET, 
								ICAP_LIGHTSOURCE, 
								&twConType, 
								&twItemType,
								twItem, 
								&twMaxSize, 
								TRUE	);

		if(nR == TWRC_SUCCESS)
		{
			twConType = TWON_ONEVALUE;
			ptwUint16[0] = TWLS_BLUE;
			twMaxSize = 1;
			 SetCapability(	MSG_SET, 
							ICAP_LIGHTSOURCE, 
							twConType, 
							twItemType, 
							twItem, 
							twMaxSize, 
							TRUE	);

			ptwUint16[0] = 0;

			nR =  GetCapability(	MSG_GETCURRENT, 
									ICAP_LIGHTSOURCE, 
									&twConType, 
									&twItemType,
									twItem, 
									&twMaxSize, 
									TRUE	);
		}
	}

	if((nCapabilities & nLightPath) == nLightPath)
	{
		twConType = TWON_DONTCARE16;	
		nR =  GetCapability(	MSG_GET, 
								ICAP_LIGHTPATH, 
								&twConType, 
								&twItemType,
								twItem, 
								&twMaxSize, 
								TRUE	);
	}

	if((nCapabilities & nIndicators) == nIndicators)
	{
		// CWP[^
		twConType = TWON_DONTCARE16;	// twConType  twItemType 擾ł
		nR =  GetCapability(	MSG_GET, 
								CAP_INDICATORS, 
								&twConType, 
								&twItemType,
								twItem, 
								&twMaxSize, 
								TRUE	);

		if(nR == TWRC_SUCCESS)
		{
			twConType = TWON_ONEVALUE;
			ptwUint16[0] = TRUE;		// ޒl
			SetCapability(	MSG_SET,
							CAP_INDICATORS,
							twConType,
							twItemType,
							twItem, 
							twMaxSize,
							TRUE	);
		}
	}

	if((nCapabilities & nHalfTones) == nHalfTones)
	{
		twConType = TWON_DONTCARE16;	
		nR =  GetCapability(	MSG_GET, 
								ICAP_HALFTONES, 
								&twConType, 
								&twItemType,
								twItem, 
								&twMaxSize, 
								TRUE	);

		if(nR == TWRC_SUCCESS)
		{
			twConType = TWON_ONEVALUE;
			lstrcpyA(ptwString32, "test");
			twMaxSize = 1;
			 SetCapability(	MSG_SET, 
							ICAP_HALFTONES, 
							twConType, 
							twItemType, 
							twItem, 
							twMaxSize,
							TRUE	);

			lstrcpyA(ptwString32, "    ");		
			nR =  GetCapability(	MSG_GETCURRENT, 
									ICAP_HALFTONES, 
									&twConType, 
									&twItemType,
									twItem, 
									&twMaxSize, 
									TRUE	);
		}
	}

	if((nCapabilities & nGamma) == nGamma) 
	{
		//@K}l
		// nFloat[ME_CAP_RANGE_MIN]  Œl
		// nFloat[ME_CAP_RANGE_MAX]  ōl
		// nFloat[ME_CAP_RANGE_STEP] Xebv
		twConType = TWON_DONTCARE16;
		nR =  GetCapability(	MSG_GET, 
								ICAP_BRIGHTNESS, 
								&twConType, 
								&twItemType, 
								twItem, 
								&twMaxSize, 
								TRUE	);

		if(nR == TWRC_SUCCESS) 
		{
			twConType = TWON_ONEVALUE;
			twMaxSize = 1;
			lpFloat[0] = -1000;
			 SetCapability(MSG_SET, ICAP_BRIGHTNESS, twConType, twItemType, twItem, twMaxSize, TRUE);

			lpFloat[0] = lpFloat[1] = lpFloat[2] = lpFloat[3] = 0.0f;
			nR =  GetCapability(	MSG_GETCURRENT, 
									ICAP_BRIGHTNESS, 
									&twConType, 
									&twItemType,
									twItem, 
									&twMaxSize, 
									TRUE	);
		}
	}

	if((nCapabilities & nFrames) == nFrames)
	{
		twConType = TWON_DONTCARE16;	
		nR =  GetCapability(	MSG_GET, 
								ICAP_FRAMES, 
								&twConType, 
								&twItemType,
								twItem, 
								&twMaxSize, 
								TRUE	);

		if(nR == TWRC_SUCCESS)
		{
			twConType = TWON_ONEVALUE;
			lpFloat[0] = 1.0f;	// left
			lpFloat[1] = 8.0f;	// right
			lpFloat[2] = 2.0f;	// top
			lpFloat[3] = 9.0f;	// bottom
			twMaxSize = 1;
			SetCapability(	MSG_SET, 
							ICAP_FRAMES, 
							twConType, 
							twItemType, 
							twItem, 
							twMaxSize, 
							TRUE	);

			lpFloat[0] = lpFloat[1] = lpFloat[2] = lpFloat[3] = 0.0f;
			nR =  GetCapability(	MSG_GETCURRENT, 
									ICAP_FRAMES, 
									&twConType, 
									&twItemType,
									twItem, 
									&twMaxSize, 
									TRUE	);

			 SetCapability(MSG_RESET, ICAP_FRAMES, TWON_DONTCARE16, twItemType, NULL, 0, TRUE);

			lpFloat[0] = lpFloat[1] = lpFloat[2] = lpFloat[3] = 0.0f;
			nR =  GetCapability(	MSG_GETCURRENT, 
									ICAP_FRAMES, 
									&twConType, 
									&twItemType,
									twItem, 
									&twMaxSize, 
									TRUE	);
		}
	}

	if((nCapabilities & nFilter) == nFilter)
	{
		twConType = TWON_DONTCARE16;	
		nR =  GetCapability(	MSG_GET, 
								ICAP_FILTER, 
								&twConType, 
								&twItemType,
								twItem, 
								&twMaxSize, 
								TRUE	);
	}

	if((nCapabilities & nContrast) == nContrast)
	{
		// RgXg
		// nFloat[ME_CAP_RANGE_MIN]  Œl
		// nFloat[ME_CAP_RANGE_MAX]  ōl
		// nFloat[ME_CAP_RANGE_STEP] Xebv
		// nFloat[ME_CAP_DEFAULT]	 l
		// nFloat[ME_CAP_CURRENT]	 ݒl
		twConType = TWON_DONTCARE16;
		nR =  GetCapability(	MSG_GET,
								ICAP_CONTRAST,
								&twConType,
								&twItemType,
								twItem,
								&twMaxSize, 
								TRUE	);

		if(nR == TWRC_SUCCESS)
		{
			twConType = TWON_ONEVALUE;
			lpFloat[0] = 1000;
			SetCapability(	MSG_SET,
							ICAP_CONTRAST, 
							twConType,
							twItemType,
							twItem,
							twMaxSize, 
							TRUE	);
			twConType = TWON_ONEVALUE;
			lpFloat[0] = 0; 
			GetCapability(	MSG_GET,
							ICAP_CONTRAST, 
							&twConType,
							&twItemType,
							twItem,
							&twMaxSize,
							TRUE	);
		}
	}
	
	if((nCapabilities & nBrighetness) == nBrighetness) 
	{
		//@邳
		// nFloat[ME_CAP_RANGE_MIN]  Œl
		// nFloat[ME_CAP_RANGE_MAX]  ōl
		// nFloat[ME_CAP_RANGE_STEP] Xebv
		// nFloat[ME_CAP_DEFAULT]	 l
		// nFloat[ME_CAP_CURRENT]	 ݒl
		twConType = TWON_DONTCARE16;
		nR =  GetCapability(	MSG_GET, 
								ICAP_BRIGHTNESS, 
								&twConType, 
								&twItemType, 
								twItem, 
								&twMaxSize,
								TRUE	);

		if(nR == TWRC_SUCCESS)
		{
			twConType = TWON_ONEVALUE;
			lpFloat[0] = 80.0f;
			SetCapability(	MSG_SET, 
							ICAP_BRIGHTNESS,
							twConType,
							twItemType,
							twItem,
							twMaxSize,
							TRUE	);

			twConType = TWON_ONEVALUE;
			twMaxSize = 1;
			lpFloat[0] = lpFloat[1] = lpFloat[2] = lpFloat[3] = lpFloat[4] = 0.0f;

			nR =  GetCapability(	MSG_GETCURRENT, 
									ICAP_BRIGHTNESS, 
									&twConType, 
									&twItemType, 
									twItem, 
									&twMaxSize,
									TRUE	);
		}
	}

	if((nCapabilities & nBitdepth) == nBitdepth)
	{
		twConType = TWON_DONTCARE16;	
		nR =  GetCapability(	MSG_GET, 
								ICAP_BITDEPTH, 
								&twConType, 
								&twItemType,
								twItem, 
								&twMaxSize, 
								TRUE	);
	}
	
	
	// 𑜓xZbg
	// nXresolution[ME_CAP_RANGE_MIN]	Œl
	// nXresolution[ME_CAP_RANGE_MAX]	ōl
	// nXresolution[ME_CAP_RANGE_STEP]	Xebvl
	// nXresolution[ME_CAP_DEFAULT]		l
	// nXresolution[ME_CAP_CURRENT]		ݒl
	
	float nXresolution[CMGC4E::capMaxArray];
	float nYresolution[CMGC4E::capMaxArray];

	SecureZeroMemory(nXresolution, sizeof(nXresolution));
	SecureZeroMemory(nYresolution, sizeof(nYresolution));

	//nR =  GetResolution(MSG_GETDEFAULT, nXresolution, nYresolution); 
	nR =  GetResolution(MSG_GET, nXresolution, nYresolution); 

	if(nR == TWRC_SUCCESS) 
	{
		nR =  SetResolution(MSG_RESET, 0.0f, 0.0f);
		nR =  SetResolution(MSG_SET, nXresolution[0], nYresolution[0]);
	}
	
	// P
	twConType	= TWON_ONEVALUE;		// f[^^
	twItemType  = TWTY_UINT16;			// f[^^Cv
	ptwUint16[0] = TWUN_INCHES;			// ޒliTWUN_INCHES/TWUN_CENTIMETERS/TWUN_PICAS/
										//				TWUN_POINTS/TWUN_TWIPS/TWUN_PIXELSj
	twMaxSize	= 1;					// f[^TCY
	nR =  SetCapability(MSG_SET, ICAP_UNITS, twConType, twItemType, twItem, twMaxSize, TRUE);

	twConType = TWON_DONTCARE16;
	nR =  GetCapability(	MSG_GETCURRENT, 
							ICAP_UNITS, 
							&twConType, 
							&twItemType,
							twItem, 
							&twMaxSize, 
							TRUE	);

	// XLi[̓ǎGA
	TW_IMAGELAYOUT twImageLayout, twDefault;
	
	nR =  GetDefaultImageLayout(&twDefault);	//l擾
	nR =  GetImageLayout(&twImageLayout);		//l擾

	if(ptwUint16[0] == TWUN_INCHES)
	{
		// ǎGAZbg
		twImageLayout.Frame.Top		= FloatToFIX32(MMtoInch(0.0f));
		twImageLayout.Frame.Left	= FloatToFIX32( MMtoInch(0.0f));
		twImageLayout.Frame.Right	= FloatToFIX32( MMtoInch(210.0f));
		twImageLayout.Frame.Bottom	= FloatToFIX32( MMtoInch(297.0f));
	}
	else if(ptwUint16[0] == TWUN_CENTIMETERS)
	{
		twImageLayout.Frame.Top		= FloatToFIX32(0.0f);
		twImageLayout.Frame.Left	= FloatToFIX32(0.0f);
		twImageLayout.Frame.Right	= FloatToFIX32(20.99f);
		twImageLayout.Frame.Bottom	= FloatToFIX32(29.69f);
	}
		
	if( SetImageLayout(&twImageLayout) != TWRC_SUCCESS)
	{
		 CloseSource(CMGC4E::csoSource, NULL);
		return failure;
	}
	
	/// ǎҋ@
	if(nR == TWRC_SUCCESS)
	{
		UINT nR = RequestAcquisition(	CMGC4E::rqaTmNative | CMGC4E::rqaUiHide | CMGC4E::rqaTimeOut7,
										hWnd, 
										NULL	);

 		if(nR != TWRC_SUCCESS) 
			nR = failure;
	}
	else
	{
		nR = failure;
	}

	return nR;
}
#endif

INT CEsergeant::eXfers()
{
	return  Xfers();
}

VOID CEsergeant::eSelectSource(HWND hWnd)
{
	INT nR;

	if(AreYouReady() == CMGC4E::no)
		return;

	// TwainSession JĂȂ瓮\
	nR = OpenSource(CMGC4E::osoSourceManeger | CMGC4E::osoShowErrorMessage, hWnd);

	if( GetTwainState() == 2)
		return;

#if _DEBUG
	INT nMethod = 0;  // \[XI@

	if(nMethod == 0) 
	{
		nR =  SelectSource();
	}
	else if(nMethod == 1)
	{		
        // \[X񋓂ԍŌ̃\[XI
		nR = TWRC_SUCCESS;
		BOOL bReset = TRUE;
		BOOL bSame = FALSE;

		while(nR == TWRC_SUCCESS)
		{ 
			nR = EnumerateSource(bReset);	// ŏ TRUE ŃZbg

			//  GetSourceID gړĨ\[X𒲂ׂ邱Ƃł
			TW_IDENTITY	twSourceID;
			GetSourceID(&twSourceID);

			if(nR != TWRC_SUCCESS)
			{
				// u[NƂ̃\[XI
				break;
			}

			bReset = FALSE;
		}
	}
#else
	nR =  SelectSource();
#endif
}

INT CEsergeant::OpenSourceAndManager(HWND hWnd, BOOL bADF)
{
	//// \[X}l[W[\[XJ
	////  K\[XA\[X}l[W[̏ɊJ
	////  ME_OSC_AUTO_1 œdON`FbNłBsv`hm@ɂgȂꍇ
	////
	////  ME_OSC_AUTO_1           : Open data source & Open data source manager & Check turning on
	////  ME_OSC_AUTO_2           : Open data source & Open data source manager
	////  ME_OSC_SOURCE_MANEGER   : Open data source manager
	////  ME_OSC_SOURCE			  : Open data source
	////  ME_OSC_CHECK_TURNING_ON : Check turning on
	////  ME_OSO_SHOW_ERR_MSG	  : Show message dialog
	////
	INT nR = failure;

	if(AreYouReady() == CMGC4E::yes) 
	{
		if(OpenSource(CMGC4E::osoAuto1, hWnd) == TWRC_SUCCESS)
		{
			nR = success;

			if(bADF) 
				SetADF();
		}
	}

	return nR;
}

INT CEsergeant::SetADF()
{
	// CAP_FEEDERENABLED
	TW_UINT16	twConType = TWON_ONEVALUE;
	TW_UINT16	twItemType = TWTY_BOOL;
	TW_BOOL		twOn;
	TW_UINT32	twMaxSize;
	INT			nR0, nR1, nR2;
	BOOL		bADF = FALSE;

	nR0 =  GetCapability(	MSG_GET, 
							CAP_FEEDERENABLED, 
							&twConType,
							&twItemType,
							&twOn, 
							&twMaxSize,
							FALSE	);
	
	if (nR0 != TWRC_SUCCESS) 
		return failure;
		
	if(!twOn) 
	{   
		twOn = TRUE;
		nR1 =  SetCapability(	MSG_SET, 
								CAP_FEEDERENABLED,
								twConType,
								twItemType,
								&twOn, 
								twMaxSize,
								FALSE	);

		if(nR1 == TWRC_SUCCESS)
		{
			twOn = FALSE;
			nR2 =  GetCapability(	MSG_GET, 
									CAP_FEEDERENABLED,
									&twConType,
									&twItemType,
									&twOn, 
									&twMaxSize,
									FALSE	);

			if(nR2 != TWRC_SUCCESS || !twOn)
				return failure;
		}
		else 
		{
			return failure;
		}
	}

	// CAP_AUTOFEED
	twOn = FALSE;
	nR0 =  GetCapability(	MSG_GET, 
							CAP_AUTOFEED,
							&twConType, 
							&twItemType, 
							&twOn, 
							&twMaxSize, 
							FALSE	);
		
	if(nR0 != TWRC_SUCCESS) 
		return failure;


	if(!twOn)
	{
		nR0 =  SetCapability(	MSG_SET, 
								CAP_AUTOFEED, 
								twConType, 
								twItemType, 
								&twOn, 
								twMaxSize, 
								FALSE	);
		
		if(nR0 == TWRC_SUCCESS)
		{ 
			nR1 =  GetCapability(	MSG_GET, 
									CAP_AUTOFEED, 
									&twConType,
									&twItemType,
									&twOn,
									&twMaxSize,
									FALSE	);

			if(nR1 != TWRC_SUCCESS || !twOn)
				return failure;
		}   
		else
		{
			return failure;
		}	
	}

	return success;
}


INT CEsergeant::eCaptureButton(HWND hWnd)
{
	return  CaptureButton(hWnd);
}

INT CEsergeant::eSave(CWnd* pWnd, LPTSTR lpszFileName)
{
	// rbg}bvt@Cۑ܂(rbg}bv̂ݑΉ)
	INT nR = SaveImage(CT2W(lpszFileName), CMGC4E::sivCreateFile);	// CMGC4E::sviDontOverWrite

	if(nR != TWRC_SUCCESS)
		nR = failure;
	
	return nR;
}

INT CEsergeant::eSaveAs(CWnd* pWnd, LPTSTR lpszFileName)
{
	// rbg}bvt@Cۑ܂(rbg}bv̂ݑΉ)
	INT	nR = failure;

	CFileDialog fileDlg(	FALSE,
							_T("bmp"),
							_T("Test.bmp"), 
							OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_EXPLORER,
							_T("Bitmap Files (*.bmp)|*bmp\0"), 
							pWnd	);

	if(fileDlg.DoModal() == IDOK)
	{
		nR = SaveImage(CT2W(fileDlg.GetPathName()), CMGC4E::sivCreateFile);

		if(lpszFileName != NULL)
			lstrcpy(lpszFileName, fileDlg.GetPathName()); 

		if(nR != TWRC_SUCCESS)
			nR = failure;
	}

	return nR;
}

INT CEsergeant::eGetDIBSize(LPINT lpHeight, LPINT lpWidth)
{
	INT nR = GetDIBSize(lpHeight, lpWidth);

	if(nR != TWRC_SUCCESS)
		nR = failure;

	return nR; 
}

LPVOID CEsergeant::eGetImage()
{
	return  GetImage();
}

LPVOID CEsergeant::eLoad(CWnd* pWnd, LPTSTR lpszFileName)
{
	LPVOID  lpImage = NULL;
	LPCTSTR szFilters = _T("Bitmap Files (*.bmp)\0");
	CFileDialog FileDlg(	TRUE, 
							_T("bmp"), 
							_T("*.bmp"), 
							OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, 
							szFilters, 
							pWnd	);
	
	if(FileDlg.DoModal() == IDOK) 
	{
		if( LoadImage(CT2W(FileDlg.GetPathName()), NULL) == TWRC_SUCCESS)
			lpImage = GetImage();

		if(lpszFileName != NULL)
			lstrcpy(lpszFileName, FileDlg.GetPathName().GetBuffer());
	}

	FileDlg.DestroyWindow();
	delete FileDlg;

	return lpImage;
}

VOID CEsergeant::eDestroyImage()
{
	 DestroyImage();
}

VOID CEsergeant::ePaintImage(HDC hDC, LPRECT lprctDIB, LPRECT lprctDest)
{
	 PaintDIB(hDC, lprctDest, lprctDIB);
}

VOID CEsergeant::eSetImage(LPVOID lpBitmap)
{
	 SetImage(lpBitmap);
}

VOID CEsergeant::eGetClipbord(HWND hWnd)
{
	 GetClipbordDIB(hWnd);
}

VOID CEsergeant::eSetClipbord(HWND hWnd)
{
	 SetClipbordDIB(hWnd);
}

INT CEsergeant::eShowDlgCaps(HWND hWnd, LPCTSTR lpszTitle)
{
	// 
	//// TWAIN @@\ꗗ\
	// 
	INT nR = ShowDlgCaps(lpszTitle, hWnd, TRUE);

	return (nR == TWRC_SUCCESS)? success : failure;		
}

INT CEsergeant::eGetFileVersion(	LPCTSTR lpszFileName, 
									DWORD*	lpdwMajor,
									DWORD*	lpdwMinor,
									DWORD*	lpdwRevision, 
									DWORD*	lpdwBild		)
{
	INT nR = GetFileVersion(CT2W(lpszFileName), lpdwMajor, lpdwMinor, lpdwRevision, lpdwBild);

	return (nR == TWRC_SUCCESS)? success : failure;		
}	


/*  C[W` Ql
VOID CEsergeant::ePaintImage(HDC hDC)
{
	LPVOID				lpBmp  = ::GlobalLock((HGLOBAL) GetImage());
	LPBITMAPINFO		lpBMI  = (LPBITMAPINFO)lpBmp;
	LPBITMAPINFOHEADER	lpBMIH = (LPBITMAPINFOHEADER)lpBmp;
	BYTE*				lpData = (BYTE*)lpBMI + lpBMI->bmiHeader.biSize;
	INT					nX = 0, nY = 0;

	SetDIBitsToDevice(	dc.m_hDC, 
						0, 0, lpBMI->bmiHeader.biWidth, lpBMI->bmiHeader.biHeight, 
						0, 0, 
						0, lpBMI->bmiHeader.biHeight, 
						lpData, lpBMI, DIB_RGB_COLORS
					  );		

	::GlobalUnlock((HGLOBAL)lpBmp);
}*/