// TestEx.cpp : AvP[ṼNX`܂B
//
#include "stdafx.h"
#include "afxwin.h"
#include "afxcmn.h"
#include "TestEx.h"
#include "DlgCopy.h"
#include "DlgImage.h"
#include "DlgFile.h"
#include "DlgTone.h"
#include "DlgYESNO.h"
#include "DlgAboutPage0.h"
#include "DlgAboutPage1.h"
#include "DlgAboutPage2.h"
#include "DlgHistogram.h"
#include "MainFrm.h"
#include "FunctionBE.h"
#include "FunctionE.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg(LPVOID lpAZ, LPVOID lpBSE, LPVOID lpE);
	virtual ~CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUT };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
public:
	afx_msg void OnBnClickedButtonEnd();
	afx_msg void OnBnClickedRadio(UINT nID);
private:
	CM3az*	m_lpAZ;			// AZ
	CBEsergeant* m_lpBSE;	// BE
	CEsergeant*	 m_lpE;		// E 
	
	CButton m_btnEnd;
	CBitmap m_bmpEnd;
	CDlgAboutPage0*	m_lpPage0;
	CDlgAboutPage1*	m_lpPage1;
	CDlgAboutPage2*	m_lpPage2;
};

CAboutDlg::CAboutDlg(LPVOID lpAZ, LPVOID lpBSE, LPVOID lpE) : CDialog(CAboutDlg::IDD)
{
	m_lpAZ = (CM3az*)lpAZ;
	m_lpBSE = (CBEsergeant*)lpBSE;
	m_lpE  = (CEsergeant*)lpE;
	// {^
	m_bmpEnd.LoadBitmap(IDB_END);
}

CAboutDlg::~CAboutDlg()
{
	m_bmpEnd.DeleteObject();
	m_lpPage0->DestroyWindow();
	delete m_lpPage0;
	m_lpPage1->DestroyWindow();
	delete m_lpPage1;
	m_lpPage2->DestroyWindow();
	delete m_lpPage2;
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_ABOUT_BUTTON_END, m_btnEnd);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	ON_BN_CLICKED(IDC_ABOUT_BUTTON_END, OnBnClickedButtonEnd)
	ON_CONTROL_RANGE(BN_CLICKED, IDC_ABOUT_RADIO0, IDC_ABOUT_RADIO2, OnBnClickedRadio)
END_MESSAGE_MAP()

// _CAOs邽߂̃AvP[V R}h
void CTestExApp::OnAppAbout()
{
	CAboutDlg aboutDlg(&m_AZ, &m_BSE, &m_E);
	aboutDlg.DoModal();
}

BOOL CAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// _CAO^Cg
	TCHAR szTitle[64];
	LoadString(theApp.m_hInstance, IDS_DLG_ABOUT_TITLE, szTitle, 64);
	GetDlgItem(IDC_ABOUT_STATIC_TITLE)->SetWindowText(szTitle);

	// y[W_CAO
	TRY
	{
		m_lpPage0 = new CDlgAboutPage0;
		m_lpPage0->Create(IDD_ABOUT_PAGE0, this);
		m_lpPage1 = new CDlgAboutPage1(NULL, m_lpBSE, m_lpE);
		m_lpPage1->Create(IDD_ABOUT_PAGE1, this);
		m_lpPage2 = new CDlgAboutPage2(NULL, m_lpAZ);
		m_lpPage2->Create(IDD_ABOUT_PAGE2, this);
	}
	CATCH(CMemoryException, pEx) 
	{
		m_lpPage0 = NULL;
		m_lpPage1 = NULL;
		m_lpPage2 = NULL;
	}
	END_CATCH;
	
	// {^
	m_btnEnd.SetBitmap(m_bmpEnd);

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

void CAboutDlg::OnBnClickedButtonEnd()
{
	OnCancel();
}

void CAboutDlg::OnBnClickedRadio(UINT nID)
{
	UINT nFlags[3];

	switch(nID)
	{
	case IDC_ABOUT_RADIO2:
		nFlags[2] = SWP_NOSIZE | SWP_SHOWWINDOW;
		nFlags[1] = SWP_NOSIZE | SWP_HIDEWINDOW;
		nFlags[0] = SWP_NOSIZE | SWP_HIDEWINDOW;
		break;
	case IDC_ABOUT_RADIO1:
		nFlags[2] = SWP_NOSIZE | SWP_HIDEWINDOW;
		nFlags[1] = SWP_NOSIZE | SWP_SHOWWINDOW;
		nFlags[0] = SWP_NOSIZE | SWP_HIDEWINDOW;
		break;
	case IDC_ABOUT_RADIO0:
		nFlags[2] = SWP_NOSIZE | SWP_HIDEWINDOW;
		nFlags[1] = SWP_NOSIZE | SWP_HIDEWINDOW;
		nFlags[0] = SWP_NOSIZE | SWP_SHOWWINDOW;
		break;
	}

	m_lpPage2->SetWindowPos(&CWnd::wndTop, 0, 40, 0, 0, nFlags[2]);
	m_lpPage1->SetWindowPos(&CWnd::wndTop, 0, 40, 0, 0, nFlags[1]);
	m_lpPage0->SetWindowPos(&CWnd::wndTop, 0, 40, 0, 0, nFlags[0]);
}

// CTestExApp

BEGIN_MESSAGE_MAP(CTestExApp, CWinApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_EDIT_PAST_NEW, OnEditPastNew)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_COMMAND(ID_EDIT_REDO, OnEditRedo)
	ON_COMMAND(ID_EDIT_RESET_AREA, OnEditResetArea)
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(ID_FILE_TWAIN_A, OnFileTwainA)
	ON_COMMAND(ID_FILE_TWAIN_B, OnFileTwainB)
	ON_COMMAND(ID_FILE_TWAIN_SOURCE, OnFileTwainSource)
	ON_COMMAND(ID_IMAGE_CONTRAST1, OnImageContrast1)
	ON_COMMAND(ID_IMAGE_CONTRAST2, OnImageContrast2)
	ON_COMMAND(ID_IMAGE_CONTRAST3, OnImageContrast3)
	ON_COMMAND(ID_IMAGE_COPY, OnImageCopy)
	ON_COMMAND(ID_IMAGE_FILTER_C1, OnImageCustomFilter1)
	ON_COMMAND(ID_IMAGE_FILTER_C2, OnImageCustomFilter2)
	ON_COMMAND(ID_IMAGE_FILTER_C3, OnImageCustomFilter3)
	ON_COMMAND(ID_IMAGE_FILTER_C4, OnImageCustomFilter4)
	ON_COMMAND(ID_IMAGE_FILTER_C5, OnImageCustomFilter5)
	ON_COMMAND(ID_IMAGE_FILTER_C6, OnImageCustomFilter6)
	ON_COMMAND(ID_IMAGE_FILTER1, OnImageFilter1)
	ON_COMMAND(ID_IMAGE_FILTER2, OnImageFilter2)
	ON_COMMAND(ID_IMAGE_FILTER3, OnImageFilter3)
	ON_COMMAND(ID_IMAGE_FILTER4, OnImageFilter4)
	ON_COMMAND(ID_IMAGE_QUALITY, OnImageQuality)
	ON_COMMAND(ID_IMAGE_TONE, OnImageTone)
	ON_COMMAND(ID_VIEW_CAPS, OnViewCaps)
	ON_COMMAND(ID_VIEW_GAMMA, OnViewGamma)
	ON_COMMAND(ID_VIEW_HISTOGRAM, OnViewHistogram)
	ON_COMMAND(ID_VIEW_IZ_MODE, OnViewMode)
	ON_COMMAND(ID_VIEW_PROPERTY, OnViewProperty)
	ON_COMMAND(ID_VIEW_REFLESH, OnViewReflesh)
	ON_COMMAND_RANGE(ID_EDIT_CLIPPING_ZONE_32, ID_EDIT_CLIPPING_ZONE_FREE, OnEditClippingZone)
	ON_COMMAND_RANGE(ID_EDIT_ROTETE_RIGHT, ID_EDIT_ROTETE_REVERSE, OnEditRotete)
	ON_COMMAND_RANGE(ID_IMAGE_DECOLOR_1, ID_IMAGE_DECOLOR_8C, OnImageDecolor)
	ON_COMMAND_RANGE(ID_VIEW_MAG_TRIPLE, ID_VIEW_MAG_110, OnViewMag)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, OnUpdateEditCopy)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PAST_NEW, OnUpdateEditPasteNew)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, OnUpdateEditPaste)
	ON_UPDATE_COMMAND_UI(ID_EDIT_REDO, OnUpdateEditRedo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_RESET_AREA, OnUpdateEditResetArea)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO, OnUpdateEditUndo)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE, OnUpdateFileSave)
	ON_UPDATE_COMMAND_UI(ID_IMAGE_CONTRAST1, OnUpdateImageContrast1)
	ON_UPDATE_COMMAND_UI(ID_IMAGE_CONTRAST2, OnUpdateImageContrast2)
	ON_UPDATE_COMMAND_UI(ID_IMAGE_CONTRAST3, OnUpdateImageContrast3)
	ON_UPDATE_COMMAND_UI(ID_IMAGE_COPY, OnUpdateImageCopy)
	ON_UPDATE_COMMAND_UI(ID_IMAGE_QUALITY, OnUpdateImageQuality)
	ON_UPDATE_COMMAND_UI(ID_IMAGE_TONE, OnUpdateImageTone)
	ON_UPDATE_COMMAND_UI(ID_VIEW_CAPS, OnUpdateViewCaps)
	ON_UPDATE_COMMAND_UI(ID_VIEW_GAMMA, OnUpdateViewGamma)
	ON_UPDATE_COMMAND_UI(ID_VIEW_HISTOGRAM, OnUpdateViewHistogram)
	ON_UPDATE_COMMAND_UI(ID_VIEW_IZ_MODE, OnUpdateViewMode)
	ON_UPDATE_COMMAND_UI(ID_VIEW_PROPERTY, OnUpdateViewProperty)
	ON_UPDATE_COMMAND_UI_RANGE(	ID_EDIT_CLIPPING_ZONE_32,
								ID_EDIT_CLIPPING_ZONE_FREE,
								OnUpdateEditClippingZone	)
	ON_UPDATE_COMMAND_UI_RANGE(ID_EDIT_ROTETE_RIGHT, ID_EDIT_ROTETE_REVERSE, OnUpdateEditRotete)
	ON_UPDATE_COMMAND_UI_RANGE(ID_FILE_TWAIN_A, ID_FILE_TWAIN_SOURCE, OnUpdateFileTwain)
	ON_UPDATE_COMMAND_UI_RANGE(ID_IMAGE_DECOLOR_1, ID_IMAGE_DECOLOR_8C, OnUpdateImageDecolor)
	ON_UPDATE_COMMAND_UI_RANGE(ID_IMAGE_FILTER_C1, ID_IMAGE_FILTER4, OnUpdateImageFilter)
	ON_UPDATE_COMMAND_UI_RANGE(ID_VIEW_MAG_TRIPLE, ID_VIEW_MAG_110, OnUpdateViewMag)
END_MESSAGE_MAP()


// CTestExApp RXgNV

CTestExApp::CTestExApp()
{
	// TODO: ̈ʒuɍ\zpR[hǉĂB
	//  InitInstance ̏dvȏׂċLqĂB
	m_bIZMode = FALSE;

	m_lpszRegKey			= _T("Software\\m.magic\\TestEx\0");
	m_lpszRegNameGamma		= _T("Ganmma\0");
	m_lpszRegNameTwainPath	= _T("TwainPath\0");

	m_nRealMagnifications[MAG_TRIPLE]	= 3.00;
	m_nRealMagnifications[MAG_DOUBLE]	= 2.00;
	m_nRealMagnifications[MAG_FULL]		= 1.00;
	m_nRealMagnifications[MAG_HALF]		= 0.50;
	m_nRealMagnifications[MAG_103]		= 0.33;
	m_nRealMagnifications[MAG_QUATER]	= 0.25;
	m_nRealMagnifications[MAG_105]		= 0.20;
	m_nRealMagnifications[MAG_106]		= 0.17;
	m_nRealMagnifications[MAG_107]		= 0.14;
	m_nRealMagnifications[MAG_108]		= 0.13;
	m_nRealMagnifications[MAG_109]		= 0.11;
	m_nRealMagnifications[MAG_110]		= 0.10;

	SecureZeroMemory(&m_setup, sizeof(SETUP));
	m_setup.nGamma = 1.00;
}


// B CTestExApp IuWFNgłB

CTestExApp theApp;

// CTestExApp 

BOOL CTestExApp::InitInstance()
{
	// AvP[V@}jtFXg@visual X^CLɂ邽߂ɁA
	// ComCtl32.dll o[W 6@ȍ~̎gpw肷ꍇ́A
	// Windows XP Ɂ@InitCommonControls() KvłBȂ΁AEBhE쐬ׂ͂Ďs܂B
	InitCommonControls();

	CWinApp::InitInstance();

	// R}hC
	if(lstrcmpi(theApp.m_lpCmdLine, _T("/R")) == 0) 
	{
		// [X[h
		if(		m_E.AreYouReady()	== CMGC4E::no
			||	m_BSE.AreYouReady() == CMBSE5E::no
			||	m_AZ.AreYouReady()	== MAZ_NO
			||	m_IZ.AreYouReady()	== CMGC4IZ::no
			||	m_LZ.AreYouReady()	== CMGC4LZ::no	) 
		{
			ShowErrorMessage(ERR_TEX_SYSTEM, _T("TEX"));
			return FALSE;
		}
		m_nReverseBuffer = CMBSE5E::criReverseBuffer;
		m_nMaxCount = MAX_FILE_COUNT;
	}
	else
	{		
		// eXg[h
		if(m_E.AreYouReady() == CMGC4E::no && m_BSE.AreYouReady() == CMBSE5E::no)
		{
			ShowErrorMessage(ERR_TEX_SYSTEM, _T("TEX"));
			return FALSE;
		}

		if(m_BSE.AreYouReady() == CMBSE5E::yes)
		{
			m_nReverseBuffer =  (ShowMessageBox(CDlgYESNO::YESNO, IDS_TEX_REVERSE) == IDOK)?
									CMBSE5E::criReverseBuffer : CMBSE5E::criNoReverseBuffer;
		}

		m_nMaxCount = MAX_FILE_COUNT_TEST;
	}

	// WXg
	//ReadRegistory();

	// CZX`FbN

	// E 
	if(m_E.AreYouReady() == CMGC4E::yes)
		m_E.eInitialize(1, 0, _T("m.magic\0"), _T("m.magic reserch\0"), _T("TestEx\0"));

	// IZ 
	if(m_IZ.AreYouReady() == CMGC4IZ::yes)
	{	
		if(m_IZ.Initialize(_T("miz4jpn.dll"), FALSE))
		{
			m_IZ.UnloadDll();
		}
		else
		{
			m_bIZMode = TRUE;
		}
	}

	// LZ 
	if(m_LZ.AreYouReady() == CMGC4LZ::yes) 
	{
		CMGC4LZ::INI_PARAMETERS params;
		params.nTimerElapse = CMGC4LZ::iniTimerElapseDefault;
		params.nFunction = 0;
		m_LZ.mlzInitialize( &params );
	}
	
	// Initialize OLE
	if(!AfxOleInit())
		return FALSE;
	
	// W
	// ̋@\g킸ɁAŏIIȎs\t@C̃TCYkꍇ́A
	// ȉAsvȏ[`
	// 폜ĂB
	// ݒ肪i[Ă郌WXg L[ύX܂B
	// TODO: ̕AЖ܂͑gDȂǂ́A
	// K؂ȕɕύXĂB
	//SetRegistryKey(_T("AvP[V EBU[hŐꂽ[J AvP[V"));
	// C EChE쐬ƂÃR[h͐Vt[ EChE IuWFNg쐬A
	// AvP[ṼC EChEɃZbg܂
	CMDIFrameWnd* pFrame = new CMainFrame;
	if (!pFrame)
		return FALSE;
	m_pMainWnd = pFrame;
	// C MDI t[ EBhE쐬܂B
	if (!pFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	// ʂ MDI j[ƃANZ[^ e[uǂݍ݂܂B
	//TODO: ǉ̃oϐāAAvP[VKvƂ
	//	ǉ̃j[^Cv̂߂ɌĂяoǂݍłB
	HINSTANCE hInst = AfxGetResourceHandle();
	m_hMDIMenu  = ::LoadMenu(hInst, MAKEINTRESOURCE(IDR_TestExTYPE));
	m_hMDIAccel = ::LoadAccelerators(hInst, MAKEINTRESOURCE(IDR_TestExTYPE));

	// C EBhEꂽ̂ŁA\ƍXVs܂B
	pFrame->ShowWindow(m_nCmdShow);
	pFrame->CenterWindow();
	pFrame->UpdateWindow();

	return TRUE;
}


// CTestExApp bZ[W nh

int CTestExApp::ExitInstance() 
{
	//TODO: ǉ\[Xꍇɂ͂Ă
	if (m_hMDIMenu != NULL)
		FreeResource(m_hMDIMenu);
	if (m_hMDIAccel != NULL)
		FreeResource(m_hMDIAccel);

	// WXg
	//WriteRegistory();
	
	return CWinApp::ExitInstance();
}

void CTestExApp::FloatToReal(DOUBLE nFloat, LPREAL lpReal)
{
	lpReal->nWhole	  = (INT)nFloat;
	lpReal->nFraction = (INT)((nFloat - lpReal->nWhole) * 10);
}
/////////////////////////////////////////////////////////////////////////////////////////////////////
//// menu file
/////////////////////////////////////////////////////////////////////////////////////////////////////
void CTestExApp::OnFileNew() 
{
	//
	//// VK摜t@C
	//
	if(FileList(SET_NEWFILE, NULL) < m_nMaxCount) 
	{
		MakeChildForm();
		CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
		lpChildFrm->SetWText();
	}

	ShowToolBar();
}

void CTestExApp::OnFileOpen()
{
	//
	//// 摜t@Cǎ
	//
	TCHAR  szFileName[MAX_PATH];

	Load(TRUE, TRUE, szFileName);
}

void CTestExApp::OnFileSave()
{
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	Save(lpChildFrm);
}

void CTestExApp::OnUpdateFileSave(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_BSE.AreYouReady() == CMBSE5E::yes);
}

void CTestExApp::OnFileSaveAs()
{
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	SaveAs(lpChildFrm);
}

void CTestExApp::OnFileTwainSource()
{
	//
	//// TWAIN @I
	//
	m_E.eSelectSource(m_pMainWnd->m_hWnd);
}

void CTestExApp::OnFileTwainA()
{
	///  m.magic E
	//// C[W擾 (Native Mode Transfer)
	//   
#if _DEBUG
	int nTWAIN = 1;
#else
	int nTWAIN = 1;
#endif

	if(nTWAIN == 1) 
	{
		//// XLJn (^CAEg 2000~b KX)
		if(m_E.eScan(m_pMainWnd->m_hWnd, FALSE) == CM4e::success) 
		{
			m_pMainWnd->EnableWindow(FALSE);
			m_pMainWnd->SetTimer(1, 2000, NULL);	// dv
		}
	}
	else if(nTWAIN == 2) 
	{
		//// C[W擾 (Memory Mode Transfer)
		//// XLJn (^CAEg 2000~b KX)
		m_lpDlgProgress = (CDlgProgress*)CreateDlgProgress(CDlgProgress::CANCEL);
		m_proc.lpParams = m_lpDlgProgress;
		m_proc.lpFunction = g_meDialog;
		m_proc.nWrittenSize = 0;
		m_proc.nMaxSize = 0;
		m_proc.szText[0] = 0;

		if(m_E.eScan(m_pMainWnd->m_hWnd, FALSE, &m_proc) == CM4e::success) 
		{
			m_pMainWnd->EnableWindow(FALSE);

			m_lpDlgProgress->ShowWindow(SW_SHOW);
			m_lpDlgProgress->EnableWindow(TRUE);	// 
			m_lpDlgProgress->UpdateWindow();
	
			m_pMainWnd->SetTimer(2, 2000, NULL);
		}
	}
#if _DEBUG
	else if(nTWAIN == 4) 
	{
		//// C[W擾 (Native Mode Transfer)
		//// XLJn (^CAEg 2000~b KX)
		if(m_E.eScanForTest(m_pMainWnd->m_hWnd, FALSE) == CM4e::success) 
		{
			m_pMainWnd->EnableWindow(FALSE);
			m_pMainWnd->SetTimer(4, 2000, NULL);
		}
	}
#endif
}

void CTestExApp::OnFileTwainB()
{
	///  m.magic E
	//// C[W擾 (Disk Mode Transfer)
	//
	CDlgFile *lpDialog = new CDlgFile(NULL, m_setup.szImagePath);

	if(lpDialog->DoModal() == IDOK) 
	{
		lpDialog->GetFileName(m_setup.szImagePath);
		//// XLJn (^CAEg 2000~b KX)
		if(m_E.eScan(m_pMainWnd->m_hWnd, FALSE, m_setup.szImagePath) == CM4e::success)
		{
			m_pMainWnd->EnableWindow(FALSE);
			m_pMainWnd->SetTimer(3, 2000, NULL);
		}
		lpDialog->GetDirectory(m_setup.szImagePath);
	}

	lpDialog->DestroyWindow();
	delete lpDialog;
}

void CTestExApp::OnUpdateFileTwain(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_E.AreYouReady() == CMGC4E::yes);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
//// menu edit
/////////////////////////////////////////////////////////////////////////////////////////////////////
void CTestExApp::OnEditUndo()
{
	// 
	//// UNDOiBoosterE Kvj
	//
	ShowWaitCursor(TRUE);

	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	

	CMBSE5E::LPIMAGEBAG lpImage = (CMBSE5E::LPIMAGEBAG)lpChildFrm->GetImage();
	LPTSTR	lpszFileName = lpChildFrm->GetFileName();
	INT nR = m_BSE.beReverseAction(CMBSE5E::rvaUndo, lpImage);
	
	if(nR > CMBSE5E::failure)
	{
		SetupViewInfo(lpImage, lpszFileName, TRUE, TRUE);
		SetReverseText(lpChildFrm, (CMBSE5E::LPIMAGEBAG)lpImage, nR);
		lpChildFrm->InvalidateRect(NULL);	// \XV
	}

	ShowWaitCursor(FALSE);
}

void CTestExApp::OnUpdateEditUndo(CCmdUI *pCmdUI)
{
	if(m_BSE.AreYouReady() == CMBSE5E::no || m_nReverseBuffer == CMBSE5E::noReverseBuffer)
	{
		pCmdUI->Enable(FALSE);
	}
	else 
	{
		CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
		CMBSE5E::LPIMAGEBAG lpImage = (CMBSE5E::LPIMAGEBAG)lpChildFrm->GetImage();
		
		if(lpImage != NULL)
			pCmdUI->Enable(lpImage->lpReverseBuffer->nRedo > 1);
	}
}

void CTestExApp::OnEditRedo()
{
	// 
	//// REDOiBoosterE Kvj
	//
	ShowWaitCursor(TRUE);

	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	
	
	CMBSE5E::LPIMAGEBAG lpImage = (CMBSE5E::LPIMAGEBAG)lpChildFrm->GetImage();
	LPTSTR	lpszFileName = lpChildFrm->GetFileName();
	INT	nR = m_BSE.beReverseAction(CMBSE5E::rvaRedo, lpImage);
	
	if(nR > CMBSE5E::failure) 
	{
		SetupViewInfo(lpImage, lpszFileName, TRUE, TRUE);
		SetReverseText(lpChildFrm, (CMBSE5E::LPIMAGEBAG)lpImage, nR);
		lpChildFrm->InvalidateRect(NULL);	// \XV
	}

	ShowWaitCursor(FALSE);
}

void CTestExApp::OnUpdateEditRedo(CCmdUI *pCmdUI)
{
	if(m_BSE.AreYouReady() == CMBSE5E::no || m_nReverseBuffer == CMBSE5E::noReverseBuffer) 
	{
		pCmdUI->Enable(FALSE);
	}
	else 
	{
		CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
		CMBSE5E::LPIMAGEBAG lpImage = (CMBSE5E::LPIMAGEBAG)lpChildFrm->GetImage();
		
		if(lpImage != NULL)
			pCmdUI->Enable(lpImage->lpReverseBuffer->nCount - lpImage->lpReverseBuffer->nRedo > 0);
	}
}

void CTestExApp::OnEditCopy()
{
	// Nbv{[hɃrbg}bvRs[܂
	CChildFrame*	lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);

	BOOL			bClipping;
	INT				nR = failure;
	CMBSE5E::LPIMAGEBAG	lpImageBag;
	CMBSE5E::CPY_PARAMS	params;


	ShowWaitCursor(TRUE);

	bClipping = lpChildFrm->IsZoneClipped();
	
	if(m_BSE.AreYouReady() == CMBSE5E::yes) // Booster E p 
	{	
		lpImageBag = lpChildFrm->GetImage();
		
		if(bClipping) 
		{
			// Ï
			SecureZeroMemory(&params, sizeof(params));
			GetClippingZone(lpImageBag, (LPRECT)&params.nSrcLeft, &params.nBitPerPixel);
			// {
			params.nMagX = params.nMagY = 1.0;
			// C[WTCY
			params.nDestWidth  = params.nSrcRight - params.nSrcLeft;
			params.nDestHeight = params.nSrcBottom - params.nSrcTop;
		}
		
		nR = m_BSE.beSetClipboardImage(m_pMainWnd->m_hWnd, &params, lpImageBag, bClipping);

		if(nR != CMBSE5E::success)
			ShowErrorMessage(nR, _T("BSE"));

		RestClippingZone(lpChildFrm);
	}
	else 
	{
		m_E.eSetImage(lpChildFrm->GetImage());
		m_E.eSetClipbord(m_pMainWnd->m_hWnd);
	}

	ShowWaitCursor(FALSE);
}

void CTestExApp::OnUpdateEditCopy(CCmdUI *pCmdUI)
{
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	pCmdUI->Enable(!(lpChildFrm == NULL));	
}

void CTestExApp::OnEditPaste()
{
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	INT		nR;
	CMBSE5E::LPIMAGEBAG	lpImageBag  = lpChildFrm->GetImage();


	ShowWaitCursor(TRUE);

	nR = m_BSE.beGetClipboardImage(m_pMainWnd->m_hWnd, lpImageBag, m_nReverseBuffer);

	if(nR == CMBSE5E::success) 
	{
		SetupViewInfo(lpImageBag, lpChildFrm->GetFileName(), TRUE, FALSE);
		lpChildFrm->InvalidateRect(NULL);	// \XV
	}
	else
	{
		ShowErrorMessage(ERR_TEX_FILE_MAX, _T("BSE"));
	}

	ShowWaitCursor(FALSE);
}

void CTestExApp::OnUpdateEditPaste(CCmdUI *pCmdUI)
{
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);

	pCmdUI->Enable(		m_BSE.AreYouReady() == CMBSE5E::yes
					&&	CheckClipborad()
					&&	lpChildFrm != NULL	);	
}

void CTestExApp::OnEditPastNew()
{
	// Nbv{[h̃rbg}bvy[Xg܂
	LPVOID	lpNewImage = NULL;


	ShowWaitCursor(TRUE);

	if(m_BSE.AreYouReady() == CMBSE5E::yes) 
	{ 
		// Booster E p
		lpNewImage = (LPVOID)m_BSE.beGetClipboardImage(m_pMainWnd->m_hWnd, m_nReverseBuffer);
	}
	else 
	{
		m_E.eGetClipbord(m_pMainWnd->m_hWnd);
		lpNewImage = m_E.eGetImage();
	}

	if(lpNewImage != NULL) 
	{
		INT nR = FileList(SET_FILENAME, NULL);

		if(nR != FILE_FOUND && nR != m_nMaxCount) 
		{
			MakeChildForm();
			SetupViewInfo((CMBSE5E::LPIMAGEBAG)lpNewImage, NULL, TRUE, FALSE);
		}
		else 
		{
			if(m_BSE.AreYouReady() == CMBSE5E::yes)	
				m_BSE.beDestroyImage((CMBSE5E::LPIMAGEBAG)lpNewImage);
			else
				m_E.eDestroyImage();
		}

		ShowToolBar();
	}

	ShowWaitCursor(FALSE);
}

void CTestExApp::OnUpdateEditPasteNew(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(CheckClipborad());	
}

void CTestExApp::OnEditRotete(UINT nID)
{
	// ]
	INT	nDegrees;
	
	if(nID == ID_EDIT_ROTETE_RIGHT)
		nDegrees = 90;
	else if(nID == ID_EDIT_ROTETE_LEFT)
		nDegrees = -90;
	else if(nID == ID_EDIT_ROTETE_REVERSE)
		nDegrees = 180;
	else
		nDegrees = 0;

	Rotate(nDegrees);
}

void CTestExApp::OnUpdateEditRotete(CCmdUI *pCmdUI)
{
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	pCmdUI->Enable(		(m_BSE.AreYouReady() == CMBSE5E::yes) 
					&&  (lpChildFrm->GetClippingZoneStatus() == CChildView::CPZ_REMOVED));
}

void CTestExApp::OnEditClippingZone(UINT nID)
{
	//
	//// 摜̈ݒ肷
	//
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	
	INT	nType;
	
	if(nID == ID_EDIT_CLIPPING_ZONE_32)
		nType = CChildView::CPZ_TYPE_32;
	else if(nID == ID_EDIT_CLIPPING_ZONE_23)
		nType = CChildView::CPZ_TYPE_23;
	else
		nType = CChildView::CPZ_TYPE_FREE;

	lpChildFrm->ClipZone(nType);
}

void CTestExApp::OnUpdateEditClippingZone(CCmdUI *pCmdUI)
{
	if(m_BSE.AreYouReady() == CMBSE5E::yes) 
	{
		CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
		pCmdUI->Enable(lpChildFrm->GetClippingZoneStatus() == CChildView::CPZ_REMOVED);
	}
	else 
	{
		pCmdUI->Enable(FALSE);
	}
}

void CTestExApp::OnEditResetArea()
{
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	lpChildFrm->SetClippingZoneStatus(CChildView::CPZ_REMOVED);
	ClipCursor(NULL);
	lpChildFrm->InvalidateRect(NULL);	// \XV
}

void CTestExApp::OnUpdateEditResetArea(CCmdUI *pCmdUI)
{
	if(m_BSE.AreYouReady() == CMBSE5E::yes) 
	{
		CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
		pCmdUI->Enable(lpChildFrm->GetClippingZoneStatus() != CChildView::CPZ_REMOVED);
	}
	else 
	{
		pCmdUI->Enable(FALSE);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
//// View
/////////////////////////////////////////////////////////////////////////////////////////////////////
void CTestExApp::OnViewMag(UINT nID)
{
	SetMagnification(nID - ID_VIEW_MAG_TRIPLE);
}

void CTestExApp::OnUpdateViewMag(CCmdUI *pCmdUI)
{
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);

	if(lpChildFrm != NULL)
	{
		CChildView::LPIMAGE_INFO lpInfo = lpChildFrm->GetImageInfo();
		pCmdUI->SetCheck(lpInfo->nMagnifications == pCmdUI->m_nID - ID_VIEW_MAG_TRIPLE);
	}

	pCmdUI->Enable(m_BSE.AreYouReady() == CMBSE5E::yes);
}

void CTestExApp::OnViewGamma()
{
	//
	//// K}l
	//
	int		nValue = 1;
	TCHAR	szText[64];

	theApp.m_pMainWnd->GetMenu()->GetMenuString(ID_VIEW_GAMMA, szText, 64, MF_BYCOMMAND);
	szText[9] = 0;
	nValue = ShowDlgSlider(	(int)(0.1 * 10.0), 
							(int)(5.0 * 10.0),
							1, 
							(INT)(m_setup.nGamma * 10.0), 
							0, 
							10, 
							1, 
							szText	);

	switch(nValue)
	{
	case failure:
		break;
	default:
		m_setup.nGamma = (DOUBLE)nValue / 10.0;
		break;
	}

	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	lpChildFrm->InvalidateRect(NULL);	// \XV
}

void CTestExApp::OnUpdateViewGamma(CCmdUI *pCmdUI)
{
	TCHAR szTxt[64];
	REAL  real;
	
	FloatToReal((DOUBLE)m_setup.nGamma, &real);
	wsprintf(szTxt, _T("K}l - %d.%d (&G)"), real.nWhole, real.nFraction);
	pCmdUI->SetText(szTxt);
	pCmdUI->Enable(m_BSE.AreYouReady() == CMBSE5E::yes);
}

void CTestExApp::OnViewHistogram()
{
	//
	//// mbeGetHistogram
	// 
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	if(lpChildFrm->GetImage() == NULL)	
		return;
	

	ShowWaitCursor(TRUE);

	CMBSE5E::HST_HISTOGRAM	data;
	CMBSE5E::DISPLAY_PROCESS dp;


	SecureZeroMemory(&data, sizeof(CMBSE5E::HST_HISTOGRAM));
	dp.lpParams = CreateDlgProgress(CDlgProgress::PROGRESS);	// _CAO
	dp.lpFunction = mbeDisplay;									// R[obN֐ݒ

	m_BSE.beGetHistogram(m_pMainWnd->m_hWnd, lpChildFrm->GetImage(), 128, &dp, &data); 

	DestroyDlgProgress(dp.lpParams);

	ShowWaitCursor(FALSE);

	CDlgHistogram *lpDialog = new CDlgHistogram(data.nData, data.nBitPerPixel);
	lpDialog->DoModal();
	lpDialog->DestroyWindow();
	delete lpDialog;
}

void CTestExApp::OnUpdateViewHistogram(CCmdUI *pCmdUI)
{
	// TODO : ɃR}hXV UI nh R[hǉ܂B
	pCmdUI->Enable(m_BSE.AreYouReady() == CMBSE5E::yes);
}

void CTestExApp::OnViewProperty()
{
	//
	//// FJEg
	//
	ShowWaitCursor(TRUE);
	
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	CMBSE5E::DISPLAY_PROCESS dp;
	TCHAR	szProperty[512];
	INT		nR;
	

	dp.lpParams = CreateDlgProgress(CDlgProgress::PROGRESS);	// _CAO
	dp.lpFunction = mbeDisplay;									// R[obN֐ݒ

	nR = m_BSE.beCountColor(m_pMainWnd->m_hWnd, lpChildFrm->GetImage(), &dp);

   	ShowWaitCursor(FALSE);

	DestroyDlgProgress(dp.lpParams);
	wsprintf(szProperty, _T("%d Colors"), nR);
	ShowMessageBox(CDlgYESNO::OK, szProperty);
}

void CTestExApp::OnUpdateViewProperty(CCmdUI *pCmdUI)
{
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	pCmdUI->Enable(m_BSE.AreYouReady() == CMBSE5E::yes && lpChildFrm->GetImage() != NULL);
}

void CTestExApp::OnViewCaps()
{
	//   m.magic E
	//// TWAIN @@\ꗗ\
	// 
	LPTSTR lpszTitle = _T("@\ꗗ\0");
	m_E.eShowDlgCaps(AfxGetMainWnd()->m_hWnd, lpszTitle);
}

void CTestExApp::OnUpdateViewCaps(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_E.AreYouReady() == CMGC4E::yes);
}

void CTestExApp::OnViewReflesh()
{
	InvalidateRect(GetWindow(m_pMainWnd->m_hWnd, GW_CHILD), NULL, TRUE); // \XV
}

void CTestExApp::OnViewMode()
{
	//
	//// IZ [hɐݒ@m.magicIZ.DLL Kv EXIF 񓙂\
	//
	ShowWaitCursor(TRUE);

	m_bIZMode ^= TRUE;
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);

	ShowWaitCursor(FALSE);
	lpChildFrm->InvalidateRect(NULL);	// \XV
}

void CTestExApp::OnUpdateViewMode(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bIZMode);
	pCmdUI->Enable(m_IZ.AreYouReady() == CMGC4IZ::yes);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
//// menu image
/////////////////////////////////////////////////////////////////////////////////////////////////////
void CTestExApp::OnImageFilter1()
{
	//
	//// 摜tB^(Ns)
	//
	CDlgImage::FUNCTION function;

	ShowDlgImage(CDlgImage::SHARP, &function);
	if(function.nFunctions != CDlgImage::NO_ADJUST)
		Filter(function.nFunctions, NULL);
}

void CTestExApp::OnImageFilter2()
{
	//
	//// 摜tB^(֊so)
	//
	// l̎擾
	Filter(CMBSE5E::fltSobelXY | CMBSE5E::fltReverse | CMBSE5E::fltGray, NULL);
}

void CTestExApp::OnImageFilter3()
{
	//
	//// 摜tB^(ڂ)
	//
	CDlgImage::FUNCTION function;
	ShowDlgImage(CDlgImage::SHADE, &function);
	if(function.nFunctions != CDlgImage::NO_ADJUST)
		Filter(function.nFunctions, NULL);
}

void CTestExApp::OnImageFilter4()
{
	//
	//// 摜tB^(Ǘ_)
	//
	// l̎擾
	Filter(CMBSE5E::fltMedianFilter, NULL);
}

void CTestExApp::OnImageCustomFilter1()
{
	//
	//// 摜tB^(JX^) [Vu[
	//
	// tB^[Zbg
	CMBSE5E::FLT_CUSTOM_DATA	fl5;
	

	INT nX[5][5] = { 0, 0, 1, 0, 0,	
					 0, 0, 1, 0, 0,
					 0, 0, 1, 0, 0, 
					 0, 0, 1, 0, 0,
					 0, 0, 1, 0, 0 }; // [Vu[
	fl5.nOffset = 0;	// F̃ItZbg
	fl5.nOrdinal = 5;	// 0͕s 
	fl5.bXY = FALSE;    

	/*INT nX[5][5] = { 0, 0, 0, 0, 0,	
					 0, 0, 1, 0, 0,
					 0, 1,-4, 1, 0, 
					 0, 0, 1, 0, 0,
					 0, 0, 0, 0, 0 }; // nLaplacian
	fl5.nOffset = 128;	// F̃ItZbg
	fl5.nOrdinal = 1;	// 0͕s 
	fl5.bXY = FALSE;            */

	CopyMemory(fl5.nFilter, nX, sizeof(nX));

	Filter(CMBSE5E::fltCustom | CMBSE5E::fltColor, &fl5);
}

void CTestExApp::OnImageCustomFilter2()
{
	//
	//// 摜tB^(JX^) W
	//
	// tB^[Zbg
	CMBSE5E::FLT_CUSTOM_DATA	fl5;
	

	INT nX[5][5] = { 0, 0, 0, 0, 0, 
					 0, 0, 0, 0, 0,
					 0, 0, 2, 0, 0, 
					 0, 0, 0, 0, 0,
					 0, 0, 0, 0, 0 }; // W
	fl5.nOffset = 128;
	fl5.nOrdinal = 1;
	fl5.bXY = FALSE;	
	
	CopyMemory(fl5.nFilter, nX, sizeof(nX));

	Filter(CMBSE5E::fltCustom | CMBSE5E::fltColor, &fl5);
}

void CTestExApp::OnImageCustomFilter3()
{
	//
	//// 摜tB^(JX^) VFCN
	//
	// tB^[Zbg
	CMBSE5E::FLT_CUSTOM_DATA	fl5;
	

	INT nX[5][5] = { 1, 0,-1, 0, 1, 
					 0, 0, 0, 0, 0,
					-1, 0, 1, 0,-1,
					 0, 0, 0, 0, 0,
					 1, 0,-1, 0, 1 }; // VFCN
	fl5.nOffset = 0;
	fl5.nOrdinal = 1;
	fl5.bXY = FALSE; 


	CopyMemory(fl5.nFilter, nX, sizeof(nX));
	
	Filter(CMBSE5E::fltCustom | CMBSE5E::fltColor, &fl5);
}

void CTestExApp::OnImageCustomFilter4()
{
	//
	//// 摜tB^(JX^) G{X
	//
	// tB^[Zbg
	CMBSE5E::FLT_CUSTOM_DATA	fl5;
	

	INT nX[5][5] = { 0, 0, 0, 0, 0, 
					 0, 0, 0, 0, 0,
					 1, 0, 0, 0,-1,
					 0, 0, 0, 0, 0,
					 0, 0, 0, 0, 0 }; // G{X
	fl5.nOffset = 100;
	fl5.nOrdinal = 1; 
	fl5.bXY = FALSE;

	CopyMemory(fl5.nFilter, nX, sizeof(nX));

	Filter(CMBSE5E::fltCustom, &fl5);
}

/*
void CTestExApp::OnImageCustomFilter5()
{
	//
	//// 摜tB^(JX^) ڂ
	//
	// tB^[Zbg
	CMBSE5E::FLT_CUSTOM_DATA	fl5;


	// l̎擾
	INT nI, nJ;
	TCHAR	szText[64];
	theApp.m_pMainWnd->GetMenu()->GetMenuString(ID_IMAGE_FILTER_C5, szText, 64, MF_BYCOMMAND);
	INT nValue = ShowDlgSlider(1, 3, 1, 1, 0, 0, 1, szText);
	if(nValue == MBE_SAV_CANCEL)
		return;

	INT nX[5][5] = { 0, 0,		0,		0,		0, 
					 0, 1,		nValue, 1,		0,
					 0, nValue, nValue, nValue, 0,
					 0, 1,		nValue, 1,		0,
					 0, 0,		0,		0,		0 }; // ڂ
	

	fl5.nOffset = 0;
	fl5.nOrdinal = 0;
	for(nI = 0; nI < 5; nI++) 
	{
		for(nJ = 0; nJ < 5; nJ++) 
		{
			fl5.nOrdinal += nX[nI][nJ];
		}
	}
	fl5.bXY = FALSE;

	
	CopyMemory(fl5.nFilter, nX, sizeof(nX));

	Filter(CMBSE5E::fltCustom, &fl5);
}

void CTestExApp::OnUpdateImageCustomFilter5(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_BSE.AreYouReady() == CMBSE5E::yes);
}*/

void CTestExApp::OnImageCustomFilter5()
{
	//
	//// 摜tB^(JX^) yCg
	//
	// tB^[Zbg
	CMBSE5E::FLT_CUSTOM_DATA	fl5;
	

	INT nX[5][5] = { 1, 0, 0, 0, 0, 
					 0, 0, 0, 0, 0,
					 0, 0, 0, 0, 0,
					 0, 0, 0, 0, 0,
					 0, 0, 0, 0, 1 }; // yCg
	fl5.nOffset = -64;
	fl5.nOrdinal = 1;
	fl5.bXY = FALSE;

	CopyMemory(fl5.nFilter, nX, sizeof(nX));

	Filter(CMBSE5E::fltCustom, &fl5);
}

/*
void CTestExApp::OnImageCustomFilter7()
{
	//
	//// 摜tB^(JX^) V[v
	//
	// tB^[Zbg
	CMBSE5E::FLT_CUSTOM_DATA	fl5;
	

	// l̎擾
	INT nI, nJ;
	TCHAR	szText[64];
	theApp.m_pMainWnd->GetMenu()->GetMenuString(ID_IMAGE_FILTER_C7, szText, 64, MF_BYCOMMAND);
	INT nValue = ShowDlgSlider(5, 15, 1, 5, 0, 0, 1, szText);
	if(nValue == MBE_SAV_CANCEL)
		return;

	INT nX[5][5] = { 0, 0, 0, 0, 0,	
					 0, 0,-1, 0, 0,
					 0,-1, nValue,-1, 0, 
					 0, 0,-1, 0, 0,
					 0, 0, 0, 0, 0 }; // V[v
	fl5.nOffset = 0;			// F̃ItZbg
	fl5.nOrdinal = 0;			// 0͕s 
	for(nI = 0; nI < 5; nI++) 
	{
		for(nJ = 0; nJ < 5; nJ++)
		{
			fl5.nOrdinal += nX[nI][nJ];	
		}
	}
	fl5.bXY = FALSE;    

	CopyMemory(fl5.nFilter, nX, sizeof(nX));

	Filter(CMBSE5E::fltCustom, &fl5);
}

void CTestExApp::OnUpdateImageCustomFilter7(CCmdUI *pCmdUI)
{
	// TODO : ɃR}hXV UI nh R[hǉ܂B
	pCmdUI->Enable(m_BSE.AreYouReady() == CMBSE5E::yes);
}*/

void CTestExApp::OnImageCustomFilter6()
{
	//
	//// 摜tB^(JX^) ώ
	//
	// tB^[Zbg
	CMBSE5E::FLT_CUSTOM_DATA	fl5;
	

	INT nX[5][5] = { 1, 1, 1, 1, 1,	
					 1, 1, 1, 1, 1,
					 1, 1, 1, 1, 1, 
					 1, 1, 1, 1, 1,
					 1, 1, 1, 1, 1 }; // ώ
	fl5.nOffset = 0;	// F̃ItZbg
	fl5.nOrdinal = 25;	// 0͕s 
	fl5.bXY = FALSE;    

	CopyMemory(fl5.nFilter, nX, sizeof(nX));

	Filter(CMBSE5E::fltCustom, &fl5);
}

void CTestExApp::OnUpdateImageFilter(CCmdUI *pCmdUI)
{
	// TODO : ɃR}hXV UI nh R[hǉ܂B
	pCmdUI->Enable(m_BSE.AreYouReady() == CMBSE5E::yes);
}

void CTestExApp::OnImageCopy()
{
	//
	//// Rs[
	// 
	CDlgCopy::COPY_VALUE	CopyValue;
	CDlgCopy* lpDlgCopy = new CDlgCopy;

	CopyValue.nFunctions = CDlgCopy::NO_ADJUST;

	if(lpDlgCopy->DoModal() == IDOK) 
	{
		lpDlgCopy->GetValue(&CopyValue); 
		if(CopyValue.nAdjust == CDlgCopy::ADJUST)
		{
			Copy(CopyValue.nFunctions, CopyValue.nDegrees, CopyValue.nMagnifications); 
		}
	}

	lpDlgCopy->DestroyWindow();
	delete lpDlgCopy;
}

void CTestExApp::OnUpdateImageCopy(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_BSE.AreYouReady() == CMBSE5E::yes);
}

void CTestExApp::OnImageContrast1()
{
	//
	//// RgXg𒲐܂
	//
	INT nR = AdjustContrast(CMBSE5E::adcAdjustAuto);

	if(nR != CMBSE5E::success)
		ShowErrorMessage(nR, _T("BSE"));
}

void CTestExApp::OnUpdateImageContrast1(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_BSE.AreYouReady() == CMBSE5E::yes);
}

void CTestExApp::OnImageContrast2()
{
	//// RgXg𒲐܂
	INT nR = AdjustContrast(CMBSE5E::adcAdjustSpot);

	if(nR != CMBSE5E::success)
		ShowErrorMessage(nR, _T("BSE"));
}

void CTestExApp::OnUpdateImageContrast2(CCmdUI *pCmdUI)
{
	if(m_BSE.AreYouReady() == CMBSE5E::yes) 
	{
		CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
		pCmdUI->Enable(		lpChildFrm->GetClippingZoneStatus() != CChildView::CPZ_REMOVED
						&&	lpChildFrm->IsZoneClipped());
	}
	else
	{
		pCmdUI->Enable(FALSE);
	}
}

void CTestExApp::OnImageContrast3()
{
	//// RgXg𒲐܂
	INT nR = AdjustContrast(CMBSE5E::adcAdjustManual);

	if(nR != CMBSE5E::success)
		ShowErrorMessage(nR, _T("BSE"));
}

void CTestExApp::OnUpdateImageContrast3(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_BSE.AreYouReady() == CMBSE5E::yes);
}

void CTestExApp::OnImageQuality()
{
	//
	//// 掿𒲐܂
	//
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	BOOL	bTwo = TRUE;
	CDlgImage::QUALITY_VALUE quality;
	INT		nR = CMBSE5E::failure;
	INT		nFunction;
	CMBSE5E::LPIMAGEBAG	lpImageBag;
	CMBSE5E::ADQ_ADJUSTMENT	adjustment;
	CMBSE5E::DISPLAY_PROCESS dp;


	ShowDlgImage(CDlgImage::QUALITY, &quality);
		
	if(!(quality.nIntensity == 0 && quality.nHue == 0 && quality.nSaturation == 0)) 
	{
		ShowWaitCursor(TRUE);

		// ̈
		lpImageBag = lpChildFrm->GetImage();
		GetClippingZone(lpImageBag, (LPRECT)&adjustment.nLeft, NULL);

		// l̎擾
		adjustment.nSaturation	= quality.nSaturation;
		adjustment.nIntensity	= quality.nIntensity;
		adjustment.nHeu			= quality.nHue;
		adjustment.dwColor			= quality.dwColor;
		adjustment.nColorDistance	= quality.nColorDistance;
		
		nFunction = (adjustment.nColorDistance == 0)? CMBSE5E::adqOptAll : CMBSE5E::adqOptFarDistance;

		dp.lpParams = CreateDlgProgress(CDlgProgress::PROGRESS);	// _CAO
		dp.lpFunction = mbeDisplay;									// R[obN֐ݒ
	
		nR = m_BSE.beAdjustQuality(m_pMainWnd->m_hWnd, nFunction, &adjustment, lpImageBag, &dp);

		if(nR == CMBSE5E::success)
			SetupViewInfo(lpImageBag, lpChildFrm->GetFileName(), TRUE, TRUE);

		ShowWaitCursor(FALSE);
		DestroyDlgProgress(dp.lpParams);

		if(nR != CMBSE5E::success)
			ShowErrorMessage(nR, _T("BSE"));
	}

	RestClippingZone(lpChildFrm);
}

void CTestExApp::OnUpdateImageQuality(CCmdUI *pCmdUI)
{
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	pCmdUI->Enable(m_BSE.AreYouReady() == CMBSE5E::yes && lpChildFrm->GetImage() != NULL);
}

void CTestExApp::OnImageDecolor(UINT nID)
{
	//
	//// Kϊ
	//
	INT	nBPP;
	INT	nMode;
	INT	nBase;
	INT	nOption;
	CDlgImage::BINALIZE_VALUE BinarizeValue;


	if(nID == ID_IMAGE_DECOLOR_1)
	{
		// l̎擾
		if(ShowDlgImage(CDlgImage::BINALIZE, &BinarizeValue) != CMBSE5E::success)
			return;

		if(BinarizeValue.nThreshold < 0)
			return;

		nBPP  = CMBSE5E::bpp1;
		nMode = CMBSE5E::decModeBinary;
		nBase = BinarizeValue.nBaseColor;
		nOption = BinarizeValue.nNoise | BinarizeValue.nThreshold;
	}
	else if(nID == ID_IMAGE_DECOLOR_24)
	{	
		nBPP = CMBSE5E::bpp24;
		nMode = CMBSE5E::decModeColor;
		nBase = CMBSE5E::decBaseRGB;
		nOption = CMBSE5E::decOpColor;
	}
	else if(nID == ID_IMAGE_DECOLOR_4A)
	{
		nBPP = CMBSE5E::bpp4;
		nMode = CMBSE5E::decModeMedianCut;
		nBase = CMBSE5E::decBaseRGB;
		nOption = CMBSE5E::decOpColor;
	}
	else if(nID == ID_IMAGE_DECOLOR_4B)
	{
		nBPP = CMBSE5E::bpp4;
		nMode = CMBSE5E::decModeLevel;
		nBase = CMBSE5E::decBaseRGB;
		nOption = CMBSE5E::decOp667;
	}
	else if(nID == ID_IMAGE_DECOLOR_4C)
	{
		nBPP = CMBSE5E::bpp4;
		nMode = CMBSE5E::decModeLevel;
		nBase = CMBSE5E::decBaseI;
		nOption = CMBSE5E::decOpGray;
	}
	else if(nID == ID_IMAGE_DECOLOR_8A)
	{
		nBPP = CMBSE5E::bpp8;
		nMode = CMBSE5E::decModeMedianCut;
		nBase = CMBSE5E::decBaseR;
		nOption = CMBSE5E::decOpColor;
	}
	else if(nID == ID_IMAGE_DECOLOR_8B)
	{
		nBPP = CMBSE5E::bpp8;
		nMode = CMBSE5E::decModeLevel;
		nBase = CMBSE5E::decBaseRGB;
		nOption = CMBSE5E::decOp667;
	}
	else if(nID == ID_IMAGE_DECOLOR_8C)
	{
		nBPP = CMBSE5E::bpp8;
		nMode = CMBSE5E::decModeLevel;
		nBase = CMBSE5E::decBaseI;
		nOption = CMBSE5E::decOpGray;
	}

	Decolor(nBPP, nMode, nBase, nOption);
}

void CTestExApp::OnUpdateImageDecolor(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_BSE.AreYouReady() == CMBSE5E::yes);
}

void CTestExApp::OnImageTone()
{
	//
	//// FZxϊ
	//
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	CMBSE5E::LPIMAGEBAG lpImageBag = lpChildFrm->GetImage();
	CMBSE5E::ADG_ADJUSTMENT2	adjustment;
	CDlgTone	*lpDlgTone;
	INT_PTR		nP;
	INT			nR;
	

	// ̈
	GetClippingZone(lpImageBag, (LPRECT)&adjustment.nLeft, NULL);
	
	lpDlgTone = new CDlgTone(	adjustment.szMappingData, 
								&adjustment.nBaseColor, 
								lpChildFrm->GetHistData()->nData );
	nP = lpDlgTone->DoModal();
	lpDlgTone->DestroyWindow();
	delete lpDlgTone;


	if(nP == IDOK) 
	{
		ShowWaitCursor(TRUE);
		CMBSE5E::DISPLAY_PROCESS dp;

		dp.lpParams = CreateDlgProgress(CDlgProgress::PROGRESS);	// _CAO
		dp.lpFunction = mbeDisplay;									// R[obN֐ݒ

		nR = m_BSE.beAdjustGamma2(	m_pMainWnd->m_hWnd,
									CMBSE5E::pushInReverseBuffer, 
									&adjustment, 
									lpChildFrm->GetImage(),
									&dp	);

		DestroyDlgProgress(dp.lpParams);

		if(nR != CMBSE5E::success)
		{
			ShowWaitCursor(FALSE);
			ShowErrorMessage(nR, _T("BSE"));
		}
		else 
		{
			SetupViewInfo(lpChildFrm->GetImage(), lpChildFrm->GetFileName(), TRUE, TRUE);
			ShowWaitCursor(FALSE);
		}
	}

	RestClippingZone(lpChildFrm);
}

void CTestExApp::OnUpdateImageTone(CCmdUI *pCmdUI)
{
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	pCmdUI->Enable(m_BSE.AreYouReady() == CMBSE5E::yes && lpChildFrm->GetImage() != NULL);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
//// pubN֐
/////////////////////////////////////////////////////////////////////////////////////////////////////
void CTestExApp::Load(BOOL bShowUI, BOOL bReverseBuffer, LPTSTR lpszFileName)
{
	//
	//// 摜t@Cǎ
	//
	LPVOID lpImage;
	
	if(m_BSE.AreYouReady() == CMBSE5E::yes)
	{
		lpImage = m_BSE.beLoadImage(bShowUI, m_nReverseBuffer, lpszFileName);
	}
	else 
	{
		lpImage = m_E.eLoad(m_pMainWnd, lpszFileName);
	}

	if(lpImage != NULL) 
	{	
		ShowWaitCursor(TRUE);

		INT nR = FileList(SET_FILENAME, lpszFileName);

		if(nR != FILE_FOUND && nR != m_nMaxCount)
		{
			MakeChildForm();
			SetupViewInfo((CMBSE5E::LPIMAGEBAG)lpImage, lpszFileName, FALSE, FALSE);
		}
		else 
		{
			if(m_BSE.AreYouReady() == CMBSE5E::yes)	
				m_BSE.beDestroyImage((CMBSE5E::LPIMAGEBAG)lpImage);
			else
				m_E.eDestroyImage();
		}

		ShowToolBar();

		ShowWaitCursor(FALSE);
	}
}

void CTestExApp::ShowToolBar()
{
	CMainFrame* lpFrame = (CMainFrame*)m_pMainWnd;
	lpFrame->ShowToolBar();
}

void CTestExApp::HideToolBar()
{
	if(FileList(GET_FILECOUNT, NULL) < 0) 
	{
		CMainFrame* lpFrame = (CMainFrame*)m_pMainWnd;
		lpFrame->HideToolBar();
	}
}

INT CTestExApp::ShowMessageBox(INT nMode, UINT nBeep, LPTSTR lpszMessage)
{
	INT_PTR   nR;
	CDlgYESNO DlgYESNO(nMode, nBeep, lpszMessage, m_pMainWnd);

	nR = DlgYESNO.DoModal();
	DlgYESNO.DestroyWindow();
	
	return (INT)nR;
}

INT CTestExApp::ShowMessageBox(INT nMode, LPTSTR lpszMessage)
{
	UINT nBeep = (nMode == CDlgYESNO::OK)? MB_ICONASTERISK : MB_ICONQUESTION;

	return ShowMessageBox(nMode, nBeep, lpszMessage);
}

INT CTestExApp::ShowMessageBox(INT nMode, INT nMessageNo)
{
	TCHAR szMsg[128];
	UINT  nBeep;
	
	GetMessage(nMessageNo, szMsg ,128);
	nBeep = (nMode == CDlgYESNO::OK)? MB_ICONASTERISK : MB_ICONQUESTION;

	return ShowMessageBox(nMode, nBeep, szMsg);
}

INT CTestExApp::ShowMessageBox(INT nMode, INT nMessageNo, LPTSTR lpszMessage)
{
	TCHAR szMsg[512];
	UINT  nBeep;
	
	GetMessage(nMessageNo, szMsg ,128);
	lstrcat(szMsg, lpszMessage);
	nBeep = (nMode == CDlgYESNO::OK)? MB_ICONASTERISK : MB_ICONQUESTION;

	return ShowMessageBox(nMode, nBeep, szMsg);
}

INT CTestExApp::ShowErrorMessage(INT nError, LPCTSTR lpszWho)
{
	TCHAR szMsgA[128];
	TCHAR szMsg[256];
	INT   nErrorMessage = 0;
	UINT  nBeep = MB_ICONEXCLAMATION;

	if(lstrcmpi(_T("TEX"), lpszWho) == 0)
	{
		switch(nError)
		{
		case ERR_TEX_SYSTEM:
			nErrorMessage = IDS_ERR_TEX_SYSTEM;
			nBeep = MB_ICONHAND;
			break;
		case ERR_TEX_LOAD_E:		
			nErrorMessage = IDS_ERR_TEX_LOAD_E;
			nBeep = MB_ICONHAND;
			break;
		case ERR_TEX_E:		
			nErrorMessage = IDS_ERR_TEX_E;
			break;
		case ERR_TEX_BSE:
			nErrorMessage = IDS_ERR_TEX_BSE;
			break;
		case ERR_TEX_AZ:	
			nErrorMessage = IDS_ERR_TEX_AZ;
			break;
		case ERR_TEX_IZ:
			nErrorMessage = IDS_ERR_TEX_IZ;
			break;
		case ERR_TEX_LZ:
			nErrorMessage = IDS_ERR_TEX_LZ;
			break;
		case ERR_TEX_FILE_MAX:
			nErrorMessage = IDS_ERR_TEX_FILE_MAX;
			break;
		case ERR_TEX_FILE_FOUND:
			nErrorMessage = IDS_ERR_TEX_FILE_FOUND;
			break;
		case ERR_TEX_DIRECTORY:
			nErrorMessage = IDS_ERR_TEX_DIRECTORY;
			break;
		default:
			nErrorMessage = IDS_ERR_TEX_FAILURE;
			break;
		}
	}
	else if(lstrcmpi(_T("IZ"), lpszWho) == 0)
	{
		switch(nError)
		{
		/*case CMGC4IZ::ERR_CANCEL:
			nErrorMessage = IDS_ERR_IZ_CANCEL;
			nBeep = MB_ICONASTERISK;
			break;*/
		case CMGC4IZ::errFile:
			nErrorMessage = IDS_ERR_IZ_FILE;
			break;
		case CMGC4IZ::errUnknownFile:
			nErrorMessage = IDS_ERR_IZ_UNKNOWN_FILE;
			break;
		case CMGC4IZ::errNonExif:
			nErrorMessage = IDS_ERR_IZ_NON_EXIF;
			break;
		case CMGC4IZ::errMemory:
			nErrorMessage = IDS_ERR_IZ_MEMORY;
			break;
		case CMGC4IZ::errResource:
			nErrorMessage = IDS_ERR_IZ_RESOURCE;
			break;
		case CMGC4IZ::errThumbnailImage:
			nErrorMessage = IDS_ERR_IZ_THUMBNAIL_IMAGE;
			break;
		default:
			nErrorMessage = IDS_ERR_TEX_IZ;
			break;
		}
	}
	else if(lstrcmpi(_T("BSE"), lpszWho) == 0)
	{
		switch(nError)
		{
		case CMBSE5E::errCannotDecolor:
			nErrorMessage = IDS_ERR_BSE_CANNOT_DECOLOR;
			break;
		case CMBSE5E::errFile:	
			nErrorMessage = IDS_ERR_BSE_FILE;
			break;
		case CMBSE5E::errMemory:
			nErrorMessage = IDS_ERR_BSE_MEMORY;
			break;
		case CMBSE5E::errRva:	
			nErrorMessage = IDS_ERR_BSE_RVA;
			break;
		case CMBSE5E::errIndexed:
			nErrorMessage = IDS_ERR_BSE_INDEXED;
			break;
		case CMBSE5E::canceled:
			nErrorMessage = IDS_ERR_BSE_CANCELED;
			break;
		default:
			nErrorMessage = IDS_ERR_TEX_BSE;
			break;
		}
	}

	GetMessage(nErrorMessage, szMsgA ,128);
	wsprintf(szMsg, _T("Error : %d\n%s"), nError, szMsgA);
	
	return ShowMessageBox(CDlgYESNO::OK, nBeep, szMsg);
}

INT CTestExApp::FileList(INT nCommand, LPCTSTR lpszFileName)
{
	//
	//// JĂt@CXgdǎh
	//
			INT		nI, nJ;
	static	INT		nStart = 0;
	static	INT		nCount = -1;
	static	TCHAR	szFileName[MAX_FILE_COUNT][MAX_PATH];


	if(nStart == 0) 
	{
		SecureZeroMemory(szFileName, sizeof(szFileName));
		nStart = 1;
	}

	
	if(nCommand == GET_FILECOUNT)
	{
		nI = (nCount < m_nMaxCount - 1)? nCount : m_nMaxCount;
	}
	else if(nCommand == SET_NEWFILE)
	{
		if(nCount < m_nMaxCount - 1) 
		{
			nCount++;
			nI = nCount;
		}
		else
		{
			nI = m_nMaxCount;
		}
	}
	else if(nCommand == DEL_FILENAME)
	{
		// 
		for(nI = 0; nI < m_nMaxCount; nI++)
		{
			if(lstrcmpi(lpszFileName, &szFileName[nI][0]) == 0)
				break;
		}

		// Xg
		if(nI != m_nMaxCount)
		{
			szFileName[nI][0] = 0;
		}

		nCount--;
	}
	else if(nCommand == SET_FILENAME)
	{
		// 
		for(nI = 0; nI < m_nMaxCount; nI++)
		{
			if(lstrcmpi(lpszFileName, &szFileName[nI][0]) == 0)
				break;
		}

		if(nCount < m_nMaxCount - 1)
		{
			if(nI == m_nMaxCount)
			{ // ȂΒǉ
				for(nJ = 0; nJ < m_nMaxCount; nJ++) 
				{
					if(szFileName[nJ][0] == 0)
					{
						lstrcpy(&szFileName[nJ][0], lpszFileName);
						nCount++;
						break;
					}
				}
				nI = nJ;
			}
			else 
			{
				nI = FILE_FOUND;
			}
		}
		else
		{
			nI = m_nMaxCount;
		}

		int nErr;

		if(nI == m_nMaxCount)
			nErr = ERR_TEX_FILE_MAX;
		else if(nI == FILE_FOUND)
			nErr = ERR_TEX_FILE_FOUND;
		else
			nErr = 0;

		if(nErr != 0)
			ShowErrorMessage(nErr, _T("TEX"));
	}

	return nI;
}

void CTestExApp::MakeChildForm()
{
	CMainFrame* pFrame = STATIC_DOWNCAST(CMainFrame, m_pMainWnd);
	// V MDI qEBhE쐬܂
	pFrame->CreateNewChild(RUNTIME_CLASS(CChildFrame), IDR_TestExTYPE, m_hMDIMenu, m_hMDIAccel);
}

void CTestExApp::Save(CChildFrame* lpChildFrame)
{
	TCHAR	szFileName[MAX_PATH];
	

	lstrcpy(szFileName, lpChildFrame->GetFileName());
	INT nLen = lstrlen(szFileName);

	if(nLen != 0)
	{
		TCHAR szWindowText[MAX_PATH];
		lpChildFrame->GetWindowText(szWindowText, MAX_PATH);
		
		if(ShowMessageBox(CDlgYESNO::YESNO, IDS_TEX_OVERWRITE, szWindowText) != IDOK)
			return;
	}
	else
	{
		OnFileSaveAs();
		return;
	}
		

	ShowWaitCursor(TRUE);

	if(m_BSE.AreYouReady() == CMBSE5E::yes)	// Booster E p
	{	
		INT	nR = CMBSE5E::failure;


		if(lstrlen(szFileName) != 0) 
		{
			CMBSE5E::JPEG_PROCESS	Jpeg;

			Jpeg.lpParams = theApp.m_pMainWnd;
			Jpeg.lpFunction = mbeJpeg;

			nR = m_BSE.beSaveImage(FALSE, lpChildFrame->GetImage(), szFileName, &Jpeg);
		}
		
		if(nR != CMBSE5E::success)
			ShowErrorMessage(nR, _T("BSE"));
		else 
			lpChildFrame->SetEdited(FALSE);
	}

	ShowWaitCursor(FALSE);
}

void CTestExApp::SaveAs(CChildFrame* lpChildFrame)
{
	TCHAR	szFileName[MAX_PATH] = { 0 };
	
	if(m_BSE.AreYouReady() == CMBSE5E::yes)	// Booster E p
	{	
		INT					nR;
		CMBSE5E::JPEG_PROCESS	Jpeg;

		Jpeg.lpParams = theApp.m_pMainWnd;
		Jpeg.lpFunction = mbeJpeg;
		
		nR = m_BSE.beSaveImage(TRUE, lpChildFrame->GetImage(), szFileName, &Jpeg);	

		if(nR == CMBSE5E::success) 
		{
			// ÂO̓Xg
			FileList(DEL_FILENAME, lpChildFrame->GetFileName());
			// VOXgɒǉ
			lpChildFrame->SetFileName(szFileName);
			FileList(SET_FILENAME, szFileName);
			lpChildFrame->SetEdited(FALSE);
		}
		else 
		{
			ShowErrorMessage(nR, _T("BSE"));
		}
	}
	else
	{
		m_E.eSetImage(lpChildFrame->GetImage());
		if(m_E.eSaveAs(m_pMainWnd, szFileName) == CM4e::success) 
		{
			lpChildFrame->SetFileName(szFileName);
			lpChildFrame->SetEdited(FALSE);
		}
	}
}

void CTestExApp::SetupViewInfo(CMBSE5E::LPIMAGEBAG lpImage, LPTSTR lpszFileName, BOOL bEdited, BOOL bMag)
{
	//
	///// Child Window ͂ꂼ̉摜ɑ΂ʏێĂ
	//
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	
	// qɓn
	CChildView::IMAGE_INFO	ViewInfo;
	SecureZeroMemory(&ViewInfo, sizeof(CChildView::IMAGE_INFO));

	// 摜|C^
	ViewInfo.lpImageBag = lpImage;

	// t@C
	if(lpszFileName != NULL)
		lstrcpy(ViewInfo.szFileName, lpszFileName);

	
	// t@C
	if(m_AZ.AreYouReady() == MAZ_YES) 
	{
		SYSTEMTIME  writetime, createtime;
		DWORD		dwFileAttributes = 0;	

		SecureZeroMemory(&writetime, sizeof(SYSTEMTIME));
		SecureZeroMemory(&createtime, sizeof(SYSTEMTIME));

		m_AZ.GetFileTime(	MAZ_FTM_CREATE_TIME | MAZ_FTM_WRITE_TIME, 
							CT2A(ViewInfo.szFileName), 
							&createtime, 
							NULL, 
							&writetime	);
		
		if(m_AZ.GetFileAttributes(CT2A(ViewInfo.szFileName), &dwFileAttributes) == MAZ_FAILURE)
			dwFileAttributes = 0;
	
		wsprintf(	ViewInfo.szWriteTime, 
					_T("%d:%02d:%02d %02d:%02d:%02d"), 
					writetime.wYear, 
					writetime.wMonth, 
					writetime.wDay, 
					writetime.wHour, 
					writetime.wMinute, 
					writetime.wSecond	);

		wsprintf(	ViewInfo.szCreateTime, 
					_T("%d:%02d:%02d %02d:%02d:%02d"), 
					createtime.wYear, 
					createtime.wMonth,
					createtime.wDay, 
					createtime.wHour, 
					createtime.wMinute, 
					createtime.wSecond	);

		if((dwFileAttributes & MAZ_ATR_READONLY) == MAZ_ATR_READONLY)
			lstrcpy(ViewInfo.szFileAttributes, _T("R"));
		else
			lstrcpy(ViewInfo.szFileAttributes, _T("_"));
		if((dwFileAttributes & MAZ_ATR_HIDDEN) == MAZ_ATR_HIDDEN)
			lstrcat(ViewInfo.szFileAttributes, _T("H"));
		else
			lstrcat(ViewInfo.szFileAttributes, _T("_"));
		if((dwFileAttributes & MAZ_ATR_ARCHIVE) == MAZ_ATR_ARCHIVE)
			lstrcat(ViewInfo.szFileAttributes, _T("A"));
		else
			lstrcat(ViewInfo.szFileAttributes, _T("_"));
		if((dwFileAttributes & MAZ_ATR_SYSTEM) == MAZ_ATR_SYSTEM)
			lstrcat(ViewInfo.szFileAttributes, _T("S"));
		else
			lstrcat(ViewInfo.szFileAttributes, _T("_"));
		if((dwFileAttributes & MAZ_ATR_COMPRESSED) == MAZ_ATR_COMPRESSED)
			lstrcat(ViewInfo.szFileAttributes, _T("C"));
		else
			lstrcat(ViewInfo.szFileAttributes, _T("_"));
		if((dwFileAttributes & MAZ_ATR_ENCRYPTED) == MAZ_ATR_ENCRYPTED)
			lstrcat(ViewInfo.szFileAttributes, _T("E"));
		else
			lstrcat(ViewInfo.szFileAttributes, _T("_"));
	}

	// 摜Zbg
	if(m_BSE.AreYouReady() == CMBSE5E::yes) 
	{
		m_BSE.beGetImageData(	lpImage, 
								&ViewInfo.nWidth, 
								&ViewInfo.nHeight, 
								&ViewInfo.nBPP	);
		// qXgO
		ViewInfo.lpHistData = lpChildFrm->GetHistData();

		TRY 
		{
			if(ViewInfo.lpHistData == NULL)		// VK
			{
				ViewInfo.lpHistData = new CMBSE5E::HST_HISTOGRAM;
			}

			SecureZeroMemory(ViewInfo.lpHistData, sizeof(CMBSE5E::HST_HISTOGRAM));
			m_BSE.beGetHistogram(	m_pMainWnd->m_hWnd,
									ViewInfo.lpImageBag,
									255,
									NULL,
									ViewInfo.lpHistData	);  
		}
		CATCH(CMemoryException, pEx) 
		{
			delete ViewInfo.lpHistData;
			ViewInfo.lpHistData = NULL;
		}
		END_CATCH
	}
	else
	{
		//m_E.SetImage(lpImage);
		m_E.eGetDIBSize(&ViewInfo.nHeight, &ViewInfo.nWidth);
		ViewInfo.nBPP = 0;
	}

	// Exif
	if(m_IZ.AreYouReady() == CMGC4IZ::yes) 
	{
		INT nR;
		nR = m_IZ.Begin(CMGC4IZ::read, CT2W(lpszFileName));
		
		if(nR > 0) 
		{									
			// Exif 擾
			INT				nI;
			CMGC4IZ::TEXT_SIZE	TextSize = { CMGC4IZ::lengthName, CMGC4IZ::lengthValue };


			ViewInfo.nExifCount = m_IZ.Begin(CMGC4IZ::beginRise, &TextSize);
		
			if(ViewInfo.nExifCount != 0)
			{
				ViewInfo.lpField = lpChildFrm->GetFieldText();

				if(ViewInfo.lpField == NULL)  // VK
				{
					TRY 
					{
						ViewInfo.lpField = new CMGC4IZ::FIELD_STRINGS[ViewInfo.nExifCount];
						for(nI = 0; nI < ViewInfo.nExifCount; nI++) 
						{
							ViewInfo.lpField[nI].lpszName = new CHAR[CMGC4IZ::lengthName];
							ViewInfo.lpField[nI].lpszValues = new CHAR[CMGC4IZ::lengthValue];
						}
					}
					CATCH(CMemoryException, pEx) 
					{
						for(nI = 0; nI < ViewInfo.nExifCount; nI++) 
						{
							delete ViewInfo.lpField[nI].lpszName;
							delete ViewInfo.lpField[nI].lpszValues;
						}
						delete ViewInfo.lpField;
						ViewInfo.nExifCount = 0;
					}
					END_CATCH
				}
				
				// Exif o
				INT nR;
				for(nI = 0; nI < ViewInfo.nExifCount; nI++)
				{
					nR = m_IZ.Begin(CMGC4IZ::cmdGetField, &ViewInfo.lpField[nI]);
					if(nR < CMGC4IZ::success)
						break;
				}
			}

		}
		
	}

	// ҏWꂽ
	ViewInfo.bEdited = bEdited;

	// {
	CChildView::LPIMAGE_INFO lpInfo;

	if(m_BSE.AreYouReady() == CMBSE5E::yes) 
	{
		if(bMag) 
		{
			lpInfo = lpChildFrm->GetImageInfo();
			ViewInfo.nMagnifications = lpInfo->nMagnifications;
			ViewInfo.nRealMagnifications = lpInfo->nRealMagnifications;
		}
		else 
		{
			// œKȂ̂T
			INT		nI;
			RECT	client;
			LONG	nW, nH;
			DOUBLE	nWm, nHm, nM;
			
			lpChildFrm->GetClientRect(&client);
			nW  = client.right - client.left - 20;
			nH  = client.bottom - client.top - 20;
			nWm = (DOUBLE)nW / (DOUBLE)ViewInfo.nWidth;
			nHm = (DOUBLE)nH / (DOUBLE)ViewInfo.nHeight;

			nM = (nHm > nWm)? nWm : nHm;

			for(nI = 1; nI < MAG_COUNT - 1; nI++)
			{
				if(nM >= m_nRealMagnifications[nI])
					break;
			}
			
			ViewInfo.nRealMagnifications = m_nRealMagnifications[nI];
			ViewInfo.nMagnifications = nI;
		}
	}
	else
	{
		ViewInfo.nRealMagnifications = 1.0;
		ViewInfo.nMagnifications = MAG_FULL;
	}
	// 摜|C^Zbg
	lpChildFrm->SetViewInfo(&ViewInfo);
	
	// XN[o[
	lpChildFrm->SetScrollBar();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
//// vCx[g֐
/////////////////////////////////////////////////////////////////////////////////////////////////////
INT	CTestExApp::AdjustContrast(INT nFunction)
{
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	if(lpChildFrm->GetImage() == NULL)	
		return CMBSE5E::failure;

	CMBSE5E::LPIMAGEBAG		lpImageBag = lpChildFrm->GetImage();
	CMBSE5E::ADC_ADJUSTMENT	Adjustment;

	
	// @
	GetClippingZone(lpImageBag, (LPRECT)&Adjustment.nLeft, NULL);

	if(nFunction == CMBSE5E::adcAdjustManual)
	{
		CDlgImage::CONTRAST_VALUE value;

		ShowDlgImage(CDlgImage::CONTRAST, &value);

        if(value.nLevel == 0)
		{
			RestClippingZone(lpChildFrm);
			return CMBSE5E::success;
		}

		Adjustment.nLevel	  = value.nLevel;
		Adjustment.nBaseColor = value.nBaseColor;
	}
	else 
	{
		Adjustment.nBaseColor = CMBSE5E::adcRGB;
	}


	ShowWaitCursor(TRUE);


	CMBSE5E::DISPLAY_PROCESS dp;

	dp.lpParams = CreateDlgProgress(CDlgProgress::PROGRESS);	// _CAO
	dp.lpFunction = mbeDisplay;									// R[obN֐ݒ

	INT nR = m_BSE.beAdjustContrast(	m_pMainWnd->m_hWnd, 
										nFunction, 
										&Adjustment, 
										lpImageBag, 
										&dp		);
	
	if(nR == CMBSE5E::success) 
	{
		SetupViewInfo(lpImageBag, lpChildFrm->GetFileName(), TRUE, TRUE);
	}

	DestroyDlgProgress(dp.lpParams);
	RestClippingZone(lpChildFrm);
	ShowWaitCursor(FALSE);

	return nR;
}

void CTestExApp::Copy(INT nFunction, INT nDegrees, DOUBLE nMagnifications)
{
	//
	//// 摜Rs[ mbeCopy
	//
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	if(lpChildFrm->GetImage() == NULL)	
	{
		ShowErrorMessage(failure, _T("TEX"));
		return;
	}
	if(FileList(GET_FILECOUNT, NULL) == m_nMaxCount)
	{
		ShowErrorMessage(ERR_TEX_FILE_MAX, _T("TEX"));
		return;
	}

	
	ShowWaitCursor(TRUE);


	CMBSE5E::LPIMAGEBAG lpImageBag = lpChildFrm->GetImage();
	INT nR = CMBSE5E::failure;

	// ϊdl (ȉ̂̂ݒ肷)
	CMBSE5E::CPY_PARAMS			params;
	CMBSE5E::DISPLAY_PROCESS	dp;
	CMBSE5E::LPIMAGEBAG			lpNewImageBag;


	SecureZeroMemory(&params, sizeof(params));

	// ̈
	GetClippingZone(lpImageBag, (LPRECT)&params.nSrcLeft, &params.nBitPerPixel);

	params.nDegrees = nDegrees;
	params.nMagX = params.nMagY = (FLOAT)nMagnifications;

	dp.lpParams = CreateDlgProgress(CDlgProgress::PROGRESS);	// _CAO
	dp.lpFunction = mbeDisplay;									// R[obN֐ݒ	

	lpNewImageBag = m_BSE.beCopy(	m_pMainWnd->m_hWnd, 
									nFunction,
									&params,
									m_nReverseBuffer,
									lpImageBag,
									&dp,
									&nR	);

	DestroyDlgProgress(dp.lpParams);

	if(nR == CMBSE5E::success)
	{
		MakeChildForm();
		FileList(SET_NEWFILE, NULL);
		SetupViewInfo(lpNewImageBag, NULL, TRUE, FALSE);
	}
	else
	{
		ShowErrorMessage(CMBSE5E::failure, _T("BSE"));
	}
	
	RestClippingZone(lpChildFrm);
	ShowWaitCursor(FALSE);
}

void CTestExApp::Decolor(INT nNewBPP, INT nMode, INT nBase, INT nOption)
{
	//
	//// Kϊ
	//
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	if(lpChildFrm->GetImage() == NULL)	
	{
		ShowErrorMessage(failure, _T("TEX"));
		return;
	}
	if(FileList(GET_FILECOUNT, NULL) == m_nMaxCount)
	{
		ShowErrorMessage(ERR_TEX_FILE_MAX, _T("TEX"));
		return;
	}

	INT nR;
	CMBSE5E::LPIMAGEBAG	lpNewImageBag;
	CMBSE5E::DISPLAY_PROCESS dp;


	lpNewImageBag = NULL;
	dp.lpParams = CreateDlgProgress(CDlgProgress::PROGRESS);	// _CAO
	dp.lpFunction = mbeDisplay;									// R[obN֐ݒ
	
	lpNewImageBag = m_BSE.beDecolor(	m_pMainWnd->m_hWnd, 
										nMode | nOption | nBase,
										nNewBPP,
										m_nReverseBuffer,
										lpChildFrm->GetImage(),
										&dp,
										&nR		);

	DestroyDlgProgress(dp.lpParams);

	if(nR == CMBSE5E::success)
	{
		MakeChildForm();
		FileList(SET_NEWFILE, NULL);
		SetupViewInfo(lpNewImageBag, NULL, TRUE, FALSE);
	}
	else
	{
		ShowErrorMessage(nR, _T("BSE"));
	}
}

void CTestExApp::Filter(INT nFunction, CMBSE5E::LPFLT_CUSTOM_DATA lpFilter)
{
	//
	//// 摜tB^
	//
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	if(lpChildFrm->GetImage() == NULL)	
		return;
	CMBSE5E::LPIMAGEBAG lpImageBag = lpChildFrm->GetImage();


	ShowWaitCursor(TRUE);

	CMBSE5E::FLT_ADJUSTMENT	Adjustment;
	CMBSE5E::DISPLAY_PROCESS dp;
	INT	nR;


	GetClippingZone(lpImageBag, (LPRECT)&Adjustment.nLeft, NULL);

	if(lpFilter != NULL)
		CopyMemory(&Adjustment.CustomData, lpFilter, sizeof(CMBSE5E::FLT_CUSTOM_DATA));
	
	dp.lpParams = CreateDlgProgress(CDlgProgress::PROGRESS);	// _CAO
	dp.lpFunction = mbeDisplay;									// R[obN֐ݒ

	nR = m_BSE.beFilter(	m_pMainWnd->m_hWnd,
							nFunction | m_nReverseBuffer,
							&Adjustment,
							lpImageBag,
							&dp	);
							
	if(nR != CMBSE5E::success)
		ShowErrorMessage(nR, _T("BSE"));
	else
        SetupViewInfo(lpImageBag, lpChildFrm->GetFileName(), TRUE, TRUE);

	DestroyDlgProgress(dp.lpParams);
	RestClippingZone(lpChildFrm);
	ShowWaitCursor(FALSE);
}

void CTestExApp::Rotate(INT nDegrees)
{
	//
	//// ]g
	//
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	if(lpChildFrm->GetImage() == NULL)	
		return;

	ShowWaitCursor(TRUE);

	INT		nR;
	CMBSE5E::LPIMAGEBAG	lpImageBag;
	CMBSE5E::DISPLAY_PROCESS dp;
	

	lpImageBag = lpChildFrm->GetImage();
	
	dp.lpParams = CreateDlgProgress(CDlgProgress::PROGRESS);	// _CAO
	dp.lpFunction = mbeDisplay;									// R[obN֐ݒ

	nR = m_BSE.beRotete(	m_pMainWnd->m_hWnd,
							lpImageBag,
							nDegrees, 
							CMBSE5E::pushInReverseBuffer,
							&dp	);

	if(nR != CMBSE5E::success)
		ShowErrorMessage(nR, _T("BSE"));
	else
		SetupViewInfo(lpImageBag, lpChildFrm->GetFileName(), TRUE, TRUE);

	DestroyDlgProgress(dp.lpParams);

	ShowWaitCursor(FALSE);
	
	lpChildFrm->InvalidateRect(NULL);	// \XV
}

INT CTestExApp::ShowDlgImage(INT nType, LPVOID lpValue)
{
	//
	//// TlC\
	//
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	CMBSE5E::LPIMAGEBAG	 lpImageBag = lpChildFrm->GetImage();

	if(lpImageBag == NULL)	
		return failure;

	CDlgImage::LPBINALIZE_VALUE lpBinarize = NULL;
	CDlgImage::LPFUNCTION		lpFunction = NULL;
	CDlgImage::LPCONTRAST_VALUE	lpContrastValue = NULL;
	CDlgImage::LPQUALITY_VALUE	lpQualityValue = NULL;

	switch(nType)
	{
	case CDlgImage::BINALIZE:
		lpBinarize = (CDlgImage::LPBINALIZE_VALUE)lpValue;
		lpBinarize->nBaseColor = 0;
		lpBinarize->nNoise = 0;
		lpBinarize->nThreshold = CDlgImage::NO_ADJUST;
		break;
	case CDlgImage::CONTRAST: 
		lpContrastValue = (CDlgImage::LPCONTRAST_VALUE)lpValue;
		lpContrastValue->nBaseColor = 0;
		lpContrastValue->nLevel = 0;
		break;
	case CDlgImage::QUALITY:
		lpQualityValue = (CDlgImage::LPQUALITY_VALUE)lpValue;
		lpQualityValue->nHue = 0;
		lpQualityValue->nIntensity = 0;
		lpQualityValue->nSaturation = 0;
		lpQualityValue->dwColor = 0;
		lpQualityValue->nColorDistance = 0;
		break;
	default:
		lpFunction = (CDlgImage::LPFUNCTION)lpValue;
		lpFunction->nFunctions = CDlgImage::NO_ADJUST;
	}

	
	INT				nR;
	INT				nFunction = CDlgImage::NO_ADJUST;
	CMBSE5E::CPY_PARAMS	params;
	CMBSE5E::LPIMAGEBAG	lpCopyImageBag;


	SecureZeroMemory(&params, sizeof(params));

	// ̈
	GetClippingZone(lpImageBag, (LPRECT)&params.nSrcLeft, &params.nBitPerPixel	);

	// k
	if(params.nSrcRight < CDlgImage::SIZE_X)
		params.nMagX = 1.00f;
	else
        params.nMagX = (FLOAT)CDlgImage::SIZE_X / (FLOAT)params.nSrcRight;

	if(params.nSrcBottom < CDlgImage::SIZE_Y)
		params.nMagY = 1.00f;
	else
		params.nMagY = (FLOAT)CDlgImage::SIZE_Y / (FLOAT)params.nSrcBottom;

	if(params.nMagX > params.nMagY)
		params.nMagX = params.nMagY;
	else
		params.nMagY = params.nMagX;


	// TCYύX̃TCY
	m_BSE.beGetSizeForCopy(&params, lpImageBag);
	// C[Wm
	lpCopyImageBag = m_BSE.beCreateImage(	CMBSE5E::noReverseBuffer, 
											params.nDestWidth,
											params.nDestHeight, 
											params.nBitPerPixel	);

	nR = failure;

	if(lpCopyImageBag != NULL) 
	{
		nR = m_BSE.beCopy(	m_pMainWnd->m_hWnd, 
							CMBSE5E::cpyCopy | CMBSE5E::doNotPushInReverseBuffer,
							&params, 
							lpImageBag, 
							lpCopyImageBag	);

		if(nR == CMBSE5E::success)
		{
			CDlgImage * lpdlgImage = new CDlgImage(	theApp.m_pMainWnd, 
													nType, 
													lpCopyImageBag, 
													params.nDestWidth,
													params.nDestHeight, 
													params.nBitPerPixel	);

			if(lpdlgImage->DoModal() == IDOK) 
			{
				switch(nType)
				{
				case CDlgImage::BINALIZE:
					lpBinarize->nBaseColor = lpdlgImage->GetBaseColor();
					lpBinarize->nNoise = lpdlgImage->GetNoise();
					lpBinarize->nThreshold = lpdlgImage->GetThrethold();
					break;
				case CDlgImage::QUALITY:
					lpQualityValue->nIntensity	= lpdlgImage->GetIntensity();
					lpQualityValue->nHue		= lpdlgImage->GetHue();
					lpQualityValue->nSaturation = lpdlgImage->GetSaturation();
					lpQualityValue->dwColor		= lpdlgImage->GetColor();
					lpQualityValue->nColorDistance = lpdlgImage->GetColorDistance();
					break;
				case CDlgImage::CONTRAST:
					lpContrastValue->nLevel = lpdlgImage->GetLevel(); 
					lpContrastValue->nBaseColor = lpdlgImage->GetBaseColor();
					break;
				default:
					lpFunction->nFunctions = lpdlgImage->GetFunctions(); 
				}
			}
							
			lpdlgImage->DestroyWindow();
			delete lpdlgImage;
			m_BSE.beDestroyImage(lpCopyImageBag);
		}
		else
		{
			ShowErrorMessage(nR, _T("BSE"));
		}
	}
	
	return nR;
}

INT CTestExApp::ShowDlgSlider(	INT		nMin, 
								INT		nMax, 
								INT		nStep, 
								INT		nPos,
								INT		nOffset,
								INT		nFloat,
								INT		nMag, 
								LPTSTR	lpLetter		)
{
	INT			nValue;
	CDlgSlider	slider(	NULL,
						CDlgSlider::OKCANCEL,
						nMin,
						nMax,
						nStep,
						nPos,
						nOffset,
						nFloat,
						nMag,
						lpLetter	);

	if(slider.DoModal() == IDOK)
		nValue = slider.GetValue();
	else
		nValue = failure;

	slider.DestroyWindow();
	
	return nValue;
}

LPVOID CTestExApp::CreateDlgProgress(INT nMode)
{
	CDlgProgress *lpDlgProgress;

	TRY 
	{
        lpDlgProgress = new CDlgProgress(nMode);
		lpDlgProgress->Create(IDD_PROGRESS, m_pMainWnd);
	}
	CATCH(CMemoryException, pEx)
	{
		lpDlgProgress = NULL;
	}
	END_CATCH;
	
	return lpDlgProgress;
}

void CTestExApp::DestroyDlgProgress(LPVOID lpDlgProgress)
{
	CDlgProgress *lpDP = (CDlgProgress*)lpDlgProgress;

	lpDP->DestroyWindow();
	delete lpDP;
}

void CTestExApp::GetMessage(INT nNo, LPTSTR lpMsg, INT nSize)
{
	if(!::LoadString(theApp.m_hInstance, (USHORT)nNo, lpMsg, nSize))
		wsprintf(lpMsg, _T("%d"), nNo);
}

void CTestExApp::GetClippingZone(CMBSE5E::LPIMAGEBAG lpImageBag, LPRECT lpClippingZone, LPINT lpBPP)
{
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	DOUBLE nRealMagnification;
	LPRECT lprctZone; 
	INT		nWidth;
	INT		nHeight;


	m_BSE.beGetImageData(lpImageBag, &nWidth, &nHeight, lpBPP);

	if(lpChildFrm->IsZoneClipped()) 
	{
		nRealMagnification = lpChildFrm->m_wndView.GetRealMagnification();
		lprctZone = lpChildFrm->GetClippedZone(); 

		lpClippingZone->left	= (LONG)((DOUBLE)lprctZone->left / nRealMagnification);
		lpClippingZone->top		= (LONG)((DOUBLE)lprctZone->top / nRealMagnification);
		lpClippingZone->right	= (LONG)((DOUBLE)lprctZone->right / nRealMagnification);
		lpClippingZone->bottom	= (LONG)((DOUBLE)lprctZone->bottom / nRealMagnification);
	}
	else 
	{
		lpClippingZone->left	= 0;
		lpClippingZone->top		= 0;
		lpClippingZone->right	= nWidth;
		lpClippingZone->bottom	= nHeight;
	}
}

void CTestExApp::RestClippingZone(CChildFrame *lpChildFrm)
{
	lpChildFrm->SetClippingZoneStatus(CChildView::CPZ_REMOVED);
	lpChildFrm->InvalidateRect(NULL);	// \XV
}

void CTestExApp::SetMagnification(INT nMag)
{
	CChildFrame* lpChildFrm = (CChildFrame*)m_pMainWnd->GetWindow(GW_CHILD)->GetWindow(GW_CHILD);
	if(lpChildFrm->GetImage() == NULL)	
		return;

	lpChildFrm->SetMagnification(GetRealMaginification(nMag), nMag);
	lpChildFrm->SetScrollBar();			// XN[o[
	lpChildFrm->InvalidateRect(NULL);	// \XV
}

void CTestExApp::ShowWaitCursor(BOOL bShow)
{
	DoWaitCursor((bShow)? 1 : -1);
}

BOOL CTestExApp::CheckClipborad()
{
	BOOL bR = FALSE;

	if(OpenClipboard(m_pMainWnd->m_hWnd))
	{
		if(GetClipboardData(CF_BITMAP) != NULL)
			bR = TRUE;
		CloseClipboard();
	}
	return bR;
}

void CTestExApp::SetReverseText(CChildFrame *lpChildFrm, CMBSE5E::LPIMAGEBAG lpImage, INT nErrNo)
{
	TCHAR szMessage[260], szE[256];
	GetMessage(nErrNo + IDS_BSE_RVA_FAILURE, szE, 256); 
	wsprintf(szMessage, _T("%d. %s"), lpImage->lpReverseBuffer->nRedo, szE);
	lpChildFrm->SetMsgUndo(szMessage);
}

void CTestExApp::ReadRegistory() 
{
	//
	//// WXgݒǂݏo
	//

	//
	//// 

	// K}l
	m_setup.nGamma  = 1.0;
	
	// C[WۑpX
	BOOL bR = FALSE;
	if(m_AZ.AreYouReady() == MAZ_YES) 
	{
		bR = m_AZ.GetSpecialFolderPath(CT2A(m_setup.szImagePath), MAZ_SFP_MYPICTURES);

		if(bR) 
		{
			if(lstrlen(m_setup.szImagePath) < 240)
				lstrcat(m_setup.szImagePath, _T("\\TestEx"));	
		}
	}

	if(!bR) 
	{
		GetCurrentDirectory(MAX_PATH, m_setup.szImagePath);

		if(lstrlen(m_setup.szImagePath) < 240)
			lstrcat(m_setup.szImagePath, _T("\\images"));	
	}


	//
	//// ǂݏo
	INT	nR0 = MAZ_FAILURE;
	INT nR1 = MAZ_FAILURE;

	if(m_AZ.AreYouReady() == MAZ_YES) 
	{
		// K}l
		DWORD dwSize = 8;

		nR0 = m_AZ.GetRegData(	MAZ_REG_READ,
								MAZ_REG_CURRENT_USER, 
								CT2A(m_lpszRegKey), 
								CT2A(m_lpszRegNameGamma), 
								MAZ_REG_BINARY, 
								(BYTE*)&m_setup.nGamma, 
								&dwSize		);
		// C[WۑpX
		nR1 = m_AZ.GetRegData(	MAZ_REG_READ_SIZE,
								MAZ_REG_CURRENT_USER, 
								CT2A(m_lpszRegKey), 
								CT2A(m_lpszRegNameTwainPath), 
								MAZ_REG_SZ, 
								(BYTE*)&m_setup.szImagePath, 
								&dwSize		);

		nR1 = m_AZ.GetRegData(	MAZ_REG_READ, 
								MAZ_REG_CURRENT_USER, 
								CT2A(m_lpszRegKey), 
								CT2A(m_lpszRegNameTwainPath), 
								MAZ_REG_SZ, 
								(BYTE*)&m_setup.szImagePath, 
								&dwSize		);
	}
}

void CTestExApp::WriteRegistory() 
{
	//
	//// WXgɐݒ菑
	//
	if(m_AZ.AreYouReady() == MAZ_YES)
	{
		DWORD dwSize = sizeof(m_setup.nGamma);

		m_AZ.SetRegData(	MAZ_REG_CURRENT_USER, 
							CT2A(m_lpszRegKey), 
							CT2A(m_lpszRegNameGamma), 
							MAZ_REG_BINARY, 
							(BYTE*)&m_setup.nGamma, 
							dwSize	);

		dwSize = sizeof(m_setup.szImagePath);

		m_AZ.SetRegData(	MAZ_REG_CURRENT_USER, 
							CT2A(m_lpszRegKey), 
							CT2A(m_lpszRegNameTwainPath), 
							MAZ_REG_SZ, 
							(BYTE*)&m_setup.szImagePath, 
							dwSize	);
	}
}
