#pragma once

#include "mgc4e.h"

// CM4e R}h ^[Qbg
// Ver4.1600a
class CM4e : public CObject
{
public:
	CM4e();
	virtual ~CM4e();

public:
	static const INT success = 0;
	static const INT failure = -1;

	VOID UnloadDll();
	INT  AreYouReady();

private:
	HMODULE m_hE;

protected:
	// ڑ
	typedef INT (CALLBACK* LPMECLOSESOURCE)(ULONG nFunction, HWND hWnd);
	typedef INT (CALLBACK* LPMECONNECTTWAINSESSION)(pTW_IDENTITY pAppID, LPCWSTR szSMDir);
	typedef INT (CALLBACK* LPMEDISCONNECTTWAINSESSION)(VOID);
	typedef INT (CALLBACK* LPMEOPENSOURCE)(ULONG nFunction, HWND hWnd);
	typedef INT (CALLBACK* LPMEREQUESTACQUISITION)(ULONG nFunction, HWND hWnd, LPVOID lpParams);
	typedef INT (CALLBACK* LPMEXFERS)(VOID);

	// 
	typedef TW_UINT16 (CALLBACK* LPMEGETTWAINSTATE)(VOID);

	// 擾
	typedef INT (CALLBACK* LPMEGETAPPID)(pTW_IDENTITY pAppID);
	
	// \[X
	typedef INT (CALLBACK* LPMEENUMERATESOURCE)(BOOL bReset);
	typedef INT (CALLBACK* LPMEGETDEFAULTSOURCE)(pTW_IDENTITY ptwSourceID);
	typedef INT (CALLBACK* LPMEGETSOURCEID)(pTW_IDENTITY pSourceID);
	typedef INT (CALLBACK* LPMESELECTSOURCE)(VOID);
	typedef VOID (CALLBACK* LPMESETSOURCEID)(pTW_IDENTITY ptwSourceID);

	// @\
	typedef INT (CALLBACK* LPMEGETCAPABILITY)(	TW_UINT16	twMsg, 
												TW_UINT16	twCap, 
												pTW_UINT16	ptwConType, 
												pTW_UINT16	ptwItemType, 
												LPVOID		lpCapsArray, 
												pTW_UINT32	ptwMaxSize, 
												BOOL		bErrMsg		);
	typedef INT (CALLBACK* LPMEGETDEFAULTIMAGELAYOUT)(pTW_IMAGELAYOUT ptwImageLayout);
	typedef INT (CALLBACK* LPMEGETIMAGELAYOUT)(pTW_IMAGELAYOUT ptwImageLayout);
	typedef INT (CALLBACK* LPMEGETRESOLUTION)(	TW_UINT16	twMsg, 
												FLOAT*		lpXresolution, 
												FLOAT*		lpYresolution	);
	typedef INT (CALLBACK* LPMESETCAPABILITY)(	TW_UINT16	twMsg, 
												TW_UINT16	twCap, 
												TW_UINT16	twConType, 
												TW_UINT16	twItemType, 
												LPVOID		lpCapsArray,
												TW_UINT32	twMaxSize,
												BOOL		bErrMsg		);
	typedef INT (CALLBACK* LPMESETIMAGELAYOUT)(pTW_IMAGELAYOUT ptwImageLayouhfdt);
	typedef INT (CALLBACK* LPMESETRESOLUTION)(TW_UINT16 twMsg, FLOAT nXresolution, FLOAT nYresolution);
	typedef INT (CALLBACK* LPMESHOWDLGCAPS)(LPCTSTR lpTitle, HWND hWnd, BOOL bErrMsg);
	typedef VOID (CALLBACK* LPMESETIMAGEINFO)(pTW_IMAGEINFO ptwImageInfo);

	// ǎ摜
	typedef VOID (CALLBACK* LPMESETIMAGE)(LPVOID lpBitmap);
	typedef INT (CALLBACK* LPMEGETIMAGEINFO)(pTW_IMAGEINFO pImageInfo);
	typedef INT (CALLBACK* LPMEDESTROYIMAGE)(VOID);
	typedef LPVOID (CALLBACK* LPMEGETIMAGE)(VOID);

	// ̑
	
	// Pʕϊ
	typedef FLOAT (CALLBACK* LPMEFIX32TOFLOAT)(pTW_FIX32 ptwFix32);
	typedef FLOAT (CALLBACK* LPMEINCHTOMM)(FLOAT nInch);
	typedef FLOAT (CALLBACK* LPMEMMTOINCH)(FLOAT nMM);
	typedef FLOAT (CALLBACK* LPMETWIPSTOINCH)(INT nTwips);
	typedef FLOAT (CALLBACK* LPMETWIPSTOMM)(INT nTwips);
	typedef INT (CALLBACK* LPMEINCHTOTWIOS)(FLOAT nInch);
	typedef INT (CALLBACK* LPMEMMTOTWIPS)(FLOAT nMM);
	typedef TW_FIX32 (CALLBACK* LPMEFLOATTOFIX32)(FLOAT nFloat);

	// 摜
	typedef INT (CALLBACK* LPMEGETCLIPBORDDIB) (HWND hWnd);
	typedef INT (CALLBACK* LPMEGETDIBSIZE)(LPINT lpHeight, LPINT lpWidth);
	typedef INT (CALLBACK* LPMELOADIMAGE)(LPCWSTR lpszFileName, LPVOID lpReserved); 
	typedef INT (CALLBACK* LPMEPAINTDIB)(HDC hDC, LPRECT lpDCRect, LPRECT lpDIBRect);
	typedef INT (CALLBACK* LPMESAVEIMAGE)(LPCWSTR lpszFileName, INT nMode); 
	typedef INT (CALLBACK* LPMESETCLIPBORDDIB)(HWND hWnd);

	// ̑
	typedef BOOL (CALLBACK* LPMECAPTUREBUTTON)(HWND hWnd);
	typedef INT (CALLBACK* LPMEGETFILEVERSION)(	LPCWSTR lpszFile, 
												DWORD*	lpMajor, 
												DWORD*	lpMinor, 
												DWORD*	lpRevision,
												DWORD*	lpBuild	);
protected:
	//
	//// TWAIN
	//

	// ڑ
	LPMECLOSESOURCE				CloseSource;
	LPMECONNECTTWAINSESSION		ConnectTwainSession;
	LPMEDISCONNECTTWAINSESSION	DisconnectTwainSession;
	LPMEOPENSOURCE				OpenSource;
	LPMEREQUESTACQUISITION		RequestAcquisition;
	LPMEXFERS					Xfers;

	// 
	LPMEGETTWAINSTATE			GetTwainState;

	// 擾
	LPMEGETAPPID				GetAppID;
		
	// \[X
	LPMEENUMERATESOURCE			EnumerateSource;
	LPMEGETDEFAULTSOURCE		GetDefaultSource;
	LPMEGETSOURCEID				GetSourceID;
	LPMESELECTSOURCE			SelectSource;
	LPMESETSOURCEID				SetSourceID;
	

	//
	//// @\
	//

	// Capability
	LPMEGETCAPABILITY			GetCapability;
	LPMEGETDEFAULTIMAGELAYOUT	GetDefaultImageLayout;
	LPMEGETIMAGELAYOUT			GetImageLayout;
	LPMEGETRESOLUTION			GetResolution;
	LPMESETCAPABILITY			SetCapability;
	LPMESETIMAGEINFO			SetImageInfo;
	LPMESETIMAGELAYOUT			SetImageLayout;
	LPMESETRESOLUTION			SetResolution;
	LPMESHOWDLGCAPS				ShowDlgCaps;


	//
	//// ǎ摜
	//
	LPMEDESTROYIMAGE			DestroyImage;
	LPMEGETIMAGE				GetImage;
	LPMEGETIMAGEINFO			GetImageInfo;
	LPMESETIMAGE				SetImage;

	
	//
	//// ̑
	//
	
	// Pʕϊ
	LPMEFIX32TOFLOAT			FIX32ToFloat;
	LPMEFLOATTOFIX32			FloatToFIX32;
	LPMEINCHTOMM				InchToMM;
	LPMEINCHTOTWIOS				InchToTwips;
	LPMEMMTOINCH				MMtoInch;
	LPMEMMTOTWIPS				MMToTwips;
	LPMETWIPSTOINCH				TwipsToInch;
	LPMETWIPSTOMM				TwipsToMM;

	// 摜
	LPMEGETCLIPBORDDIB			GetClipbordDIB;
	LPMEGETDIBSIZE				GetDIBSize;
	LPMELOADIMAGE				LoadImage; 
	LPMEPAINTDIB				PaintDIB;
	LPMESAVEIMAGE				SaveImage; 
	LPMESETCLIPBORDDIB			SetClipbordDIB;

	// ̑
	LPMECAPTUREBUTTON			CaptureButton;
	LPMEGETFILEVERSION			GetFileVersion;
};