#include "stdafx.h"
#include "m4lz.h"

// CM4lz
//
//  mgc4lz.dll [hNXł
//	Ver4.1600b
//
CM4lz::CM4lz()
{
	LoadDll();
}

CM4lz::~CM4lz()
{
	UnloadDll();
}

// CM4lz o֐
void CM4lz::LoadDll()
{
	LPCTSTR lpFileName = _T("mgc4lz.dll");

	m_hMLZ = LoadLibrary(lpFileName);

	if(m_hMLZ != NULL) 
	{
		mlzInitialize			= (LPMLZINITIALIZE)GetProcAddress(m_hMLZ, "mlzInitialize");
		mlzStart				= (LPMLZSTART)GetProcAddress(m_hMLZ, "mlzStart");
		mlzStop					= (LPMLZSTOP)GetProcAddress(m_hMLZ, "mlzStop");
		mlzGetResult			= (LPMLZGETRESULT)GetProcAddress(m_hMLZ, "mlzGetResult");
		mlzGetSamplingPosition	= (LPMLZGETSAMPLINGPOSITION)GetProcAddress(m_hMLZ, "mlzGetSamplingPosition");
		mlzDifferentiate		= (LPMLZDIFFERENTIATE)GetProcAddress(m_hMLZ, "mlzDifferentiate");
		mlzGetFileVersion		= (LPMLZGETFILEVERSION)GetProcAddress(m_hMLZ, "mlzGetFileVersion");

		DWORD dwMajor = 0;

		if(		GetFileVersion(lpFileName, &dwMajor, NULL, NULL, NULL) != CMGC4LZ::success
			||  dwMajor != 4	)
		{
			UnloadDll();
		}
	}
}

void CM4lz::UnloadDll()
{
	if(m_hMLZ != NULL) 
	{
		BOOL bR = FreeLibrary(m_hMLZ);

		m_hMLZ = NULL;
		mlzInitialize			= NULL;
		mlzStart				= NULL;
		mlzStop					= NULL;
		mlzGetResult			= NULL;
		mlzGetSamplingPosition	= NULL;
		mlzDifferentiate		= NULL;
		mlzGetFileVersion		= NULL;
	}
}

int CM4lz::AreYouReady()
{
	return (m_hMLZ != NULL)? yes : no;
}

int CM4lz::GetFileVersion(	LPCTSTR lpFileName,
							DWORD* lpdwMajor,
							DWORD* lpdwMinor,
							DWORD* lpdwRevision,
							DWORD* lpdwBild	)
{
	return mlzGetFileVersion(	lpFileName, 
								lpdwMajor,
								lpdwMinor,
								lpdwRevision,
								lpdwBild	);
}

