#pragma once

#include "mbster5e.h"

// CMb5e R}h ^[Qbg
// Ver 5.1600a
class CMb5e : public CObject
{
public:
	CMb5e();
	virtual ~CMb5e();

	void UnloadDll();
	int	 AreYouReady();

private:
	HMODULE m_hBooster;

protected:
	
	typedef INT (CALLBACK* LPMBEADJUSTCONTRAST)(HWND hWnd,
												ULONG nFunctions,
												CMBSE5E::LPADC_ADJUSTMENT lpAdjustment,
												CMBSE5E::LPIMAGEBAG lpImageBag,
												CMBSE5E::LPDISPLAY_PROCESS lpDisplay	);
	typedef INT (CALLBACK* LPMBEADJUSTGAMMA)(	HWND hWnd, 
												ULONG nFunctions,
												CMBSE5E::LPADG_ADJUSTMENT lpAdjustment,
												CMBSE5E::LPIMAGEBAG lpImageBag,
												CMBSE5E::LPDISPLAY_PROCESS lpDisplay	);
	typedef INT (CALLBACK* LPMBEADJUSTGAMMA2)(	HWND hWnd,
												ULONG nFunctions,
												CMBSE5E::LPADG_ADJUSTMENT2 lpAdjustment2,
												CMBSE5E::LPIMAGEBAG lpImageBag,
												CMBSE5E::LPDISPLAY_PROCESS lpDisplay	);
	typedef INT (CALLBACK* LPMBEADJUSTQUALITY)(	HWND hWnd,
												ULONG nFunctions,
												CMBSE5E::LPADQ_ADJUSTMENT lpAdjustment,
												CMBSE5E::LPIMAGEBAG lpImageBag,
												CMBSE5E::LPDISPLAY_PROCESS lpDisplay	);

	typedef INT (CALLBACK* LPMBECOPY)(	HWND hWnd,
										ULONG nFunctions,
										CMBSE5E::LPCPY_PARAMS lpParams,
										CMBSE5E::LPIMAGEBAG lpOriginal,
										CMBSE5E::LPIMAGEBAG lpCopy,
										CMBSE5E::LPDISPLAY_PROCESS lpDisplay	);
	typedef INT (CALLBACK* LPMBEDECOLOR)(	HWND hWnd,
												ULONG nFunctions,
												CMBSE5E::LPIMAGEBAG lpImageBag,
												CMBSE5E::LPIMAGEBAG lpNewImage,
												CMBSE5E::LPDISPLAY_PROCESS lpDisplay	);
	typedef INT (CALLBACK* LPMBEFILTER)(	HWND hWnd,
												ULONG nFunctions,
												CMBSE5E::LPFLT_ADJUSTMENT lpAdjustment,
												CMBSE5E::LPIMAGEBAG lpImageBag,
												CMBSE5E::LPDISPLAY_PROCESS lpDisplay	);
	typedef INT (CALLBACK* LPMBEROTATE)(	HWND hWnd,
											ULONG nFunctions,
											CMBSE5E::LPROT_PARAMS lpParams,
											CMBSE5E::LPIMAGEBAG lpImageBag,
											CMBSE5E::LPDISPLAY_PROCESS lpDisplay	);


	typedef CMBSE5E::LPIMAGEBAG (CALLBACK* LPMBEATTACHIMAGE)(ULONG nFunctions, LPVOID lpBitmap);
	typedef CMBSE5E::LPIMAGEBAG (CALLBACK* LPMBECREATEIMAGE)(	ULONG nFunctions,
																INT nWidth,
																INT nHeight,
																INT nBPP, 
																DWORD dwFlags	);
	typedef VOID (CALLBACK* LPMBEDESTROYIMAGE)(CMBSE5E::LPIMAGEBAG lpImageBag);
	typedef BOOL (CALLBACK* LPMBEDRAWIMAGE)(	HDC hDestDC,
												INT xDest,
												INT yDest,
												INT nDestWidth, 
												INT nDestHeight, 
												INT xSrc,
												INT ySrc,
												DWORD dwROP,
												CMBSE5E::LPIMAGEBAG lpSrcImage	); 
	typedef DWORD (CALLBACK* LPMBEGETCOLOR)(CMBSE5E::LPIMAGEBAG lpImageBag, INT nX, INT nY);
	typedef	CMBSE5E::LPIMAGEBAG (CALLBACK* LPMBELOADIMAGE)(ULONG nFunctions, LPCWSTR lpszFileName); 
	typedef INT (CALLBACK* LPMBESAVEIMAGE)(	ULONG nFunctions,
											CMBSE5E::LPIMAGEBAG lpImageBag,
											LPCWSTR lpszFileName,
											CMBSE5E::LPJPEG_PROCESS lpJpeg	);


	typedef INT (CALLBACK* LPMBECOUNTCOLOR)(	HWND hWnd,
												ULONG nFunctions,
												CMBSE5E::LPIMAGEBAG lpImageBag,
												CMBSE5E::LPDISPLAY_PROCESS lpDisplay	);
	typedef INT (CALLBACK* LPMBEGETHISTOGRAM)(	HWND hWnd, 
												CMBSE5E::LPIMAGEBAG lpImageBag,
												CMBSE5E::LPHST_HISTOGRAM lpHistData,
												CMBSE5E::LPDISPLAY_PROCESS lpParams	);
	typedef VOID (CALLBACK* LPMBEGETIMAGEDATA)(	CMBSE5E::LPIMAGEBAG lpImageBag,
												INT *lpWidth, 
												INT *lpHeight, 
												INT *lpBPP	);
	
	

	typedef INT (CALLBACK* LPMBEREVERSEACTION)(ULONG nFunctions, CMBSE5E::LPIMAGEBAG lpBuffer);


	typedef INT (CALLBACK* LPMBESETCLIPBOARDIMAGE)(HWND hWnd, CMBSE5E::LPIMAGEBAG lpImageBag);
	typedef CMBSE5E::LPIMAGEBAG (CALLBACK* LPMBEGETCLIPBOARDIMAGE)(ULONG nFunctions, HWND hWnd);


	typedef INT (CALLBACK* LPMBEGETFILEVERSION)(	LPCWSTR lpszFile,
													DWORD* lpMajor,
													DWORD* lpMinor,
													DWORD* lpRevision,
													DWORD* lpBuild	);
public:
	LPMBEADJUSTCONTRAST		AdjustContrast;
	LPMBEADJUSTGAMMA		AdjustGamma;
	LPMBEADJUSTGAMMA2		AdjustGamma2;
	LPMBEADJUSTQUALITY		AdjustQuality;
	LPMBECOPY				Copy;
	LPMBEDECOLOR			Decolor;
	LPMBEFILTER				Filter;
	LPMBEROTATE				Rotate;
	

	LPMBEATTACHIMAGE		AttachImage;
	LPMBECREATEIMAGE		CreateImage;
	LPMBEDESTROYIMAGE		DestroyImage;
	LPMBEDRAWIMAGE			DrawImage; 
	LPMBEGETCOLOR			GetColor;
	LPMBELOADIMAGE			LoadImage;
	LPMBESAVEIMAGE		    SaveImage;

	LPMBECOUNTCOLOR			CountColor;
	LPMBEGETHISTOGRAM		GetHistogram;
	LPMBEGETIMAGEDATA       GetImageData;
	
	
	LPMBEREVERSEACTION		ReverseAction;

	LPMBEGETCLIPBOARDIMAGE  GetClipboardImage;
	LPMBESETCLIPBOARDIMAGE  SetClipboardImage;
	
	LPMBEGETFILEVERSION		GetFileVersion;
};
